------------------------------------------
-- Houses RPG by BetaM -------------------
-- Special thanks to Blazing and Flacko --
------------------------------------------
if hrpg~=nil then
	print("255000000HRPG Error: Script already exists. Shutting down...")
	return 1
end
hrpg={}
hrpg.furniture={}
hrpg.furn={id={},size={},type={},player={},var={},img={},rot={},image={},images={},prices={},types={},sizes={},color={}}
hrpg.mob={id={},type={},spawns={},level={},experience={},spawnarea={},busy={},fightimage={},hp={},maxhp={},typ={},shadow={},types={},armor={},typevar={hp={},armor={},attack={},exp={},drops={},dropchances={},sound={},deathsound={},image={},money={}}}

function hrpg.loadsettings()
	local chk={}
	if loadfile("sys/lua/HRPG_settings/Settings.txt")==nil then
		print("255000000HRPG Error: Settings file not found. Please check the HRPG_settings folder in your sys/lua folder! (Settings.txt)")
		print("255255255HRPG: Loading demo version...")
		hrpg.maxdebt=10000
		hrpg.mindaylength=40
		hrpg.maxdaylength=120
		hrpg.night_transparency=0.5
		hrpg.housecoor={{37,26},{20,38},{20,52},{20,66},{20,80},{71,26},{87,26},{76,46},{76,60},{76,74},{76,88},{95,88},{114,88},{114,74},{114,60},{114,46},{95,46},{103,26},{119,26},{153,26},{170,38},{170,52},{170,66},{170,80},{154,139},{138,139},{122,139},{106,139},{84,139},{68,139},{52,139},{36,139}}
		hrpg.housesize={{7,6}  ,{6,6}  ,{6,6}  ,{6,6}  ,{6,6}  ,{7,6}  ,{7,6}  ,{6,6}  ,{6,6}  ,{6,6}  ,{6,6}  ,{7,6}  ,{6,6}   ,{6,6}   ,{6,6}   ,{6,6}   ,{7,6}  ,{7,6}   ,{7,6}   ,{7,6}   ,{6,6}   ,{6,6}   ,{6,6}   ,{6,6}   ,{7,7}    ,{7,7}    ,{7,7}    ,{7,7}    ,{7,7}   ,{7,7}   ,{7,7}   ,{7,7}}
		hrpg.housedoor={{37,32},{26,38},{26,52},{26,66},{26,80},{71,32},{87,32},{70,46},{70,60},{70,74},{70,88},{95,94},{120,88},{120,74},{120,60},{120,46},{95,40},{103,32},{119,32},{153,32},{164,38},{164,52},{164,66},{164,80},{154,132},{138,132},{122,132},{106,132},{84,132},{68,132},{52,132},{36,132}}
		hrpg.houserot ={180    ,90     ,90     ,90     ,90     ,180    ,180    ,-90    ,-90    ,-90    ,-90    ,180    ,90      ,90      ,90      ,90      ,0      ,180     ,180     ,180     ,-90     ,-90     ,-90     ,-90     ,0        ,0        ,0        ,0        ,0       ,0       ,0       ,0}
		hrpg.roof_transparency=0.1
		hrpg.wall_type=5
		hrpg.wall_delay=10000
		hrpg.maxlaps=2
		hrpg.spawnmobs=true
		hrpg.aggrodist=4
		hrpg.mobrange=1
		hrpg.mobspeed=1000
		hrpg.spawnsetting=1 
		hrpg.maxcombo=20
		hrpg.aggro=true
		hrpg.room_for_error=200
		hrpg.combo_accuracy=20 
		hrpg.save_data=false
		hrpg.house_menu_key=1
		hrpg.inventory_key=2
		hrpg.multi_key=3
		hrpg.save_noob_data=false
		hrpg.carimage="gfx/Houses RPG/car_beta1.png"
		hrpg.maxlevel=25
		hrpg.maxlevelitems={"Sofa"}
		hrpg.maxinv=30
		hrpg.hudids={1,2,3,4,5,6,7,8,9,10}
		hrpg.priority=2
		hrpg.allow_mapmaker_chat=true
		parse('mp_dmspawnmoney 0')
		parse('mp_startmoney 0')
		parse('mp_killbuildings 0')
		parse('mp_killbuildingmoney 1')
		parse('mp_turretdamage 0')
		parse('mp_building_limit Supply 999999')
		parse('mp_building_limit Dispenser 999999')
		parse('mp_building_limit Turret 2')
		parse('mp_building_limit "Gate Field" 999999')
		parse('mp_dispenser_money 0')
		parse('mp_dispenser_health 10')
		parse('mp_supply_items 75')
		parse('mp_antispeeder 0')
		parse('mp_infammo 0')
	else
		dofile("sys/lua/HRPG_settings/Settings.txt")
		table.insert(chk,hrpg.carimage)
		table.insert(chk,"gfx/weapons/portalgun_k.bmp")
	end
	local file=0
	local lines={}
	local t={}
	file=io.open('sys/lua/HRPG_settings/Furniture.txt','r')
	if file==nil then
		table.insert(hrpg.furniture,"Sofa")
		table.insert(hrpg.furniture,"Small Sofa")
		table.insert(hrpg.furn.prices,3000)
		table.insert(hrpg.furn.prices,1500)
		table.insert(hrpg.furn.sizes,{3,1})
		table.insert(hrpg.furn.sizes,{1,1})
		table.insert(hrpg.furn.types,2)
		table.insert(hrpg.furn.types,2)
		table.insert(hrpg.furn.images,"")
		table.insert(hrpg.furn.images,"")
		table.insert(hrpg.furn.image,"gfx/Houses RPG/Sofa.png")
		table.insert(hrpg.furn.image,"gfx/Houses RPG/Small Sofa.png")
		print("255000000HRPG Error: Furniture file not found. Please check the HRPG_settings folder in your sys/lua folder! (Furniture.txt)")
	else
		for line in io.lines('sys/lua/HRPG_settings/Furniture.txt','r') do
			if not line:find(":") then
				lines=totable(line)
				if #lines~=0 then
					t=hrpg.commakiller(lines[1])
					if #lines>1 then
						local t1={}
						for i=2,#lines do
							t1=hrpg.commakiller(lines[i])
							t[#t]=t[#t].." "..t1[1]..""
							if #t1>1 then
								for v=2,#t1 do
									table.insert(t,t1[v])
								end
							end
						end
					end
					table.insert(hrpg.furniture,t[1])
					table.insert(hrpg.furn.image,t[2])
					table.insert(chk,t[2])
					table.insert(hrpg.furn.prices,tonumber(t[3]))
					table.insert(hrpg.furn.sizes,{tonumber(t[4]),tonumber(t[5])})
					table.insert(hrpg.furn.types,tonumber(t[6]))
					if t[7]==nil then
						table.insert(hrpg.furn.images,"")
					else
						table.insert(hrpg.furn.images,t[7])
						table.insert(chk,t[7])
					end
				end
			end
		end
		file:close()
	end
	lines={}
	t={}
	file=0
	file=io.open('sys/lua/HRPG_settings/Weapons.txt','r')
	if file==nil then
		table.insert(hrpg.furniture,"M249")
		table.insert(hrpg.furniture,"Deagle")
		table.insert(hrpg.furn.prices,7500)
		table.insert(hrpg.furn.prices,500)
		table.insert(hrpg.furn.images,"")
		table.insert(hrpg.furn.images,"")
		table.insert(hrpg.furn.types,1)
		table.insert(hrpg.furn.types,1)
		table.insert(hrpg.furn.sizes,{1,1})
		table.insert(hrpg.furn.sizes,{1,1})
		table.insert(hrpg.furn.image,"")
		table.insert(hrpg.furn.image,"")
		print("255000000HRPG Error: Weapons file not found. Please check the HRPG_settings folder in your sys/lua folder! (Weapons.txt)")
	else
		for line in io.lines('sys/lua/HRPG_settings/Weapons.txt','r') do
			if not line:find(":") then
				lines=totable(line)
				if #lines~=0 then
					t=hrpg.commakiller(lines[1])
					if #lines>1 then
						local t1={}
						for i=2,#lines do
							t1=hrpg.commakiller(lines[i])
							t[#t]=t[#t].." "..t1[1]..""
							if #t1>1 then
								for v=2,#t1 do
									table.insert(t,t1[v])
								end
							end
						end
					end
					table.insert(hrpg.furniture,t[1])
					table.insert(hrpg.furn.image,"")
					table.insert(hrpg.furn.prices,tonumber(t[2]))
					table.insert(hrpg.furn.sizes,{1,1})
					table.insert(hrpg.furn.types,1)
					table.insert(hrpg.furn.images,"")
				end
			end
		end
		file:close()
	end
	lines={}
	d=1
	t={}
	file=0
	file=io.open('sys/lua/HRPG_settings/Battle.txt','r')
	if file==nil then
		table.insert(hrpg.furniture,"Band-aid")
		table.insert(hrpg.furniture,"Medkit")
		table.insert(hrpg.furn.prices,5000)
		table.insert(hrpg.furn.prices,10000)
		table.insert(hrpg.furn.images,"")
		table.insert(hrpg.furn.images,"")
		table.insert(hrpg.furn.types,8)
		table.insert(hrpg.furn.types,8)
		table.insert(hrpg.furn.sizes,{1,1})
		table.insert(hrpg.furn.sizes,{1,1})
		table.insert(hrpg.furn.image,"gfx/hud/power_bandage.png")
		table.insert(hrpg.furn.image,"gfx/hud/power_medikit.png")
		print("255000000HRPG Error: Battle file not found. Please check the HRPG_settings folder in your sys/lua folder! (Battle.txt)")
	else
		for line in io.lines('sys/lua/HRPG_settings/Battle.txt','r') do
			if not line:find(":") then
				lines=totable(line)
				if #lines~=0 then
					t=hrpg.commakiller(lines[1])
					if #lines>1 then
						local t1={}
						for i=2,#lines do
							t1=hrpg.commakiller(lines[i])
							t[#t]=t[#t].." "..t1[1]..""
							if #t1>1 then
								for v=2,#t1 do
									table.insert(t,t1[v])
								end
							end
						end
					end
					table.insert(hrpg.furniture,t[1])
					table.insert(hrpg.furn.image,t[2])
					table.insert(chk,t[2])
					table.insert(hrpg.furn.prices,tonumber(t[3]))
					table.insert(hrpg.furn.sizes,{1,1})
					table.insert(hrpg.furn.types,8)
					table.insert(hrpg.furn.images,"")
				end
			end
		end
		file:close()
	end
	lines={}
	d=1
	t={}
	file=0
	file=io.open('sys/lua/HRPG_settings/Mobs.txt','r')
	if file==nil then
		table.insert(hrpg.mob.types,"Zombie")
		table.insert(hrpg.mob.types,"Soldier")
		table.insert(hrpg.mob.typevar.hp,250)
		table.insert(hrpg.mob.typevar.hp,300)
		table.insert(hrpg.mob.typevar.armor,5)
		table.insert(hrpg.mob.typevar.armor,20)
		table.insert(hrpg.mob.typevar.attack,17)
		table.insert(hrpg.mob.typevar.attack,22)
		table.insert(hrpg.mob.typevar.exp,20)
		table.insert(hrpg.mob.typevar.exp,30)
		table.insert(hrpg.mob.typevar.drops,{"Gut Bomb"})
		table.insert(hrpg.mob.typevar.drops,{"MP5"})
		table.insert(hrpg.mob.typevar.dropchances,5)
		table.insert(hrpg.mob.typevar.dropchances,10)
		table.insert(hrpg.mob.typevar.money,200)
		table.insert(hrpg.mob.typevar.money,500)
		table.insert(hrpg.mob.typevar.sound,"player/zm_attack1.wav")
		table.insert(hrpg.mob.typevar.sound,"weapons/mp5.wav")
		table.insert(hrpg.mob.typevar.deathsound,"player/zm_die.wav")
		table.insert(hrpg.mob.typevar.deathsound,"player/die1.wav")
		table.insert(hrpg.mob.typevar.image,"gfx/Houses RPG/mob_Zombie.png")
		table.insert(hrpg.mob.typevar.image,"gfx/Houses RPG/mob_Soldier.png")
		print("255000000HRPG Error: Mobs file not found. Please check the HRPG_settings folder in your sys/lua folder! (Mobs.txt)")
	else
		for line in io.lines('sys/lua/HRPG_settings/Mobs.txt','r') do
			if not line:find(":") then
				lines=totable(line)
				if #lines~=0 then
					t=hrpg.commakiller(lines[1])
					if #lines>1 then
						local t1={}
						for i=2,#lines do
							t1=hrpg.commakiller(lines[i])
							t[#t]=t[#t].." "..t1[1]..""
							if #t1>1 then
								for v=2,#t1 do
									table.insert(t,t1[v])
								end
							end
						end
					end
					table.insert(hrpg.mob.types,t[1])
					table.insert(hrpg.mob.typevar.image,t[2])
					table.insert(chk,t[2])
					table.insert(hrpg.mob.typevar.hp,tonumber(t[3]))
					table.insert(hrpg.mob.typevar.armor,tonumber(t[4]))
					table.insert(hrpg.mob.typevar.attack,tonumber(t[5]))
					table.insert(hrpg.mob.typevar.exp,tonumber(t[6]))
					table.insert(hrpg.mob.typevar.money,tonumber(t[7]))
					table.insert(hrpg.mob.typevar.sound,t[8])
					table.insert(chk,"sfx/"..t[8])
					table.insert(hrpg.mob.typevar.deathsound,t[9])
					table.insert(chk,"sfx/"..t[9])
					if t[10]~=nil then
						table.insert(hrpg.mob.typevar.drops,{t[10]})
						table.insert(hrpg.mob.typevar.dropchances,{t[11]})
					else
						table.insert(hrpg.mob.typevar.drops,{})
						table.insert(hrpg.mob.typevar.dropchances,{})
					end
				end
			end
		end
		file:close()
	end
	lines={}
	d=1
	file=0
	t={}
	file=io.open('sys/lua/HRPG_settings/Furnishings.txt','r')
	if file==nil then
		table.insert(hrpg.furniture,"Paint Can")
		table.insert(hrpg.furniture,"Wooden Roof")
		table.insert(hrpg.furn.prices,5000)
		table.insert(hrpg.furn.prices,10000)
		table.insert(hrpg.furn.images,"")
		table.insert(hrpg.furn.images,"")
		table.insert(hrpg.furn.types,11)
		table.insert(hrpg.furn.types,11)
		table.insert(hrpg.furn.sizes,{1,1})
		table.insert(hrpg.furn.sizes,{1,1})
		table.insert(hrpg.furn.image,"gfx/Houses RPG/Paint Can.png")
		table.insert(hrpg.furn.image,"gfx/Houses RPG/roof_wooden_small.png")
		table.insert(hrpg.furn.images,"")
		table.insert(hrpg.furn.images,"gfx/Houses RPG/roof_wooden.png")
		print("255000000HRPG Error: Furnishings file not found. Please check the HRPG_settings folder in your sys/lua folder! (Furnishings.txt)")
	else
		for line in io.lines('sys/lua/HRPG_settings/Furnishings.txt','r') do
			if not line:find(":") then
				lines=totable(line)
				if #lines~=0 then
					t=hrpg.commakiller(lines[1])
					if #lines>1 then
						local t1={}
						for i=2,#lines do
							t1=hrpg.commakiller(lines[i])
							t[#t]=t[#t].." "..t1[1]..""
							if #t1>1 then
								for v=2,#t1 do
									table.insert(t,t1[v])
								end
							end
						end
					end
					table.insert(hrpg.furniture,t[1])
					table.insert(hrpg.furn.prices,tonumber(t[2]))
					table.insert(hrpg.furn.image,t[3])
					table.insert(chk,t[3])
					table.insert(hrpg.furn.sizes,{1,1})
					table.insert(hrpg.furn.types,11)
					if t[4]~=nil then
						table.insert(hrpg.furn.images,t[4])
						table.insert(chk,t[4])
					else
						table.insert(hrpg.furn.images,"")
					end
				end
			end
		end
		file:close()
	end
	lines={}
	d=1
	file=0
	t={}
	if #chk~=0 then
		file=io.open('sys/servertransfer.lst','a+')
		if file~=nil then
			for line in io.lines('sys/servertransfer.lst','a+') do
				lines=totable(line)
				if #lines~=0 then
					t=hrpg.commakiller(lines[1])
					if #lines>1 then
						local t1={}
						for i=2,#lines do
							t1=hrpg.commakiller(lines[i])
							t[#t]=t[#t].." "..t1[1]..""
							if #t1>1 then
								for v=2,#t1 do
									table.insert(t,t1[v])
								end
							end
						end
					end
					local d=1
					for c=1,#chk do
						if chk[d]==t[1] then
							table.remove(chk,d)
							d=d-1
						end
						d=d+1
					end
				end
			end
			if #chk~=0 then
				file:write('\n')
				for v=1,#chk do
					file:write(chk[v]..'\n')
				end
			end
			file:close()
		end
	end
end

function array(m)
	local array = {}
	for i = 1, m do
		array[i] = 0
	end
	return array
end
function array2(m,c,d)
	local array = {}
	for i = 1, m do
		array[i] = math.random(c,d)
	end
	return array
end
function array3(m,d)
	local array = {}
	for i = 1, m do
		array[i] = d
	end
	return array
end
function arrayc(m,d)
	local t={}
	for i=1,m do
		t[i]=d.." "..i..""
	end
	return t
end
function hudtxt2(player,id,color,text,x,y,align)
	if(color==COLOR_NORMAL or color==nil) then
		color=""
	end
	parse("hudtxt2 "..player.." "..id.." \""..color..text.."\" "..x.." "..y.." "..align)
end
function clearhudtxt2(player,id)
	parse("hudtxt2 "..player.." "..id.." \"\" 0 0 0")
end
function translate(id,word)
	local n=0
	for i=1,#hrpg.english do
		if hrpg.english[i]==word then
			n=i
		end
	end
	if n==0 then return word end
	if hrpg.language[id]=="English" then
		return word
	elseif hrpg.language[id]=="German" then
		return hrpg.german[n]
	elseif hrpg.language[id]=="Polish" then
		return hrpg.polish[n]
	elseif hrpg.language[id]=="Russian" then
		return word
	end
	return word
end
function totable(t,match)
	local cmd = {}
	if not match then match = "[^%s]+" end
	for word in string.gmatch(t, match) do
		table.insert(cmd, word)
	end 
	return cmd 
end
function hrpg.commakiller(s,f)
	local t={}
	local p=1
	local g=""
	if f~=nil then
		g=f
	else
		g=","
	end
	for i=1,string.len(s) do
		if string.sub(s,i,i)==g then
			table.insert(t,string.sub(s,p,i-1))
			p=i+1
		end
		if i==string.len(s) then
			table.insert(t,string.sub(s,p,i))
		end
	end
	return t
end
function build(id,b,x,y,t)
	parse('spawnobject '..b..' '..x..' '..y..' 0 0 '..t..' '..id)
end
function setpos(id,x,y)
	parse("setpos "..id.." "..x.." "..y)
end

hrpg.loadsettings()
math.randomseed(os.time())
cfight="None"
score1=0
score2=0
tim=0
time2=0
frk1=0
frk2=0
challenger=0
challenging=0
rules=""
wid=74
hrpg.sellstates={"idle","idle","idle","idle"}
hrpg.clrtb={0,50,100,125,150,175,200,225,255}
hrpg.bargains={0.6,0.8,0.9,0.7}
hrpg.superbargains={0.3,0.2,0.4,0.5}
hrpg.holidaybargains={0.5,0.6,0.7,0.3,0.4,0.2}
hrpg.english={"Houses RPG v24 by BetaM","Yes","No"  ,"Next"    ,"Back"  ,"Previous"  ,"HRPG Menu","Get a house"   ,"Toggle your house door","Explore"  ,"Teleport to your house"      ,"Rename your house","Car menu" ,"Quest menu","Wanna leave the race?"             ,"Wanna leave the arena?"         ,"Choose your quest","Houses - Page 1" ,"Houses - Page 2" ,"Houses - Page 3" ,"Houses - Page 4" ,"Houses - Page 5" ,"Client settings","Toggle version info"         ,"Toggle HUD"  ,"Rebuild house walls"  ,"Get rid of your house","Destroy house walls","Change client settings","Choose quest" ,"Abandon quest"      ,"You already have a house.","This house is being owned."            ,"You don't own a house :P"    ,"Okay, your house has now the name","Door toggled."           ,"Spawn car"      ,"Get into your car"  ,"Park your car"    ,"Quest completed!"          ,"Current fight"  ,"Your active quest","Done"       ,"Reward" ,"You already have a car!"  ,"Your car is already parked!"        ,"You don't have a car!","Pay off bank debt"     ,"Customize your house","Place furniture" ,"Remove furniture","Shop Menu - Page"    ,"Inventory - Page","Change your car's colour"     ,"How much?","Collect furniture"        ,"New to the map? Say !help to know more. Also remember that F2 opens the House Menu!"                            ,"Find your car"    ,"Your car is not parked!"         ,"Drop how much?"       ,"times","Win a race"          ,"Recover loot from enemies in the arena","Kill people in the arena"    ,"Turned which way?"        ,"Left" ,"Right" ,"Up"  ,"Down" ,"time","Current race"   ,"None","Buy an item in a shop"     ,"You owe now"                 ,"to the bank" ,"You owe too much to the bank" ,"happening at the same time"         ,"Hosted by"     ,"on","Slots"        ,"Status","None" ,"Slay a monster"     ,"Attack" ,"Defend"      ,"Run"      ,"Inventory","Level" ,"Experience points"   ,"You got a"    ,"You got an" ,"Check your Inventory (F3/serveraction 2)!"                     ,"Car colour change - Colour","Car colour change - Tone","HP","AP","Remove roof"   ,"Money"    ,"Light" ,"Balanced"     ,"Heavy","Full" ,"Red"     ,"Green"  ,"Blue"     ,"Yellow","Cyan","Violet"   ,"Custom","Painting Furniture - Colour","Painting Furniture - Tone","                  ","                   ","   ",""   ,"Too soon!"   ,"Too late!","COMBO","tried running... and succeeded!"                ,"tried running... and failed!"                      ,"is defending."          ,"HITS!"        ,"missed!"             ,"hit"    ,"for"          ,"damage!" ,"did mortal damage to"               ,"A wild"    ,"appeared!"         ,"You win!"   ,"You lost..."        ,"left something behind! It's an","left something behind! It's a" ,"Click to continue!"                           ,"You got"    ,"and","You lost"    ,"took out"        ,"It healed"        ,"It did nothing..."             ,"Select a menu" ,"Racing stuff"    ,"Leave the race"        ,"Manually start the race"    ,"This furniture is not yours!"     ,"from your item queue"        ,"Inventory overloaded!"   ,"was added to your item queue."               ,"Bank menu" ,"Borrow money","Deposit money"  ,"Account"   ,"Withdraw money"  ,"You don't have that much money!" ,"Thank you. Your bank account holds now"   ,"You don't have that much money on your bank account!","Money transfer"   ,"The transfer has been completed. Your bank account holds now"          ,"has transferred","to your bank account! It holds now"            ,"Furniture menu","This player is no longer on the server! Try again!"                ,"You can't transfer money to yourself!"       ,"It halved the armor of"        ,"Gain a level"              ,"Level up!"                       ,"It allowed him/her to run!","Racing"   ,"Host"     ,"Join"      ,"available" ,"Waiting"    ,"In Progress","There is no race available!"         ,"Waiting for players to join. Press F4 to leave."              ,"Lobby is full - starting the race automatically."    ,"Sorry, but this racing lobby is full!"          ,"Lobby count has changed. Please try again."                            ,"Racing lobbies - Page","Choose the track" ,"Random"  ,"Waiting for players to join. Press F4 to leave or to start the race"                ,"players needed","There is already a race on this track!"       ,"Hoster started the race manually."     ,"The race is already in progress!"    ,"Can't start the race - not enough players"               ,"needed"     ,"You can't join - the arena is full!"            ,"Weapon Type" ,"Fight Rules" ,"Your bank account is empty!"    ,"Quick loan"      ,"Quick place"      ,"Quick collect"    ,"There's nothing underneath you!","more players needed"   ,"Your car is south-east from here!"             ,"Your car is north-east from here!"           ,"Your car is south-west from here!"             ,"Your car is north-west from here!"           ,"Say the name you want for your house."   ,"Your furniture has been set! Interact with it by pressing E while standing on it!"}
hrpg.polish={ "Houses RPG v24 by BetaM","Tak","Nie" ,"Nastepne","Wroc"  ,"Poprzednie","Menu HRPG","Zajmij dom"    ,"Przelacz drzwi"        ,"Eksploruj","Przenies sie do twojego domu","Zmien nazwe domu" ,"Menu aut" ,"Menu zadan","Chcesz opuscic wyscig?"            ,"Chcesz opuscic arene?"          ,"Wybierz misje"    ,"Domy - Strona 1" ,"Domy - Strona 2" ,"Domy - Strona 3" ,"Domy - Strona 4" ,"Domy - Strona 5" ,"Opcje osobiste" ,"Przelacz informacje o wersji","Przelacz HUD","Przebuduj sciany domu","Oddaj dom"            ,"Zniszcz sciany domu","Zmien opcje osobiste"  ,"Wybierz misje","Wycofaj sie z misji","Masz juz dom."            ,"Ten dom jest w uzytku."                ,"Nie kupiles domu :P"         ,"OK, twoj dom sie teraz nazywa"    ,"Drzwi przelaczone."      ,"Stworz samochod","Wejdz do samochodu" ,"Zaparkuj samochod","Misja zakonczona sukcesem!","Aktualna walka" ,"Aktualna misja"   ,"Ukonczono"  ,"Nagroda","Juz masz samochod!"       ,"Twoj samochod jest juz zaparkowany!","Nie masz samochodu!"  ,"Splac dlug w banku"    ,"Pozmieniaj swoj dom" ,"Postaw mebel"    ,"Usun meble"      ,"Menu sklepu - Strona","Plecak - Strona" ,"Zmien kolor samochodu"        ,"Jak duzo?","Zbierz mebel (pod toba)"  ,"Pierwszy raz tutaj? Wpisz na czacie !help zeby sie dowiedziec wiecej. Zapamietaj tez, ze F2 otwiera menu domow!","Znajdz swoje auto","Twoje auto nie jest zaparkowane!","Ile wyrzucic?"        ,"razy" ,"Wygraj wyscig"       ,"Zdobac przedmioty z ludzi"             ,"Zabij ludzi na Arenie"       ,"W ktora strone odwrocony?","Lewo" ,"Prawo" ,"Gora","Dol"  ,"raz" ,"Aktywne wyscigi","Brak","Kup przedmtiot w sklepie"  ,"Jestes teraz winny/a bankowi",""            ,"Masz za wysoki dlug w banku"  ,"odbywajacych sie w tym samym czasie","Zalozony przez","na","Sloty"        ,"Status","Brak" ,"Zabij potwora"      ,"Atakuj" ,"Bron sie"    ,"Uciekaj"  ,"Plecak"   ,"Poziom","Punkty doswiadczenia","Dostales/as"  ,"Dostales/as","Sprawdz w swoim plecaku (F3/2-ga akcja serwera)!"              ,"Zmiana koloru auta - Kolor","Zmiana koloru auta - Ton","HP","AP","Usun dach"     ,"Pieniadze","Slaby" ,"Wyrownany"    ,"Mocny","Pelny","Czerwony","Zielony","Niebieski","Zolty" ,"Cyan","Fioletowy","Inny"  ,"Malowanie mebla - Kolor"    ,"Malowanie mebla - Ton"    ,"                  ","                  " ,""   ,""   ,"Za wczesnie!","Za pozno!","KOMBO","sprobowal(a) uciec... i powiodlo to sie mu/jej!","sprobowal(a) uciec... i nie udalo to sie mu/jej!"  ,"broni siebie."          ,"RAZY Z RZEDU!","nie trafil!"         ,"uderzyl","zadajac"      ,"obrazen!","zadal smiertelne obrazenia"         ,"Dziki"     ,"nagle sie pojawil!","Zwyciestwo!","Porazka..."         ,"zostawil cos po sobie! Byl to" ,"zostawil cos po sobie! Bylo to","Nacisnij lewy przycisk myszy, by kontynuowac!","Dostales"   ,"i"  ,"Straciles"   ,"wycignal/nela"   ,"Wyleczone zostalo","Nie mialo to zadnego efektu...","Wybierz menu"  ,"Wyscigowe sprawy","Opusc wyscig"          ,"Manualnie rozpocznij wyscig","Ten mebel nie jest twoj!"         ,"z twojej kolejki przedmiotow","Twoj plecak jest pelny!" ,"zostal dodany to twojej kolejki przedmoitow.","Menu banku","Wez pozyczke","Wplac pieniadze","Stan konta","Wyplac pieniadze","Nie masz tyle pieniedzy!"        ,"Dziekuje. Stan twojego konta wynosi teraz","Nie masz tyle pieniedzy na koncie!"                  ,"Przelew pieniedzy","Przelew zostal pomyslnie zakonczony. Stan twojego konta wynosi teraz"  ,"przelal"        ,"na twoje konto bankowe! Jego stan wynosi teraz","Menu mebli"    ,"Ten gracz nie jest juz na tym serwerze! Sprobuj ponownie!"         ,"Nie mozesz przelac sam sobie pieniedzy!"     ,"Zmniejszyl on o polowe pancerz","Zdobadz wyzszy poziom"     ,"Zdobyles/as wyzszy poziom!"      ,"Dzieki niej uciekles/as!"  ,"Wyscigi"  ,"Zaloz"    ,"Dolacz"    ,"dostepnych","Oczekiwanie","W trakcie"  ,"Nie ma dostepnych wyscigow!"         ,"Czekaj, az dolaczy sie wiecej graczy. Nacisnij F4, aby wyjsc.","Wszyscy gotowi - wyscig zostal rozpoczety."          ,"Niestety ten wyscig jest juz pelny!"            ,"Ilosc wyscigow ulegla zmianie. Prosze sprobowac jeszcze raz."          ,"Wyscigi - Strona"     ,"Wybierz tor"      ,"Losowy"  ,"Czekaj, az dolaczy sie wiecej graczy. Nacisnij F4 aby wyjsc lub by rozpoczac wyscig","graczy brakuje","Na tym torze juz jest wyscig!"                ,"Zalozyciel manualnie rozpoczal wyscig.","Ten wyscig juz trwa!"                ,"Nie mozna rozpoczac wyscigu - za malo graczy"            ,"potrzebnych","Nie mozesz wejsc - arena jest pelna!"           ,"Rodzaj broni","Zasady walki","Twoje konto bankowe jest puste!","Szybki kredyt"   ,"Szybkie stawianie","Szybkie zbieranie","Nic pod toba nie jest!"         ,"graczy jeszcze brakuje","Twoje auto jest na poludniowym-wschodzie stad!","Twoje auto jest na polnocnym-wschodzie stad!","Twoje auto jest na poludniowym-zachodzie stad!","Twoje auto jest na polnocnym-zachodzie stad!","Powiedz nowa nazwe twojego domu."        ,"Mebel zostal postawiony! Rob cos z nim naciskajac E, gdy stoisz na nim!"}
hrpg.german={ "Houses RPG v24 by BetaM","Ja" ,"Nein","Nchste" ,"Zurck","Vohrige"   ,"HRPG Men","Nehme ein Haus","ffne/Schliee die Tr","Wandere"  ,"Zu deinen Haus teleportieren","Haus Name ndern" ,"Auto Men","Quest Men","Wollen sie den Wettlauf verlassen?","Wollen sie die Arena verlassen?","Whle einen quest","Huser - Seite 1","Huser - Seite 2","Huser - Seite 3","Huser - Seite 4","Huser - Seite 5","Klient Optionen","Version Info An/Aus"         ,"HUD An/Aus"  ,"Baue Haus Wnde"      ,"Haus verkaufen"       ,"Zerstre Haus Wnde","Klient Optionen"       ,"Quest whlen" ,"Quest aufgeben"     ,"Du hast ein Haus."        ,"Jemand hat diesen Haus schon genommen.","Du hast kein Haus gekauft :P","Okay, dein haus heit jetzt"      ,"Tr geffnet/geschloen.","Auto schaffen"  ,"Ins Auto einsteigen","Auto parken"      ,"Quest vollendet!"          ,"Aktueller Kampf","Aktiver Quest"    ,"Fortschritt","Preis"  ,"Du hast bereits ein Auto!","Dein Auto ist bereits geparkt!"     ,"Du hast kein Auto!"   ,"Bankschulden auszahlen","Haus anpassen"       ,"Stelle ein Mbel","Mbel entfernen" ,"Laden Men - Seite"  ,"Vorrte - Seite" ,"ndere die Farbe deines Autos","Wieviel?" ,"Mbel nehmen (unter dich)","Neu zu der Karte? Sag !help um mehr zu erfahren. Ach ja, F2 ffnet das Haus Men!"                              ,"Finde dein Auto"  ,"Dein Auto ist nicht geparkt!"    ,"Wieviel runterwerfen?","mal"  ,"Gewinne ein Wettlauf","Finde Beute aus Leuten in der Arena"   ,"Bringe Leute in der Arena um","Nach wo gedreht?"         ,"Links","Rechts","Oben","Unten","mal" ,"Aktive Rennen"  ,"Kein","Kaufe etwas in einen Laden","Du hast jetzt"               ,"Bankschulden","Du hast zu groe Bankschulden","geschehen zur gleichen Zeit"        ,"Erstellt von"  ,"im","Spieler-Slots","Status","Keine","Lege ein Monster um","Angriff","Verteidigung","Weglaufen","Vorrte"  ,"Level" ,"Erfahrungspunkte"    ,"Du hast einen","Du hast ein","bekommen! Guck mal in deine Vorrte (F3/zweite Server Aktion)!","Autofarbe wechseln - Farbe","Autofarbe wechseln - Ton","LP","AP","Dach entfernen","Geld"     ,"Leicht","Ausgegliechen","Stark","Voll" ,"Rot"     ,"Grn"   ,"Blau"     ,"Gelb"  ,"Cyan","Violett"  ,"Andere","Mbel farben - Farbe"       ,"Mbel farben - Ton"       ,"               "   ,"                 "  ,""   ,"   ","Zu frh!"    ,"Zu spt!" ,"COMBO","versuchte zu fliehen... und es war ein Erfolg!" ,"versuchte zu fliehen... und es hat fehlgeschlagen!","verteidigt sich selbst.","MAL IN FOLGE!","hat nicht getroffen!","hat"    ,"getroffen fr","Schaden!","hat tdliche Schaden angerichtet zu","Ein wilder","hat erscheint!"    ,"Erfolg!"    ,"Du hast verloren...","hat etwas verloren! Es war ein","hat etwas verloren! Es war ein","Klicken sie, um fortzufahren!"                ,"Du bekommst","und","Du verlierst","herausnahmte ein","Es heilte"        ,"Es hat nichts getan..."        ,"Whle ein Men","Wettlauf Sachen" ,"Den Wettlauf verlassen","Starte den Wettlauf manuell","Dieses Mbelstck ist nicht dein!","aus deiner Sachenschlange"   ,"Deine Vorrte sind voll!","wurde hinzugefgt zu ihrer Sachenschlange."  ,"Bank Men" ,"Geld leihen" ,"Geld einzahlen" ,"Konto"     ,"Geld abheben"    ,"Du hast noch nicht so viel Geld!","Danke schn. Dein Konto betragt jetzt"    ,"Du hast noch nicht so viel Geld an deinem Konto!"    ,"Geld bertragung" ,"Die bertragung wurde erfolgreich ausgetragt. Dein Konto betragt jetzt","tragte"         ,"an dein Konto ber! Es betragt jetzt"          ,"Mbel Men"    ,"Dieser Spieler ist nicht mehr in diesen Spiel! Versuch es nochmal!","Du kannst nicht sich selbst Geld bertragen!","Es halbierte die Rstung von"  ,"Erreiche einen hher Level","Du hast jetzt einen hher Level!","Du bist davongelaufen!"    ,"Wettlufe","Erstellen","Teilnehmen","verfgbar" ,"Warten"     ,"Im Gange"   ,"Es gibt keine verfgbaren Wettlufe!","Warte auf mehr Spieler. Drcke F4 um zu verlassen."           ,"Alle Spieler sind hier - der Wettlauf startet jetzt.","Traurigerweise, dieser Wettlauf ist schon voll.","Die Nummer von Wettlaufen hat sich gendert. Versuchen sie es nochmal.","Wettlufe - Seite"    ,"Whle die Strecke","Zufllig","Warte auf mehr Spieler. Drcke F4 um zu verlassen oder um zu starten"               ,"Spieler fehlen","Da ist schon ein Wettlauf auf dieser Strecke!","Der Wettlauf wurde manuell gestartet." ,"Dieser Wettlauf ist schon gestartet!","Der Wettlauf wurde nicht gestartet - nicht genug Spieler","fehlen"     ,"Du kannst nicht reingehen - die Arena ist voll!","Waffentyp"   ,"Kampf Regeln","Dein Bankkonto ist lehr!"       ,"Schneller Kredit","Schnelles stellen","Schnelles sammeln","Da ist nichts unter dich!"      ,"Spieler fehlen noch"   ,"Dein Auto ist sd-stlich von hier!"           ,"Dein Auto ist nord-stlich von hier!"        ,"Dein Auto ist sd-westlich von hier!"          ,"Dein Auto ist nord-westlich von hier!"       ,"Sag den gewnschten Namen fr dein Haus.","Das Mbel wurde gestellt! Mach etwas mit es bei drcken E auf ihm!"}
qnames={"Win a race","Kill people in the arena","Buy an item in a shop","Slay a monster","Gain a level"}
rnames={"100$","200$","500$","1000$","2000$","5000$","1 point max health boost","1 point armor boost","10000$","2 point max health boost","2 point armor boost","16000$","3 point max health boost","3 point armor boost","4 point max health boost","4 point armor boost","5 point max health boost","5 point armor boost","10 point max health boost","10 point armor boost"}
hrpg.names=arrayc(32,"House")
hrpg.bldgx=array3(32,{})
hrpg.bldgy=array3(32,{})
myh=array(32)
hrpg.debt=array(32)
racer=array(32)
namch=array(32)
carimg=array(32)
parkimg=array(32)
hrpg.bankdeposit=array(32)
hrpg.quests=array(32)
hrpg.questtypes=array(32)
hrpg.questdets=array(32)
hrpg.quest=array3(32,"None")
hrpg.questtype=array(32)
hrpg.questdet=array(32)
hrpg.questch=array(32)
hrpg.questprog=array(32)
hrpg.questreward=array(32)
hrpg.questrews=array(32)
hrpg.maxhealth=array3(32,100)
hrpg.maxarmor=array(32)
hrpg.inventory=array3(32,{})
hrpg.item_queue=array3(32,{})
hrpg.page=array3(32,0)
hrpg.context=array3(32,0)
hrpg.language=array3(32,"English")
hrpg.hud1=array3(32,1)
hrpg.hud2=array3(32,1)
hrpg.colors=array3(32,{255,255,255})
hrpg.placeh=array3(32,0)
hrpg.russian=hrpg.english
hrpg.turkish=hrpg.english
hrpg.sellers={image("gfx/Houses RPG/shopkeeper.png",42*32+16,49*32+16,1),image("gfx/Houses RPG/shopkeeper.png",148*32+16,49*32+16,1),image("gfx/Houses RPG/shopkeeper.png",42*32+16,87*32+16,1),image("gfx/Houses RPG/shopkeeper.png",148*32+16,87*32+16,1)}
hrpg.sellershadows={image("gfx/Houses RPG/shadow.png",42*32+16,49*32+16,0),image("gfx/Houses RPG/shadow.png",148*32+16,49*32+16,0),image("gfx/Houses RPG/shadow.png",42*32+16,87*32+16,0),image("gfx/Houses RPG/shadow.png",148*32+16,87*32+16,0)}
imagepos(hrpg.sellers[1],42*32+16,49*32+16,-180)
imagepos(hrpg.sellers[2],148*32+16,49*32+16,-180)
imagepos(hrpg.sellers[3],42*32+16,87*32+16,-180)
imagepos(hrpg.sellers[4],148*32+16,87*32+16,-180)
tween_move(hrpg.sellers[1],5000,42*32+16,55*32+16)
tween_move(hrpg.sellershadows[1],5000,42*32+16,55*32+16)
tween_move(hrpg.sellers[2],5000,148*32+16,55*32+16)
tween_move(hrpg.sellershadows[2],5000,148*32+16,55*32+16)
tween_move(hrpg.sellers[3],5000,42*32+16,93*32+16)
tween_move(hrpg.sellershadows[3],5000,42*32+16,93*32+16)
tween_move(hrpg.sellers[4],5000,148*32+16,93*32+16)
tween_move(hrpg.sellershadows[4],5000,148*32+16,93*32+16)
for v=1,4 do
	imagescale(hrpg.sellershadows[v],1.2,1.2)
	imagealpha(hrpg.sellershadows[v],0.5)
	timer(5000,"hrpg.sellercycle",""..v..",up")
end
hrpg.hazard={}
hrpg.hazard.easy=0
hrpg.hazard.medium=0
hrpg.hazard.hard=0
hrpg.races={}
hrpg.tracks={"Speedy Speedway","Wet Stroll","Highway Circuit","Downhill Maze","Industrial Slalom"}
hrpg.tracksx={210*32+16,338*32+16,292*32+16,276*32+16,342*32+16}
hrpg.tracksy={43*32+16 ,62*32+16 ,29*32+16 ,122*32+16,148*32+16}
hrpg.shop={}
hrpg.shop.dealimgs={0,0,0,0,0,0,0,0}
hrpg.shop.prices=hrpg.furn.prices
hrpg.shop.stockings={}
hrpg.shop.offers={{},{},{},{}}
hrpg.shop.being=array3(32,0)
for g=1,#hrpg.furniture do
	if hrpg.furn.types[g]==1 then
		table.insert(hrpg.shop.offers[2],hrpg.furniture[g])
	elseif hrpg.furn.types[g]==8 or hrpg.furn.types[g]==9 then
		table.insert(hrpg.shop.offers[3],hrpg.furniture[g])
	elseif hrpg.furn.types[g]==11 then
		table.insert(hrpg.shop.offers[4],hrpg.furniture[g])
	elseif hrpg.furn.types[g]<10 then
		table.insert(hrpg.shop.offers[1],hrpg.furniture[g])
	end
end
for h=1,#hrpg.furn.types do
	if hrpg.furn.types[h]~=1 then
		table.insert(hrpg.shop.stockings,math.random(10,20))
	else
		table.insert(hrpg.shop.stockings,-1)
	end
end
hrpg.shop.demand=array3(#hrpg.furniture,0)
hrpg.cycle=0
hrpg.lengths={}
for p=1,10 do
	table.insert(hrpg.lengths,math.random(hrpg.mindaylength,hrpg.maxdaylength)*10000)
end
hrpg.time=0
hrpg.namechange=array3(32,0)
hrpg.lap=array3(32,0)
hrpg.check=array3(32,0)
hrpg.powerup={}
hrpg.powerup.image1=array3(32,0) 
hrpg.powerup.image2=array3(32,0) 
hrpg.powerup.types={65,77,45,64,69,52,51}
hrpg.powerup.item=array3(32,0)
hrpg.powerup.placement={ {{208,209,210,211,212,268,268,268,268,268,268,268,268,260,260,260,260,260,260,260,260},
						  {54,54,54,54,54,59,60,61,64,65,66,67,68,88,89,90,92,93,94,95,96}} 
					   , {{333,334,335,336,336,335,334,329,329,329,329,329,348,349,350,351,352,354,355,356,357},
						  {71,72,73,74,76,77,78,114,115,116,117,118,77,77,77,77,77,77,77,77,77}} 
					   , {{300,300,300,300,300,357,358,359,360,361,310,310,310,310,310,237,238,239,240,241},
						  {27,28,29,30,31,23,23,23,23,23,14,15,16,17,18,22,22,22,22,22}}
					   , {{274,275,276,277,278,274,275,276,277,278,266,266,266,286,286,286,259,260,261,291,292,293,276,239,239,239,239,239,239,239,240,240,240,240,240,240,240,313,313,313,313,313,313,313,314,314,314,314,314,314,314},
					      {124,124,124,124,124,125,125,125,125,125,155,156,157,155,156,157,171,171,171,171,171,171,169,183,184,185,186,187,188,189,183,184,185,186,187,188,189,183,184,185,186,187,188,189,183,184,185,186,187,188,189}},
						  {{347,347,347,347,347,348,348,348,348,348,349,349,349,349,349,350,350,350,350,350,349,349,349,349,349,350,350,350,350,350,349,349,349,349,349,350,350,350,350,350},
						   {146,147,148,149,150,146,147,148,149,150,162,163,164,165,166,162,163,164,165,166,178,179,180,181,182,178,179,180,181,182,186,187,188,189,190,186,187,188,189,190}}}
hrpg.level=array3(32,1)
hrpg.experience=array3(32,0)
hrpg.fight=array3(32,0)
hrpg.fightimg=array3(32,0)
hrpg.enemyimg=array3(32,0)
hrpg.fighting={turn=array3(32,0),comboticker=array3(32,0),action=array(32,0),hud=array(32,{}),damleft=array(32,0),combocounter=array(32,0),turnimg=array(32,0),music=array(32,0),musicticker=array(32,0),combohit=array3(32,false)}
hrpg.myhrot=array3(32,0)
hrpg.houseroof=array3(32,0)
hrpg.rooftype=array3(32,"Default")
hrpg.roof_visible=array3(32,true)
hrpg.roof_exists={}
hrpg.darkness=array3(32,0)
hrpg.delay=array3(32,false)
hrpg.music={
	files={{"Houses RPG/fightmusic_1_1.ogg","Houses RPG/fightmusic_1_2.ogg","Houses RPG/fightmusic_1_3.ogg","Houses RPG/fightmusic_1_4.ogg","Houses RPG/fightmusic_1_5.ogg","Houses RPG/fightmusic_1_6.ogg"},{"Houses RPG/fightmusic_2_1.ogg","Houses RPG/fightmusic_2_2.ogg","Houses RPG/fightmusic_2_3.ogg","Houses RPG/fightmusic_2_4.ogg","Houses RPG/fightmusic_2_5.ogg","Houses RPG/fightmusic_2_6.ogg","Houses RPG/fightmusic_2_7.ogg"},{"Houses RPG/fightmusic_3_1.ogg","Houses RPG/fightmusic_3_2.ogg","Houses RPG/fightmusic_3_3.ogg","Houses RPG/fightmusic_3_4.ogg","Houses RPG/fightmusic_3_5.ogg","Houses RPG/fightmusic_3_6.ogg","Houses RPG/fightmusic_3_7.ogg"},{"Houses RPG/fightmusic_4_1.ogg","Houses RPG/fightmusic_4_2.ogg","Houses RPG/fightmusic_4_3.ogg","Houses RPG/fightmusic_4_4.ogg","Houses RPG/fightmusic_4_5.ogg","Houses RPG/fightmusic_4_6.ogg"},{"Houses RPG/fightmusic_5_1.ogg","Houses RPG/fightmusic_5_2.ogg","Houses RPG/fightmusic_5_3.ogg","Houses RPG/fightmusic_5_4.ogg","Houses RPG/fightmusic_5_5.ogg","Houses RPG/fightmusic_5_6.ogg","Houses RPG/fightmusic_5_7.ogg"}},
	timing={{380},{450},{520,520,320,320,320},{400},{460}},
	length={{5000,5000,5000,5000,5000,7900},{5000,5000,5000,5000,5000,5000,2900},{5000,5000,5000,5000,5000,5000,6000},{5000,5000,5000,5000,5000,4200},{5000,5000,5000,5000,5000,5000,4040}}}--4400}}}
	
function hrpg.house(i,p)
	if tonumber(i)==nil then
		local o=hrpg.commakiller(i)
		i=tonumber(o[1])
		p=o[2]
	end
	if p=="owned" then
		for id=1,#player(0,"table") do
			if myh[player(0,"table")[id]]~=0 and myh[player(0,"table")[id]]==i then
				return player(0,"table")[id]
			end
		end
		return 0
	elseif p=="generate" then
		msg("175175175Lag warning - a house is being generated!")
		local id=hrpg.house(i,"owned")
		if hrpg.housesize[myh[id]][1]>0 and hrpg.housesize[myh[id]][2]>0 then
			for x=-hrpg.housesize[myh[id]][1],hrpg.housesize[myh[id]][1] do
				for y=-hrpg.housesize[myh[id]][2],hrpg.housesize[myh[id]][2] do
					for d=1,#object(0,"table") do
						if object(0,"table")[d]~=nil and object(object(0,"table")[d],"player")==id and object(object(0,"table")[d],"tilex")==hrpg.housecoor[myh[id]][1]+x and object(object(0,"table")[d],"tiley")==hrpg.housecoor[myh[id]][2]+y then
							parse('killobject '..object(0,"table")[d])
						end
					end
					if (math.abs(y)==hrpg.housesize[myh[id]][2] or math.abs(x)==hrpg.housesize[myh[id]][1]) then
						if (hrpg.housecoor[myh[id]][1]+x~=hrpg.housedoor[myh[id]][1] or hrpg.housecoor[myh[id]][2]+y~=hrpg.housedoor[myh[id]][2]) then
							build(id,hrpg.wall_type,hrpg.housecoor[myh[id]][1]+x,hrpg.housecoor[myh[id]][2]+y,player(id,"team"))
						end
					end
				end
			end
		end
	elseif p=="destroy" then
		local id=hrpg.house(i,"owned")
		local f=0
		if id==0 then
			f=i
		else
			f=myh[id]
		end
		local g=#object(0,"table")+1
		local c=0
		for d=1,#object(0,"table") do
			c=object(0,"table")[g-d]
			if c~=nil and object(c,"player")==id then
				for x=-hrpg.housesize[f][1],hrpg.housesize[f][1] do
					if object(c,"tilex")>=hrpg.housecoor[f][1]-x and object(c,"tilex")<=hrpg.housecoor[f][1]+x then
						for y=-hrpg.housesize[f][2],hrpg.housesize[f][2] do
							if object(c,"tiley")<=hrpg.housecoor[f][2]+y and object(c,"tiley")>=hrpg.housecoor[f][2]-y then
								parse('killobject '..c)
							end
						end
					end
				end
			end
		end
		if hrpg.houseroof[i]~=0 then
			freeimage(hrpg.houseroof[i])
		end
		for r=1,#hrpg.roof_exists do
			if hrpg.roof_exists[r]==i then
				table.remove(hrpg.roof_exists,r)
			end
		end
		hrpg.houseroof[i]=0
		hrpg.rooftype[i]="Default"
		if item(0,"table")~=nil and item(0,"table")~={} and #item(0,"table")~=0 then
			local m=0
			local v=#item(0,"table")
			for n=1,#item(0,"table") do
				m=item(0,"table")[v]
				if m~=nil and item(m,"x")~=nil and item(m,"x")>=hrpg.housecoor[i][1]-hrpg.housesize[i][1] and item(m,"x")<=hrpg.housecoor[i][1]+hrpg.housesize[i][1] and item(m,"y")<=hrpg.housecoor[i][2]+hrpg.housesize[i][2] and item(m,"y")>=hrpg.housecoor[i][2]-hrpg.housesize[i][2] then
					parse("removeitem "..m)
				end
				v=v-1
			end
		end
	elseif p=="destroywalls" then
		msg("175175175Lag warning - a house's walls are being modified!")
		local id=hrpg.house(i,"owned")
		for x=-hrpg.housesize[myh[id]][1],hrpg.housesize[myh[id]][1] do
			for y=-hrpg.housesize[myh[id]][2],hrpg.housesize[myh[id]][2] do
				for d=1,#object(0,"table") do
					if object(0,"table")[d]~=nil and object(object(0,"table")[d],"player")~=0 and object(object(0,"table")[d],"tilex")==hrpg.housecoor[myh[id]][1]+x and object(object(0,"table")[d],"tiley")==hrpg.housecoor[myh[id]][2]+y then
						if math.abs(y)==hrpg.housesize[myh[id]][2] or math.abs(x)==hrpg.housesize[myh[id]][1] then
							parse('killobject '..object(0,"table")[d])
						end
					end
				end
			end
		end
	elseif p=="generatewalls" then
		hrpg.house(i,"destroywalls")
		local id=hrpg.house(i,"owned")
		for x=-hrpg.housesize[myh[id]][1],hrpg.housesize[myh[id]][1] do
			for y=-hrpg.housesize[myh[id]][2],hrpg.housesize[myh[id]][2] do
				if (math.abs(y)==hrpg.housesize[myh[id]][2] or math.abs(x)==hrpg.housesize[myh[id]][1]) then
					if (hrpg.housecoor[myh[id]][1]+x~=hrpg.housedoor[myh[id]][1] or hrpg.housecoor[myh[id]][2]+y~=hrpg.housedoor[myh[id]][2]) then
						build(id,hrpg.wall_type,hrpg.housecoor[myh[id]][1]+x,hrpg.housecoor[myh[id]][2]+y,player(id,"team"))
					end
				end
			end
		end
	elseif p=="save" and hrpg.save_data then
		local id=hrpg.house(i,"owned")
		local file=0
		local iden={"",""}
		if player(id,"usgn")~=0 then
			iden={"USGN","usgn"}
		else
			if player(id,"name")=="Player" and not hrpg.save_noob_data then
				return 1
			end
			iden={"IP","ip"}
		end
		file=io.open('sys/lua/HRPG_saves/'..iden[1]..'_'..player(id,iden[2])..'.sav','w')
		file:write("House stuff:\n"..hrpg.houserot[myh[id]]..","..hrpg.housesize[myh[id]][1]..","..hrpg.housesize[myh[id]][2]..","..myh[id].."\nBuildings:\n")
		for o=1,#object(0,"table") do
			if object(object(0,"table")[o],"player")==id and object(object(0,"table")[o],"tilex")<=hrpg.housecoor[i][1]+hrpg.housesize[i][1] and object(object(0,"table")[o],"tilex")>=hrpg.housecoor[i][1]-hrpg.housesize[i][1] and object(object(0,"table")[o],"tiley")>=hrpg.housecoor[i][2]-hrpg.housesize[i][2] and object(object(0,"table")[o],"tiley")<=hrpg.housecoor[i][2]+hrpg.housesize[i][2] then
				file:write(object(object(0,"table")[o],"tilex")-hrpg.housecoor[i][1]..","..object(object(0,"table")[o],"tiley")-hrpg.housecoor[i][2]..","..object(object(0,"table")[o],"type").."\n")
			end
		end
		file:write("Furniture:\n")
		for f=1,#hrpg.furn.id do
			if object(hrpg.furn.id[f],"tilex")<=hrpg.housecoor[i][1]+hrpg.housesize[i][1] and object(hrpg.furn.id[f],"tilex")>=hrpg.housecoor[i][1]-hrpg.housesize[i][1] and object(hrpg.furn.id[f],"tiley")>=hrpg.housecoor[i][2]-hrpg.housesize[i][2] and object(hrpg.furn.id[f],"tiley")<=hrpg.housecoor[i][2]+hrpg.housesize[i][2] then
				file:write(object(hrpg.furn.id[f],"tilex")-hrpg.housecoor[i][1]..","..object(hrpg.furn.id[f],"tiley")-hrpg.housecoor[i][2]..","..hrpg.furn.rot[f]..","..hrpg.furn.color[f][1]..","..hrpg.furn.color[f][2]..","..hrpg.furn.color[f][3]..","..hrpg.furn.var[f].."\n")
			end
		end
		file:write("Dropped items:\n")
		for c=1,#item(0,"table") do
			if item(item(0,"table")[c],"x")<=hrpg.housecoor[myh[id]][1]+hrpg.housesize[myh[id]][1] and item(item(0,"table")[c],"x")>=hrpg.housecoor[myh[id]][1]-hrpg.housesize[myh[id]][1] and item(item(0,"table")[c],"y")<=hrpg.housecoor[myh[id]][2]+hrpg.housesize[myh[id]][2] and item(item(0,"table")[c],"y")>=hrpg.housecoor[myh[id]][2]-hrpg.housesize[myh[id]][2] then
				file:write(item(item(0,"table")[c],"x")..","..item(item(0,"table")[c],"y")..","..item(item(0,"table")[c],"type").."\n")
			end
		end
		file:write("Money:\n"..player(id,"money").."\nDebt:\n"..hrpg.debt[id].."\nLanguage:\n"..hrpg.language[id].."\nCar Color:\n"..hrpg.colors[id][1]..","..hrpg.colors[id][2]..","..hrpg.colors[id][3].."\n")
		file:write("Inventory:\n")
		for b=1,#hrpg.inventory[id] do
			file:write(hrpg.inventory[id][b].."\n")
		end
		file:write("Last known name:\n"..player(id,"name").."\nLast logout date and time:\n"..os.date().."\nLevel:\n"..hrpg.level[id].."\nExperience:\n"..hrpg.experience[id].."\n")
		if hrpg.names[i]~="House "..i.."" then
			file:write("House name:\n"..hrpg.names[i].."\n")
		else
			file:write("House name:\nDefault\n")
		end
		file:write("Roof type:\n"..hrpg.rooftype[i].."\nMax health:\n"..hrpg.maxhealth[id].."\nArmor:\n"..hrpg.maxarmor[id].."\nBank account:\n"..hrpg.bankdeposit[id].."")
		file:close()
	elseif p=="load" then
		local id=hrpg.house(i,"owned")
		local file=0
		local iden={"",""}
		if player(id,"usgn")~=0 then
			iden={"USGN","usgn"}
		else
			iden={"IP","ip"}
		end
		local t={}
		local m=-1
		local lines={}
		local rotdif=0
		local sizex=0
		local sizey=0
		local res=0
		local temp=0
		file=io.open('sys/lua/HRPG_saves/'..iden[1]..'_'..player(id,iden[2])..'.sav','r') 
		if file~=nil then
			for line in io.lines('sys/lua/HRPG_saves/'..iden[1]..'_'..player(id,iden[2])..'.sav','r') do
				if line:find(":") then
					m=m+1
				else
					lines=totable(line)
					t=hrpg.commakiller(lines[1])
					if m==0 then
						hrpg.myhrot[id]=tonumber(t[1])
						sizex=math.abs(tonumber(t[2]))
						sizey=math.abs(tonumber(t[3]))
						res=math.abs(tonumber(t[4]))
						myh[id]=0
						if hrpg.house(res,"owned")==0 and hrpg.housesize[res][1]==sizex and hrpg.housesize[res][2]==sizey and hrpg.houserot[res]==hrpg.myhrot[id] then
							myh[id]=res
						end
						if myh[id]==0 then
							for v=1,32 do
								if hrpg.house(v,"owned")==0 and hrpg.housesize[v][1]==sizex and hrpg.housesize[v][2]==sizey and hrpg.houserot[v]==hrpg.myhrot[id] then
									myh[id]=v
									break
								end
							end
						end
						if myh[id]==0 then
							for v=1,32 do
								if hrpg.house(v,"owned")==0 and hrpg.housesize[v][1]==sizex and hrpg.housesize[v][2]==sizey then
									rotdif=hrpg.houserot[v]-hrpg.myhrot[id]
									myh[id]=v
									break
								end
							end
						end
						if myh[id]==0 then
							for v=1,32 do
								if hrpg.house(v,"owned")==0 then
									rotdif=hrpg.houserot[v]-hrpg.myhrot[id]
									myh[id]=v
									break
								end
							end
						end
						i=myh[id]
						hrpg.house(i,"destroy")
					elseif m==1 then
						if rotdif~=0 then
							if math.abs(rotdif)==180 then
								t[1]=-t[1]
								t[2]=-t[2]
								if hrpg.housecoor[i][1]+t[1]==hrpg.housedoor[i][1] and hrpg.housecoor[i][2]+t[2]==hrpg.housedoor[i][2] then
								else
									build(id,t[3],hrpg.housecoor[i][1]+t[1],hrpg.housecoor[i][2]+t[2],player(id,"team"))
								end
							else
								if rotdif==90 then
									if hrpg.housecoor[i][1]+t[1]<hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]<hrpg.housecoor[i][2] then
										t[1]=-t[1]
									elseif hrpg.housecoor[i][1]+t[1]>hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]<hrpg.housecoor[i][2] then
										t[2]=-t[2]
									elseif hrpg.housecoor[i][1]+t[1]>hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]>hrpg.housecoor[i][2] then
										t[1]=-t[1]
									elseif hrpg.housecoor[i][1]+t[1]<hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]>hrpg.housecoor[i][2] then 
										t[2]=-t[2]
									elseif hrpg.housecoor[i][1]+t[1]==hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]~=hrpg.housecoor[i][2] then
										t[1]=-t[2]
										t[2]=0
									elseif hrpg.housecoor[i][1]+t[1]~=hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]==hrpg.housecoor[i][2] then
										t[2]=t[1]
										t[1]=0
									end
								else
									if hrpg.housecoor[i][1]+t[1]<hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]<hrpg.housecoor[i][2] then
										t[2]=-t[2]
									elseif hrpg.housecoor[i][1]+t[1]>hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]<hrpg.housecoor[i][2] then
										t[1]=-t[1]
									elseif hrpg.housecoor[i][1]+t[1]>hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]>hrpg.housecoor[i][2] then
										t[2]=-t[2]
									elseif hrpg.housecoor[i][1]+t[1]<hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]>hrpg.housecoor[i][2] then 
										t[1]=-t[1]
									elseif hrpg.housecoor[i][1]+t[1]==hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]~=hrpg.housecoor[i][2] then
										t[2]=-t[1]
										t[1]=0
									elseif hrpg.housecoor[i][1]+t[1]~=hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]==hrpg.housecoor[i][2] then
										t[1]=t[2]
										t[2]=0
									end
								end
							end
						end
						if hrpg.housecoor[i][1]+t[1]==hrpg.housedoor[i][1] and hrpg.housecoor[i][2]+t[2]==hrpg.housedoor[i][2] then
						else
							build(id,t[3],hrpg.housecoor[i][1]+t[1],hrpg.housecoor[i][2]+t[2],player(id,"team"))
						end
					elseif m==2 then
						if rotdif~=0 then
							t[3]=t[3]-rotdif
							if math.abs(rotdif)==180 then
								t[1]=-t[1]
								t[2]=-t[2]
							else
								t[3]=t[3]+rotdif
								if rotdif==90 then
									if hrpg.housecoor[i][1]+t[1]<hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]<hrpg.housecoor[i][2] then
										t[1]=-t[1]
									elseif hrpg.housecoor[i][1]+t[1]>hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]<hrpg.housecoor[i][2] then
										t[2]=-t[2]
									elseif hrpg.housecoor[i][1]+t[1]>hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]>hrpg.housecoor[i][2] then
										t[1]=-t[1]
									elseif hrpg.housecoor[i][1]+t[1]<hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]>hrpg.housecoor[i][2] then 
										t[2]=-t[2]
									elseif hrpg.housecoor[i][1]+t[1]==hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]~=hrpg.housecoor[i][2] then
										t[1]=-t[2]
										t[2]=0
									elseif hrpg.housecoor[i][1]+t[1]~=hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]==hrpg.housecoor[i][2] then
										t[2]=t[1]
										t[1]=0
									end
								else
									if hrpg.housecoor[i][1]+t[1]<hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]<hrpg.housecoor[i][2] then
										t[2]=-t[2]
									elseif hrpg.housecoor[i][1]+t[1]>hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]<hrpg.housecoor[i][2] then
										t[1]=-t[1]
									elseif hrpg.housecoor[i][1]+t[1]>hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]>hrpg.housecoor[i][2] then
										t[2]=-t[2]
									elseif hrpg.housecoor[i][1]+t[1]<hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]>hrpg.housecoor[i][2] then 
										t[1]=-t[1]
									elseif hrpg.housecoor[i][1]+t[1]==hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]~=hrpg.housecoor[i][2] then
										t[2]=-t[1]
										t[1]=0
									elseif hrpg.housecoor[i][1]+t[1]~=hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]==hrpg.housecoor[i][2] then
										t[1]=t[2]
										t[2]=0
									end
								end
							end
						end
						if #lines==1 then
							hrpg.furn.spawn(id,hrpg.housecoor[i][1]+t[1],hrpg.housecoor[i][2]+t[2],t[3],{t[4],t[5],t[6]},t[7])
						else
							local fix=t[7]
							for fi=2,#lines do
								fix=fix.." "..lines[fi]..""
							end
							hrpg.furn.spawn(id,hrpg.housecoor[i][1]+t[1],hrpg.housecoor[i][2]+t[2],t[3],{t[4],t[5],t[6]},fix)
						end
					elseif m==3 then
						if rotdif~=0 then
							if math.abs(rotdif)==180 then
								t[1]=-t[1]
								t[2]=-t[2]
								if hrpg.housecoor[i][1]+t[1]==hrpg.housedoor[i][1] and hrpg.housecoor[i][2]+t[2]==hrpg.housedoor[i][2] then
								else
									build(id,t[3],hrpg.housecoor[i][1]+t[1],hrpg.housecoor[i][2]+t[2],player(id,"team"))
								end
							else
								if rotdif==90 then
									if hrpg.housecoor[i][1]+t[1]<hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]<hrpg.housecoor[i][2] then
										t[1]=-t[1]
									elseif hrpg.housecoor[i][1]+t[1]>hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]<hrpg.housecoor[i][2] then
										t[2]=-t[2]
									elseif hrpg.housecoor[i][1]+t[1]>hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]>hrpg.housecoor[i][2] then
										t[1]=-t[1]
									elseif hrpg.housecoor[i][1]+t[1]<hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]>hrpg.housecoor[i][2] then 
										t[2]=-t[2]
									elseif hrpg.housecoor[i][1]+t[1]==hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]~=hrpg.housecoor[i][2] then
										t[1]=-t[2]
										t[2]=0
									elseif hrpg.housecoor[i][1]+t[1]~=hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]==hrpg.housecoor[i][2] then
										t[2]=t[1]
										t[1]=0
									end
								else
									if hrpg.housecoor[i][1]+t[1]<hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]<hrpg.housecoor[i][2] then
										t[2]=-t[2]
									elseif hrpg.housecoor[i][1]+t[1]>hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]<hrpg.housecoor[i][2] then
										t[1]=-t[1]
									elseif hrpg.housecoor[i][1]+t[1]>hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]>hrpg.housecoor[i][2] then
										t[2]=-t[2]
									elseif hrpg.housecoor[i][1]+t[1]<hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]>hrpg.housecoor[i][2] then 
										t[1]=-t[1]
									elseif hrpg.housecoor[i][1]+t[1]==hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]~=hrpg.housecoor[i][2] then
										t[2]=-t[1]
										t[1]=0
									elseif hrpg.housecoor[i][1]+t[1]~=hrpg.housecoor[i][1] and hrpg.housecoor[i][2]+t[2]==hrpg.housecoor[i][2] then
										t[1]=t[2]
										t[2]=0
									end
								end
							end
						end
						parse("spawnitem "..t[3].." "..t[1].." "..t[2].."")
					elseif m==4 then
						parse("setmoney "..id.." "..tonumber(t[1]))
					elseif m==5 then
						hrpg.debt[id]=tonumber(t[1])
					elseif m==6 then
						hrpg.language[id]=t[1]
					elseif m==7 then
						hrpg.colors[id]={t[1],t[2],t[3]}
					elseif m==8 then
						hrpg.item_add(id,line,0)
					elseif m==12 then
						hrpg.level[id]=tonumber(t[1])
					elseif m==13 then
						hrpg.experience[id]=tonumber(t[1])
					elseif m==14 then
						if line~="Default" then
							hrpg.names[myh[id]]=line
						else
							hrpg.names[myh[id]]="House "..myh[id]..""
						end
					elseif m==15 then
						hrpg.rooftype[myh[id]]=t[1]
						if hrpg.rooftype[myh[id]]~="" and hrpg.rooftype[myh[id]]~="Default" then
							for i=1,#hrpg.furniture do
								if hrpg.furniture[i]:find(t[1]) and hrpg.furniture[i]:find("Roof") then
									hrpg.houseroof[myh[id]]=image(hrpg.furn.images[i],hrpg.housecoor[myh[id]][1]*32+16,hrpg.housecoor[myh[id]][2]*32+16,3)
									table.insert(hrpg.roof_exists,myh[id])
									hrpg.roof_visible[myh[id]]=true
									imagescale(hrpg.houseroof[myh[id]],hrpg.housesize[myh[id]][1]/2,hrpg.housesize[myh[id]][2]/2)
									imagepos(hrpg.houseroof[myh[id]],hrpg.housecoor[myh[id]][1]*32+16,hrpg.housecoor[myh[id]][2]*32+16,hrpg.houserot[myh[id]])
									hrpg.respcycle()
									break
								end
							end
						end
					elseif m==16 then
						hrpg.maxhealth[id]=tonumber(t[1])
					elseif m==17 then
						hrpg.maxarmor[id]=tonumber(t[1])
					elseif m==18 then
						hrpg.bankdeposit[id]=tonumber(t[1])
					end
				end
			end
			msg2(id,"125125125"..iden[1].." save successfully loaded!")
			file:close()
		else
			msg2(id,"125125125"..iden[1].." save not found...")
		end
	end
end

function hrpg.item_add(id,i,m)
	if #hrpg.inventory[id]<hrpg.maxinv then
		table.insert(hrpg.inventory[id],i)
		if m==1 then
			if string.sub(i,1,1)~="A" and string.sub(i,1,1)~="a" and string.sub(i,1,1)~="e" and string.sub(i,1,1)~="E" and string.sub(i,1,1)~="o" and string.sub(i,1,1)~="O" and string.sub(i,1,1)~="I" and string.sub(i,1,1)~="i" and string.sub(i,1,1)~="U" and string.sub(i,1,1)~="U" then
				msg2(id,"255255255"..translate(id,"You got a").." "..i.."! "..translate(id,"Check your Inventory (F3/serveraction 2)!").."")
			else
				msg2(id,"255255255"..translate(id,"You got an").." "..i.."! "..translate(id,"Check your Inventory (F3/serveraction 2)!").."")
			end
		end
	else
		table.insert(hrpg.item_queue[id],i)
		if m==1 then
			msg2(id,"255255255"..translate(id,"Inventory overloaded!").." "..i.." "..translate(id,"was added to your item queue."))
		end
	end
end
function hrpg.item_remove(id,i)
	table.remove(hrpg.inventory[id],i)
	if #hrpg.item_queue[id]>0 then
		table.insert(hrpg.inventory[id],hrpg.item_queue[id][1])
		if string.sub(i,1,1)~="A" and string.sub(i,1,1)~="a" and string.sub(i,1,1)~="e" and string.sub(i,1,1)~="E" and string.sub(i,1,1)~="o" and string.sub(i,1,1)~="O" and string.sub(i,1,1)~="I" and string.sub(i,1,1)~="i" and string.sub(i,1,1)~="U" and string.sub(i,1,1)~="U" then
			msg2(id,"255255255"..translate(id,"You got a").." "..hrpg.item_queue[id][1].." "..translate(id,"from your item queue").."! "..translate(id,"Check your Inventory (F3/serveraction 2)!").."")
		else
			msg2(id,"255255255"..translate(id,"You got an").." "..hrpg.item_queue[id][1].." "..translate(id,"from your item queue").."! "..translate(id,"Check your Inventory (F3/serveraction 2)!").."")
		end
		table.remove(hrpg.item_queue[id],1)
	end
end

function hrpg.furn.spawn(id,x,y,r,color,name)
	local rot=tonumber(r)
	if tonumber(name)~=nil then
		table.insert(hrpg.furn.id,image("gfx/weapons/"..string.gsub(itemtype(name,"name")," ","").."_k.bmp",x*32+16,y*32+16,0))
		table.insert(hrpg.furn.size,{1,1})
		table.insert(hrpg.furn.type,1)
		table.insert(hrpg.furn.player,id)
		table.insert(hrpg.furn.var,name)
		table.insert(hrpg.furn.img,"")
		table.insert(hrpg.furn.rot,rot)
		table.insert(hrpg.furn.color,color)
		imagepos(hrpg.furn.id[#hrpg.furn.id],x*32+16,y*32+16,rot)
		imagescale(hrpg.furn.id[#hrpg.furn.id],0,0)
		imagecolor(hrpg.furn.id[#hrpg.furn.id],color[1],color[2],color[3])
		tween_scale(hrpg.furn.id[#hrpg.furn.id],1000,1,1)
	else
		local f=1
		for s=1,#hrpg.furniture do
			if hrpg.furniture[s]==name then
				f=s
				break
			end
		end
		if (hrpg.furn.types[f]~=4 and hrpg.furn.types[f]~=6) or (name:find("TV")) then
			table.insert(hrpg.furn.id,image(hrpg.furn.image[f],x*32+16,y*32+16,0))
		else
			table.insert(hrpg.furn.id,image(hrpg.furn.image[f],x*32+16,y*32+16,1))
		end
		table.insert(hrpg.furn.type,hrpg.furn.types[f])
		table.insert(hrpg.furn.player,id)
		table.insert(hrpg.furn.var,name)
		table.insert(hrpg.furn.img,hrpg.furn.images[f])
		table.insert(hrpg.furn.color,color)
		local size1=hrpg.furn.sizes[f][1]
		local size2=hrpg.furn.sizes[f][2]
		if rot==0 then
			table.insert(hrpg.furn.size,{size1,size2})
		elseif rot==180 then
			table.insert(hrpg.furn.size,{size1,size2})
		elseif rot==-90 then
			table.insert(hrpg.furn.size,{size2,size1})
		elseif rot==90 then
			table.insert(hrpg.furn.size,{size2,size1})
		else
			table.insert(hrpg.furn.size,{size1,size2})
		end
		table.insert(hrpg.furn.rot,rot)
		imagepos(hrpg.furn.id[#hrpg.furn.id],x*32+16,y*32+16,rot)
		imagescale(hrpg.furn.id[#hrpg.furn.id],0,0)
		imagecolor(hrpg.furn.id[#hrpg.furn.id],color[1],color[2],color[3])
		tween_scale(hrpg.furn.id[#hrpg.furn.id],1000,1,1)
	end
end
function hrpg.furn.kill(p)
	tween_scale(hrpg.furn.id[p],1000,0,0)
	timer(1000,"freeimage",""..hrpg.furn.id[p].."")
	if p~=#hrpg.furn.id then
		for i=p+1,#hrpg.furn.id do
			if hrpg.furn.var[i]=="TV" and tonumber(hrpg.furn.img[i])~=nil and tonumber(hrpg.furn.img[i])~=0 then
				freetimer("hrpg.furn.tvimg",""..i.."")
				timer(math.random(1,10)*100,"hrpg.furn.tvimg",""..(i-1).."")
			end
		end
	end
	table.remove(hrpg.furn.id,p)
	table.remove(hrpg.furn.size,p)
	table.remove(hrpg.furn.type,p)
	table.remove(hrpg.furn.player,p)
	table.remove(hrpg.furn.rot,p)
	table.remove(hrpg.furn.color,p)
	for c=1,#hrpg.furniture do
		if hrpg.furn.var[p]==hrpg.furniture[c] and hrpg.furn.img[p]==hrpg.furn.images[c] then
			table.remove(hrpg.furn.var,p)
			table.remove(hrpg.furn.img,p)
			return 1
		end
	end
	local f=hrpg.furn.var[p]
	table.remove(hrpg.furn.var,p)
	if hrpg.furn.img[p]~=nil and hrpg.furn.img[p]~="" then
		if f=="TV" then
			freetimer("hrpg.furn.tvimg",""..p.."")
		end
		tween_scale(hrpg.furn.img[p],1000,0,0)
		timer(1000,"freeimage",""..hrpg.furn.img[p].."")
	end
	table.remove(hrpg.furn.img,p)
end
function hrpg.furn.poscheck(x,y,sizex,sizey)
	for s=1,#hrpg.furn.id do
		if hrpg.furn.id[s]~=nil and hrpg.furn.type[s]~=7 then
			if x+sizex-math.floor(sizex/2)-1>=object(hrpg.furn.id[s],"tilex")-hrpg.furn.size[s][1]+math.floor(hrpg.furn.size[s][1]/2)+1 and x-sizex+math.floor(sizex/2)+1<=object(hrpg.furn.id[s],"tilex")+hrpg.furn.size[s][1]-math.floor(hrpg.furn.size[s][1]/2)-1 and y+sizey-math.floor(sizey/2)-1>=object(hrpg.furn.id[s],"tiley")-hrpg.furn.size[s][2]+math.floor(hrpg.furn.size[s][2]/2)+1 and y-sizey+math.floor(sizey/2)+1<=object(hrpg.furn.id[s],"tiley")+hrpg.furn.size[s][2]-math.floor(hrpg.furn.size[s][2]/2)-1 then
				return 1
			end
		end
	end
	return 0
end

function hrpg.hit(id,source,weapon,hpdmg,apdmg)
	if racer[source]==1 then
		if weapon==77 then
			parse("speedmod "..id.." -20")
			if carimg[id]~=0 then
				timer(750,"parse","speedmod "..id.." 25")
			else
				timer(750,"parse","speedmod "..id.." 15")
			end
		elseif weapon==45 then
			parse("strip "..source.." 45")
			parse("speedmod "..id.." -20")
			if carimg[id]~=0 then
				timer(750,"parse","speedmod "..id.." 25")
			else
				timer(750,"parse","speedmod "..id.." 15")
			end
		elseif weapon==69 then
			parse("strip "..source.." 69")
			local px=player(id,"x")
			local py=player(id,"y")
			local sx=player(source,"x")
			local sy=player(source,"y")
			parse("setpos "..id.." "..sx.." "..sy.."")
			parse("setpos "..source.." "..px.." "..py.."")
			parse("speedmod "..id.." -20")
			if carimg[id]~=0 then
				timer(1000,"parse","speedmod "..id.." 25")
			else
				timer(1000,"parse","speedmod "..id.." 15")
			end
		elseif weapon==51 then
			parse("strip "..source.." 51")
			parse("speedmod "..id.." -20")
			if carimg[id]~=0 then
				timer(750,"parse","speedmod "..id.." 25")
			else
				timer(750,"parse","speedmod "..id.." 15")
			end
		end
		return 1
	end
	if id~=source and hrpg.fight[id]==0 and (weapon==74 or weapon==50) and player(id,"weapontype")==75 and id~=challenger and id~=challenging then
		parse("strip "..id.." 75")
		parse("equip "..source.." 75")
		parse("setweapon "..source.." 75")
    end
	if source==challenger or source==challenging then
		if rules=="" then
			return 1
		else
			if id==challenger or id==challenging then
				return 0
			else
				return 1
			end
		end
	else
		return 1
	end
	if source~=0 and id~=0 and id~=challenging and id~=challenger then
		return 1
	end
end

function hrpg.projectile(id,w,x,y)
	if w~=75 and racer[id]==0 then
		for i=1,#hrpg.inventory[id] do
			if hrpg.inventory[id][i]==itemtype(w,"name") then
				hrpg.item_remove(id,i)
				for w=1,#playerweapons(id) do
					if playerweapons(id)[w]~=nil and itemtype(playerweapons(id)[w],"name")==itemtype(w,"name") then
						parse("strip "..id.." "..w.."")
						break
					end
				end
				break
			end
		end
	end
	if w==75 and racer[id]==0 then
		local tx=math.floor(x/32)
		local ty=math.floor(y/32)
		local px=player(id,"tilex")
		local py=player(id,"tiley")
		parse("strip "..id.." 75")
		if not tile(tx,ty,"wall") then
			parse("spawnitem 75 "..tx.." "..ty)
		else
			if tx==px and ty<py then
				ty=ty+1
				parse("spawnitem 75 "..tx.." "..ty)
			elseif tx==px and ty>py then
				ty=ty-1
				parse("spawnitem 75 "..tx.." "..ty)
			elseif tx<px and ty==py then
				tx=tx+1
				parse("spawnitem 75 "..tx.." "..ty)
			elseif tx>px and ty==py then
				tx=tx-1
				parse("spawnitem 75 "..tx.." "..ty)
			elseif tx>px and ty>py then
				tx=tx-1
				ty=ty-1
				parse("spawnitem 75 "..tx.." "..ty)
			elseif tx<px and ty<py then
				tx=tx+1
				ty=ty+1
				parse("spawnitem 75 "..tx.." "..ty)
			elseif tx<px and ty>py then
				tx=tx+1
				ty=ty-1
				parse("spawnitem 75 "..tx.." "..ty)
			elseif tx>px and ty<py then
				tx=tx-1
				ty=ty+1
				parse("spawnitem 75 "..tx.." "..ty)
			end
		end
	end
end

function hudding(p,id)
	if player(id,"exists") and player(id,"team")>0 then
		if p==1 then
			if hrpg.hud2[id]==1 and hrpg.fight[id]==0 then
				if cfight~="None" then
					hudtxt2(id,hrpg.hudids[3],"255255255",translate(id,"Current fight")..": "..cfight.."",5,405,0)
				else
					hudtxt2(id,hrpg.hudids[3],"255255255",translate(id,"Current fight")..": "..translate(id,cfight).."",5,405,0)
				end
			elseif hrpg.hud2[id]~=1 then
				clearhudtxt2(id,hrpg.hudids[3])
			end
		elseif p==2 then
			if hrpg.hud2[id]==1 and hrpg.fight[id]==0 then
				if #hrpg.races>1 then
					hudtxt2(id,hrpg.hudids[2],"255255255",translate(id,"Current race")..": "..#hrpg.races.." "..translate(id,"happening at the same time").."",5,419,0)
				elseif #hrpg.races==1 then
					hudtxt2(id,hrpg.hudids[2],"255255255",translate(id,"Current race")..": "..translate(id,"Hosted by").." "..player(hrpg.races[1][3],"name").." "..translate(id,"on").." "..hrpg.races[1][4].." | "..translate(id,"Slots")..": "..hrpg.races[1][1].."/"..hrpg.races[1][2].." "..translate(id,"Status")..": "..translate(id,hrpg.races[1][5]).."",5,419,0)
				else
					hudtxt2(id,hrpg.hudids[2],"255255255",translate(id,"Current race")..": "..translate(id,"None").."",5,419,0)
				end
			elseif hrpg.hud2[id]~=1 then
				clearhudtxt2(id,hrpg.hudids[2])
			end
		elseif p==3 then
			if hrpg.hud2[id]==1 then
				if hrpg.quest[id]~="None" then
					hudtxt2(id,hrpg.hudids[4],"255255255",translate(id,"Your active quest")..": "..hrpg.quest[id].." "..translate(id,"Done")..": "..hrpg.questprog[id].."/"..hrpg.questdet[id].." "..translate(id,"Reward")..": "..hrpg.questreward[id].."",5,433,0)
				else
					hudtxt2(id,hrpg.hudids[4],"255255255",translate(id,"Your active quest")..": "..translate(id,hrpg.quest[id]).."",5,433,0)
				end
			else
				clearhudtxt2(id,hrpg.hudids[4])
			end
		elseif p==4 then
			if hrpg.hud1[id]==1 then
				hudtxt2(id,hrpg.hudids[1],"255255255",translate(id,"Houses RPG v24"),53,46,1)
			else
				clearhudtxt2(id,hrpg.hudids[1])
			end
			if hrpg.hud2[id]==1 then
				if hrpg.level[id]<hrpg.maxlevel then
					hudtxt2(id,hrpg.hudids[5],"255255255",""..translate(id,"Level")..": "..hrpg.level[id].."",635,373,2)
					hudtxt2(id,hrpg.hudids[6],"255255255",""..translate(id,"Experience points")..": "..hrpg.experience[id].."/"..(hrpg.level[id]*100)+((hrpg.level[id]-1)*10).."",635,391,2)
				else
					hudtxt2(id,hrpg.hudids[5],"255255255",""..translate(id,"Level")..": MAX",635,373,2)
					hudtxt2(id,hrpg.hudids[6],"255255255",""..translate(id,"Experience points")..": MAX",635,391,2)
				end
			else
				clearhudtxt2(id,hrpg.hudids[5])
				clearhudtxt2(id,hrpg.hudids[6])
			end
		elseif p==5 and hrpg.fight[id]~=0 then
			hudtxt2(id,hrpg.hudids[2],"255255255",""..translate(id,"")..""..translate(id,"Attack")..""..translate(id,"                  ")..""..translate(id,"Defend").."",320,392,1)
			hudtxt2(id,hrpg.hudids[3],"255255255",""..translate(id,"   ")..""..translate(id,"Run")..""..translate(id,"                   ")..""..translate(id,"Inventory").."",320,422,1)
			if hrpg.mob.id[hrpg.fight[id]]~=nil then
				hudtxt2(id,hrpg.hudids[4],"255255255",""..hrpg.mob.type[hrpg.fight[id]].." "..translate(id,"Level").." "..hrpg.mob.level[hrpg.fight[id]].."",320,20,1)
				if hrpg.mob.hp[hrpg.fight[id]]>=0 then
					hudtxt2(id,hrpg.hudids[7],"255255255",""..hrpg.mob.hp[hrpg.fight[id]].." "..translate(id,"HP").." | "..translate(id,"AP").." "..hrpg.mob.armor[hrpg.fight[id]].."",320,40,1)
				else
					hudtxt2(id,hrpg.hudids[7],"255255255","0 "..translate(id,"HP").." | "..translate(id,"AP").." "..hrpg.mob.armor[hrpg.fight[id]].."",320,40,1)
				end
			end
		elseif hrpg.fight[id]==0 then
			clearhudtxt2(id,hrpg.hudids[7])
			clearhudtxt2(id,hrpg.hudids[8])
			clearhudtxt2(id,hrpg.hudids[9])
			clearhudtxt2(id,hrpg.hudids[10])
		end
	elseif player(id,"exists") and player(id,"team")==0 then
		for d=1,10 do
			clearhudtxt2(id,hrpg.hudids[d])
		end
	end
end

function hrpg.serveraction(id,action)
	if player(id,"team")>0 and player(id,"health")>0 and hrpg.namechange[id]==0 and namch[id]==0 then
		if id~=challenger and id~=challenging then
			if racer[id]==0 then
				if hrpg.fight[id]==0 then
					if action==hrpg.house_menu_key then
						if myh[id]~=0 then
							menu(id,translate(id,"HRPG Menu")..","..translate(id,"Get a house")..","..translate(id,"Toggle your house door")..","..translate(id,"Teleport to your house")..","..translate(id,"Bank menu")..","..translate(id,"Customize your house")..","..translate(id,"Car menu")..","..translate(id,"Quest menu")..","..translate(id,"Furniture menu")..","..translate(id,"Change client settings").."")
						else
							menu(id,translate(id,"HRPG Menu")..","..translate(id,"Get a house")..",,,,,"..translate(id,"Car menu")..","..translate(id,"Quest menu")..","..translate(id,"Furniture menu")..","..translate(id,"Change client settings").."")
						end
					elseif action==hrpg.inventory_key then
						hrpg.context[id]=2
						hrpg.inv(id,2)
					elseif action==hrpg.multi_key then
						hrpg.page[id]=0
						hrpg.placeh[id]=0
						menu(id,translate(id,"Select a menu")..","..translate(id,"HRPG Menu")..","..translate(id,"Inventory")..","..translate(id,"Quick loan")..","..translate(id,"Quick collect")..","..translate(id,"Quick place").."")
					end
				end
			else
				for i=1,#hrpg.races do
					if hrpg.races[i][3]==id and hrpg.races[i][5]=="Waiting" then
						menu(id,translate(id,"Racing stuff").."@b,"..translate(id,"Leave the race")..","..translate(id,"Manually start the race").." |"..(math.floor(hrpg.races[i][2]/2)+1)-hrpg.races[i][1].." "..translate(id,"more players needed"))
						return 1
					end
				end
				menu(id,translate(id,"Wanna leave the race?")..","..translate(id,"Yes")..","..translate(id,"No"))
			end
		else
			menu(id,translate(id,"Wanna leave the arena?")..","..translate(id,"Yes")..","..translate(id,"No"))
		end
	end
end

function hrpg.minute()
	if math.random(1,20)==7 then
		msg("255255255F2 (serveraction 1) opens the House Menu!")
		msg("255255255Type !help in chat if you don't know what to do!")
		msg("255255255Reach level "..hrpg.maxlevel.." to win cool stuff!")
	end
	local c=0
	local p=0
	for id=1,#player(0,"tableliving") do
		p=player(0,"tableliving")[id]
		if player(p,"tilex")>=36 and player(p,"tilex")<=42 and player(p,"tiley")>=49 and player(p,"tiley")<=55 then
			c=1
		elseif player(p,"tilex")>=148 and player(p,"tilex")<=154 and player(p,"tiley")>=49 and player(p,"tiley")<=55 then
			c=2
		elseif player(p,"tilex")>=36 and player(p,"tilex")<=42 and player(p,"tiley")>=87 and player(p,"tiley")<=93 then
			c=3
		elseif player(p,"tilex")>=148 and player(p,"tilex")<=154 and player(p,"tiley")>=87 and player(p,"tiley")<=93 then
			c=4
		end
	end
	if c==1 then
		if hrpg.sellstates[1]=="idle" then
			tween_move(hrpg.sellers[1],1500,42*32+8,52*32+16,-90)
			tween_move(hrpg.sellershadows[1],1500,42*32+8,52*32+16,-90)
			hrpg.sellstates[1]="busy"
		end
	else
		if hrpg.sellstates[1]=="busy" then
			freetimer("hrpg.sellercycle","1,up")
			freetimer("hrpg.sellercycle","1,down")
			tween_move(hrpg.sellers[1],5000,42*32+16,49*32+16,0)
			tween_move(hrpg.sellershadows[1],5000,42*32+16,49*32+16,0)
			timer(5000,"hrpg.sellercycle","1,down")
			hrpg.sellstates[1]="idle"
		end
		if c==2 then
			if hrpg.sellstates[2]=="idle" then
				tween_move(hrpg.sellers[2],1500,148*32+24,52*32+16,90)
				tween_move(hrpg.sellershadows[2],1500,148*32+24,52*32+16,90)
				hrpg.sellstates[2]="busy"
			end
		else
			if hrpg.sellstates[2]=="busy" then
				freetimer("hrpg.sellercycle","2,up")
				freetimer("hrpg.sellercycle","2,down")
				tween_move(hrpg.sellers[2],5000,148*32+16,49*32+16,0)
				tween_move(hrpg.sellershadows[2],5000,148*32+16,49*32+16,0)
				timer(5000,"hrpg.sellercycle","2,down")
				hrpg.sellstates[2]="idle"
			end
			if c==3 then
				if hrpg.sellstates[3]=="idle" then
					tween_move(hrpg.sellers[3],1500,42*32+8,90*32+16,-90)
					tween_move(hrpg.sellershadows[3],1500,42*32+8,90*32+16,-90)
					hrpg.sellstates[3]="busy"
				end
			else
				if hrpg.sellstates[3]=="busy" then
					freetimer("hrpg.sellercycle","3,up")
					freetimer("hrpg.sellercycle","3,down")
					tween_move(hrpg.sellers[3],5000,42*32+16,87*32+16,0)
					tween_move(hrpg.sellershadows[3],5000,42*32+16,87*32+16,0)
					timer(5000,"hrpg.sellercycle","3,down")
					hrpg.sellstates[3]="idle"
				end
				if c==4 then
					if hrpg.sellstates[4]=="idle" then
						tween_move(hrpg.sellers[4],1500,148*32+24,90*32+16,90)
						tween_move(hrpg.sellershadows[4],1500,148*32+24,90*32+16,90)
						hrpg.sellstates[4]="busy"
					end
				else
					if hrpg.sellstates[4]=="busy" then
						freetimer("hrpg.sellercycle","4,up")
						freetimer("hrpg.sellercycle","4,down")
						tween_move(hrpg.sellers[4],5000,148*32+16,87*32+16,0)
						tween_move(hrpg.sellershadows[4],5000,148*32+16,87*32+16,0)
						timer(5000,"hrpg.sellercycle","4,down")
						hrpg.sellstates[4]="idle"
					end
				end
			end
		end
	end
end
function hrpg.second()
	if hrpg.time>0 then
		hrpg.time=hrpg.time-1000
	elseif hrpg.time<0 then
		hrpg.time=hrpg.time+1000
	end
	if challenger~=0 and challenging~=0 and rules=="1 min" then
		if tim>=10 then
			cfight="1 minute fest - "..player(challenger,"name").." "..score1..":"..score2.." "..player(challenging,"name").." Time left: "..time2..":"..tim..""
		else
			cfight="1 minute fest - "..player(challenger,"name").." "..score1..":"..score2.." "..player(challenging,"name").." Time left: "..time2..":0"..tim..""
		end
		if time2==0 and tim==0 then
			if score1>score2 then
				msg("255255255"..player(challenger,"name").." has won the 1 minute fest!")
				won(challenger,challenging)
				hrpg.endarena()
			elseif score1<score2 then
				msg("255255255"..player(challenging,"name").." has won the 1 minute fest!")
				won(challenging,challenger)
				hrpg.endarena()
			else
				msg("255255255It's a tie between "..player(challenging,"name").." and "..player(challenger,"name").."! Choosing random winner...")
				if math.random(1,2)==1 then
					won(challenging,challenger)
				else
					won(challenger,challenging)
				end
				hrpg.endarena()
			end
		end
		if time2>=0 then
			tim=tim-1
		end
		if tim<=-1 then
			if time2>=1 then
				time2=time2-1
				tim=59
			else
				time2=0
				tim=0
			end
		end
		for z=1,32 do
			hudding(1,z)
		end
	end
end

function hrpg.sellercycle(d)
	local c=hrpg.commakiller(d)
	if c[2]=="down" and hrpg.sellstates[tonumber(c[1])]=="idle" then
		freetimer("hrpg.sellercycle",""..tonumber(c[1])..",up")
		local i=tonumber(c[1])
		if i==1 then
			imagepos(hrpg.sellers[i],42*32+16,49*32+16,-180)--tween_rotate(hrpg.seller,1000,-90)
			imagepos(hrpg.sellershadows[i],42*32+16,49*32+16,-180)
			tween_move(hrpg.sellers[i],10000,42*32+16,55*32+16)
			tween_move(hrpg.sellershadows[i],10000,42*32+16,55*32+16)
		elseif i==2 then
			imagepos(hrpg.sellers[i],148*32+16,49*32+16,-180)
			imagepos(hrpg.sellershadows[i],148*32+16,49*32+16,-180)
			tween_move(hrpg.sellers[i],10000,148*32+16,55*32+16)
			tween_move(hrpg.sellershadows[i],10000,148*32+16,55*32+16)
		elseif i==3 then
			imagepos(hrpg.sellers[i],42*32+16,87*32+16,-180)
			imagepos(hrpg.sellershadows[i],42*32+16,87*32+16,-180)
			tween_move(hrpg.sellers[i],10000,42*32+16,93*32+16)
			tween_move(hrpg.sellershadows[i],10000,42*32+16,93*32+16)
		elseif i==4 then
			imagepos(hrpg.sellers[i],148*32+16,87*32+16,-180)
			imagepos(hrpg.sellershadows[i],148*32+16,87*32+16,-180)
			tween_move(hrpg.sellers[i],10000,148*32+16,93*32+16)
			tween_move(hrpg.sellershadows[i],10000,148*32+16,93*32+16)
		end
		timer(10000,"hrpg.sellercycle",""..tonumber(c[1])..",up")
	elseif c[2]=="up" and hrpg.sellstates[tonumber(c[1])]=="idle" then
		freetimer("hrpg.sellercycle",""..tonumber(c[1])..",down")
		local i=tonumber(c[1])
		if i==1 then
			imagepos(hrpg.sellers[i],42*32+16,55*32+16,0)
			imagepos(hrpg.sellershadows[i],42*32+16,55*32+16,0)
			tween_move(hrpg.sellers[i],10000,42*32+16,49*32+16)
			tween_move(hrpg.sellershadows[i],10000,42*32+16,49*32+16)
		elseif i==2 then
			imagepos(hrpg.sellers[i],148*32+16,55*32+16,0)
			imagepos(hrpg.sellershadows[i],148*32+16,55*32+16,0)
			tween_move(hrpg.sellers[i],10000,148*32+16,49*32+16)
			tween_move(hrpg.sellershadows[i],10000,148*32+16,49*32+16)
		elseif i==3 then
			imagepos(hrpg.sellers[i],42*32+16,93*32+16,0)
			imagepos(hrpg.sellershadows[i],42*32+16,93*32+16,0)
			tween_move(hrpg.sellers[i],10000,42*32+16,87*32+16)
			tween_move(hrpg.sellershadows[i],10000,42*32+16,87*32+16)
		elseif i==4 then
			imagepos(hrpg.sellers[i],148*32+16,93*32+16,0)
			imagepos(hrpg.sellershadows[i],148*32+16,93*32+16,0)
			tween_move(hrpg.sellers[i],10000,148*32+16,87*32+16)
			tween_move(hrpg.sellershadows[i],10000,148*32+16,87*32+16)
		end
		timer(10000,"hrpg.sellercycle",""..tonumber(c[1])..",down")
	end
end

function spawnplayer(id,x,y)
	local m=player(id,"money")
	parse("spawnplayer "..id.." "..x.." "..y)
	parse("setmoney "..id.." "..m.."")
	if racer[id]~=1 then
		if carimg[id]==0 then
			parse('speedmod '..id..' 0')
		else
			parse('speedmod '..id..' 15')
		end
	end
end

function hrpg.menu(id,men,sel)
	if hrpg.fight[id]~=0 and hrpg.context[id]~=3 then
		return 1
	end
	if men==translate(id,"Wanna leave the race?") then
		if sel==1 then
			spawnplayer(id,78*32+16,179*32+16)
			racer[id]=0
			if carimg[id]~=0 then
				parse('speedmod '..id..' 15')
			else
				parse('speedmod '..id..' 0')
			end
			hrpg.race_leave(id)
		end
	elseif men==translate(id,"Wanna leave the arena?")  then
		if sel==1 then
			spawnplayer(id,77*32+16,162*32+16)
			msg("255255255"..player(id,"name").." has left the arena!")
			hrpg.endarena()
		end
	elseif men==translate(id,"HRPG Menu") then
		if sel==1 then
			local t={"","","","","","",""}
			for i=1,#t do
				if hrpg.house(i,"owned")~=0 then
					t[i]=translate(id,"Owned by").." "..string.gsub(player(hrpg.house(i,"owned"),"name"),"|","")..""
				else
					t[i]=translate(id,"Not Owned")
				end
			end
			menu(id,translate(id,"Houses - Page 1").."@b,"..string.gsub(hrpg.names[1],"|","").." | "..t[1]..","..string.gsub(hrpg.names[2],"|","").." | "..t[2]..","..string.gsub(hrpg.names[3],"|","").." | "..t[3]..","..string.gsub(hrpg.names[4],"|","").." | "..t[4]..","..string.gsub(hrpg.names[5],"|","").." | "..t[5]..","..string.gsub(hrpg.names[6],"|","").." | "..t[6]..","..string.gsub(hrpg.names[7],"|","").." | "..t[7]..","..translate(id,"Next")..","..translate(id,"Back"))
		elseif sel==2 then
			if myh[id]~=0 then
				parse("trigger hs"..myh[id].."w")
				msg2(id,"255255255"..translate(id,"Door toggled."))
			else
				msg2(id,"255255255"..translate(id,"You don't own a house :P"))
			end
		elseif sel==3 then
			if myh[id]>0 then
				setpos(id,hrpg.housecoor[myh[id]][1]*32+16,hrpg.housecoor[myh[id]][2]*32+16)
				if carimg[id]~=0 then
					parse('speedmod '..id..' 15')
				else
					parse('speedmod '..id..' 0')
				end
				hrpg.roofupdate(id,hrpg.housecoor[myh[id]][1]*32+16,hrpg.housecoor[myh[id]][2]*32+16)
			else
				msg2(id,"255255255"..translate(id,"You don't own a house :P"))
			end
		elseif sel==4 then
			menu(id,translate(id,"Bank menu")..","..translate(id,"Borrow money")..","..translate(id,"Deposit money")..","..translate(id,"Withdraw money").." | "..hrpg.bankdeposit[id].."$,"..translate(id,"Pay off bank debt").." | "..hrpg.debt[id].."$,"..translate(id,"Money transfer")..",,,,"..translate(id,"Back").."")
		elseif sel==5 then
			if myh[id]~=0 then
				menu(id,translate(id,"Customize your house")..","..translate(id,"Rename your house")..","..translate(id,"Rebuild house walls")..","..translate(id,"Destroy house walls")..","..translate(id,"Get rid of your house")..",,,,,"..translate(id,"Back").."")
			else
				msg2(id,"255255255"..translate(id,"You don't own a house :P"))
			end
		elseif sel==6 then
			menu(id,translate(id,"Car menu")..","..translate(id,"Spawn car")..","..translate(id,"Get into your car")..","..translate(id,"Park your car")..","..translate(id,"Change your car's colour")..","..translate(id,"Find your car")..",,,,"..translate(id,"Back"))
		elseif sel==7 then
			menu(id,translate(id,"Quest menu")..","..translate(id,"Choose quest")..","..translate(id,"Abandon quest")..",,,,,,,"..translate(id,"Back"))
		elseif sel==8 then
			menu(id,translate(id,"Furniture menu")..","..translate(id,"Place furniture")..","..translate(id,"Collect furniture")..","..translate(id,"Remove roof")..","..translate(id,"Remove furniture")..",,,,,"..translate(id,"Back"))
		elseif sel==9 then
			menu(id,translate(id,"Client settings")..",Change language,"..translate(id,"Toggle version info")..","..translate(id,"Toggle HUD")..","..translate(id,"Back"))
		end
	elseif men==translate(id,"Client settings") then
		if sel==1 then
			hrpg.team(id,player(id,"team"),-1)
		elseif sel==3 then
			if hrpg.hud2[id]==1 then
				hrpg.hud2[id]=0
			else
				hrpg.hud2[id]=1
			end
			for i=1,5 do
				hudding(i,id)
			end
		elseif sel==2 then
			if hrpg.hud1[id]==1 then
				hrpg.hud1[id]=0
			else
				hrpg.hud1[id]=1
			end
			for i=1,5 do
				hudding(i,id)
			end
		elseif sel==4 then
			hrpg.serveraction(id,1)
		end
	elseif men==translate(id,"Quest menu") then
		if sel==1 then
			hrpg.gen(id)
		elseif sel==2 then
			hrpg.showq(id)
		elseif sel==9 then
			hrpg.serveraction(id,1)
		end
	elseif men==translate(id,"Choose your quest") then
		if sel>0 and sel<9 then
			if hrpg.questch[id]~=1 then
				hrpg.quest[id]=hrpg.quests[id][sel]
				hrpg.questtype[id]=hrpg.questtypes[id][sel]
				hrpg.questdet[id]=hrpg.questdets[id][sel]
				hrpg.questreward[id]=hrpg.questrews[id][sel]
				hrpg.questch[id]=1
				hudding(3,id)
			else
				msg2(id,"255255255Sorry, you already have a quest.")
			end
		elseif sel==9 then
			hrpg.serveraction(id,1)
		end
	elseif men==translate(id,"Car menu") then
		if sel==1 or sel==2 then
			if carimg[id]==0 then
				if parkimg[id]==0 then
					carimg[id]=image(hrpg.carimage,1,0,200+id)
					imagecolor(carimg[id],hrpg.colors[id][1],hrpg.colors[id][2],hrpg.colors[id][3])
					imagescale(carimg[id],0,0)
					tween_scale(carimg[id],1000,1,1)
					if racer[id]==0 then
						parse('speedmod '..id..' 15')
					else
						parse('speedmod '..id..' 25')
					end
				else
					if player(id,"tilex")>=object(parkimg[id],"tilex")-1 and player(id,"tilex")<=object(parkimg[id],"tilex")+1 and player(id,"tiley")>=object(parkimg[id],"tiley")-1 and player(id,"tiley")<=object(parkimg[id],"tiley")+1 then
						tween_move(parkimg[id],500,player(id,"x"),player(id,"y"),player(id,"rot"))
						tween_color(parkimg[id],500,hrpg.colors[id][1],hrpg.colors[id][2],hrpg.colors[id][3])
						if player(id,"speedmod")>-50 then						
							parse("speedmod "..id.." -100")
							timer(500,"hrpg.carappear",""..id.."")
						end
					end
				end
			else
				msg2(id,"255255255"..translate(id,"You already have a car!"))
			end
		elseif sel==3 then
			if parkimg[id]==0 then
				if player(id,"speedmod")>-50 then
					parse("speedmod "..id.." -100")
					timer(500,"hrpg.cardisappear",""..id.."")
				end
			else
				msg2(id,"255255255"..translate(id,"Your car is already parked!"))
			end
		elseif sel==4 then
			if carimg[id]~=0 or parkimg[id]~=0 then
				menu(id,translate(id,"Car colour change - Colour")..","..translate(id,"Red")..","..translate(id,"Green")..","..translate(id,"Blue")..","..translate(id,"Yellow")..","..translate(id,"Cyan")..","..translate(id,"Violet")..","..translate(id,"Custom")..","..translate(id,"Back"))
			else
				msg2(id,"255255255"..translate(id,"You don't have a car!"))
			end
		elseif sel==5 then
			if carimg[id]~=0 or parkimg[id]~=0 then
				if parkimg[id]~=0 then
					if object(parkimg[id],"tilex")>=player(id,"tilex") and object(parkimg[id],"tiley")>=player(id,"tiley") then
						msg2(id,"255255255"..translate(id,"Your car is south-east from here!"))
					elseif object(parkimg[id],"tilex")<player(id,"tilex") and object(parkimg[id],"tiley")<player(id,"tiley") then
						msg2(id,"255255255"..translate(id,"Your car is north-west from here!"))
					elseif object(parkimg[id],"tilex")<player(id,"tilex") and object(parkimg[id],"tiley")>player(id,"tiley") then
						msg2(id,"255255255"..translate(id,"Your car is south-west from here!"))
					elseif object(parkimg[id],"tilex")>player(id,"tilex") and object(parkimg[id],"tiley")<player(id,"tiley") then
						msg2(id,"255255255"..translate(id,"Your car is north-east from here!"))
					end
				else
					msg2(id,"255255255"..translate(id,"Your car is not parked!"))
				end
			else
				msg2(id,"255255255"..translate(id,"You don't have a car!"))
			end
		elseif sel==9 then
			hrpg.serveraction(id,1)
		end
	elseif men==translate(id,"Car colour change - Colour") then
		if sel>=1 and sel<=6 then
			hrpg.placeh[id]=sel
			menu(id,translate(id,"Car colour change - Tone")..","..translate(id,"Light")..","..translate(id,"Balanced")..","..translate(id,"Heavy")..","..translate(id,"Full")..","..translate(id,"Back"))
		elseif sel==7 then
			msg2(id,"255255255Please say how much red colour would you like to have on your car (0-250).")
			hrpg.namechange[id]=1
		elseif sel==8 then
			menu(id,translate(id,"Car menu")..","..translate(id,"Spawn car")..","..translate(id,"Get into your car")..","..translate(id,"Park your car")..","..translate(id,"Change your car's colour")..","..translate(id,"Find your car")..","..translate(id,"Back"))
		end
	elseif men==translate(id,"Car colour change - Tone") then
		local colour=0
		if sel==1 then
			colour=155
		elseif sel==2 then
			colour=195
		elseif sel==3 then
			colour=215
		elseif sel==4 then
			colour=255
		elseif sel==5 then
			menu(id,"Car Colour Change - Colour,Red,Green,Blue,Yellow,Cyan,Violet,Custom,"..translate(id,"Back"))
		end
		if sel>=1 and sel<=4 then
			if hrpg.placeh[id]==1 then
				hrpg.colors[id][1]=colour
				hrpg.colors[id][2]=0
				hrpg.colors[id][3]=0
			elseif hrpg.placeh[id]==2 then
				hrpg.colors[id][2]=colour
				hrpg.colors[id][1]=0
				hrpg.colors[id][3]=0
			elseif hrpg.placeh[id]==3 then
				hrpg.colors[id][3]=colour
				hrpg.colors[id][2]=0
				hrpg.colors[id][1]=0
			elseif hrpg.placeh[id]==4 then
				hrpg.colors[id][1]=colour
				hrpg.colors[id][2]=colour
				hrpg.colors[id][3]=0
			elseif hrpg.placeh[id]==5 then
				hrpg.colors[id][1]=0
				hrpg.colors[id][2]=colour
				hrpg.colors[id][3]=colour
			elseif hrpg.placeh[id]==6 then
				hrpg.colors[id][1]=colour
				hrpg.colors[id][2]=0
				hrpg.colors[id][3]=colour
			end
			msg2(id,"255255255Thank you, your car is now coloured accordingly to your will.")
			if parkimg[id]~=0 then
				tween_color(parkimg[id],1000,hrpg.colors[id][1],hrpg.colors[id][2],hrpg.colors[id][3])
			else
				tween_color(carimg[id],1000,hrpg.colors[id][1],hrpg.colors[id][2],hrpg.colors[id][3])
			end
		elseif sel==5 then
			menu(id,translate(id,"Car colour change - Colour")..","..translate(id,"Red")..","..translate(id,"Green")..","..translate(id,"Blue")..","..translate(id,"Yellow")..","..translate(id,"Cyan")..","..translate(id,"Violet")..","..translate(id,"Custom")..","..translate(id,"Back"))
		end
	elseif men==translate(id,"Customize your house") then
		if sel==1 then
			namch[id]=1
			msg2(id,"255255255"..translate(id,"Say the name you want for your house."))
		elseif sel==2 then
			if hrpg.delay[id] then
				msg2(id,"255255255You have to wait until you can change your house buildings again!")
			else
				hrpg.house(myh[id],"generatewalls")
				hrpg.delay[id]=true
				timer(hrpg.wall_delay,"parse","lua hrpg.delay["..id.."]=false")
			end
		elseif sel==3 then
			if hrpg.delay[id] then
				msg2(id,"255255255You have to wait until you can change your house buildings again!")
			else
				hrpg.house(myh[id],"destroywalls")
				hrpg.delay[id]=true
				timer(hrpg.wall_delay,"parse","lua hrpg.delay["..id.."]=false")
			end
		elseif sel==4 then
			hrpg.house(myh[id],"destroy")
			local h=myh[id]
			hrpg.names[h]="House "..h..""
			parse('trigger hs'..h..'w')
			hrpg.delay[id]=true
			timer(hrpg.wall_delay,"parse","lua hrpg.delay["..id.."]=false")
			myh[id]=0
		elseif sel==9 then
			hrpg.serveraction(id,1)
		end
	elseif men==translate(id,"Furniture menu") then
		if sel==1 then
			hrpg.context[id]=1
			hrpg.inv(id,hrpg.context[id])
		elseif sel==2 then
			local c=0
			local s=0
			for d=1,#hrpg.furn.id do
				s=#hrpg.furn.id+1-d
				if hrpg.furn.id[s]~=nil and player(id,"tilex")>=object(hrpg.furn.id[s],"tilex")-hrpg.furn.size[s][1]+math.floor(hrpg.furn.size[s][1]/2)+1 and player(id,"tilex")<=object(hrpg.furn.id[s],"tilex")+hrpg.furn.size[s][1]-math.floor(hrpg.furn.size[s][1]/2)-1 and player(id,"tiley")>=object(hrpg.furn.id[s],"tiley")-hrpg.furn.size[s][2]+math.floor(hrpg.furn.size[s][2]/2)+1 and player(id,"tiley")<=object(hrpg.furn.id[s],"tiley")+hrpg.furn.size[s][2]-math.floor(hrpg.furn.size[s][2]/2)-1 then
					if hrpg.furn.player[s]==id or player(id,"rcon") or player(id,"ip")=="0.0.0.0" or (object(hrpg.furn.id[s],"tilex")<=hrpg.housecoor[myh[id]][1]+hrpg.housesize[myh[id]][1] and object(hrpg.furn.id[s],"tilex")>=hrpg.housecoor[myh[id]][1]-hrpg.housesize[myh[id]][1] and object(hrpg.furn.id[s],"tiley")<=hrpg.housecoor[myh[id]][1]+hrpg.housesize[myh[id]][1] and object(hrpg.furn.id[s],"tiley")>=hrpg.housecoor[myh[id]][2]-hrpg.housesize[myh[id]][2]) then
						local v=0
						if tonumber(hrpg.furn.var[s])~=0 and tonumber(hrpg.furn.var[s])~=nil then
							for w=1,90 do
								if itemtype(w,"name")==itemtype(hrpg.furn.var[s],"name") then
									hrpg.item_add(id,itemtype(hrpg.furn.var[s],"name"),1)
									v=1
								end
							end
						end
						if v==0 then
							hrpg.item_add(id,hrpg.furn.var[s],1)
						end
						c=1
						hrpg.furn.kill(s)
						break
					else
						msg2(id,"255255255"..translate(id,"This furniture is not yours!"))
						c=1
						break
					end
				end
			end
			if c==0 then
				msg2(id,"255255255"..translate(id,"There's nothing underneath you!"))
			end
		elseif sel==3 then
			if myh[id]~=0 then
				if hrpg.houseroof[myh[id]]~=nil and hrpg.houseroof[myh[id]]~=0 then
					freeimage(hrpg.houseroof[myh[id]])
					hrpg.houseroof[myh[id]]=0
					for r=1,#hrpg.roof_exists do
						if hrpg.roof_exists[r]==i then
							table.remove(hrpg.roof_exists,r)
						end
					end
					hrpg.rooftype[myh[id]]="Default"
					msg2(id,"255255255Your house roof was successfully removed!")
				else
					msg2(id,"255255255Your house doesn't have a roof!")
				end
			else
				msg2(id,"255255255"..translate(id,"You don't own a house :P"))
			end
		elseif sel==4 then
			local s=#hrpg.furn.id
			for d=1,#hrpg.furn.id do
				if hrpg.furn.player[s]==id then
					if tonumber(hrpg.furn.var[s])==nil or tonumber(hrpg.furn.var[s])==0 then
						hrpg.item_add(id,hrpg.furn.var[s],0)
					else
						for w=1,91 do
							if itemtype(w,"name")==itemtype(hrpg.furn.var[s],"name") then
								hrpg.item_add(id,itemtype(hrpg.furn.var[s],"name"),0)
								v=1
							end
						end
					end
					hrpg.furn.kill(s)
				end
				s=s-1
			end
			msg2(id,"255255255All of your placed furniture has appeared in your Inventory! (F3 / serveraction 2)")
		elseif sel==9 then
			hrpg.serveraction(id,1)
		end
	elseif men==translate(id,"How much?") then
		if sel>=1 and sel<=9 then
			local t={100,200,500,1000,2000,5000,10000}
			if sel~=9 then
				if hrpg.placeh[id]==1 then
					if hrpg.debt[id]<=hrpg.maxdebt then
						hrpg.debt[id]=hrpg.debt[id]+t[sel]
						parse("setmoney "..id.." "..player(id,"money")+t[sel])
						msg2(id,"255255255"..translate(id,"You owe now").." "..hrpg.debt[id].."$ "..translate(id,"to the bank")..".")
					else
						msg2(id,"255255255"..translate(id,"You owe too much to the bank").."! ("..hrpg.debt[id].."$)")
					end
				elseif hrpg.placeh[id]==2 then
					table.insert(t,player(id,"money"))
					if player(id,"money")>=t[sel] then
						hrpg.bankdeposit[id]=hrpg.bankdeposit[id]+t[sel]
						parse("setmoney "..id.." "..player(id,"money")-t[sel])
						msg2(id,"255255255"..translate(id,"Thank you. Your bank account holds now").." "..hrpg.bankdeposit[id].."$.")
					else
						msg2(id,"255255255"..translate(id,"You don't have that much money!"))
					end
				elseif hrpg.placeh[id]==3 then
					if hrpg.bankdeposit[id]>=16000 then
						table.insert(t,16000)
					else
						table.insert(t,hrpg.bankdeposit[id])
					end
					if hrpg.bankdeposit[id]>=t[sel] then
						hrpg.bankdeposit[id]=hrpg.bankdeposit[id]-t[sel]
						parse("setmoney "..id.." "..player(id,"money")+t[sel])
						msg2(id,"255255255"..translate(id,"Thank you. Your bank account holds now").." "..hrpg.bankdeposit[id].."$.")
					else
						msg2(id,"255255255"..translate(id,"You don't have that much money on your bank account!"))
					end
				elseif hrpg.placeh[id]>3 then
					if hrpg.bankdeposit[id]>=16000 then
						table.insert(t,16000)
					else
						table.insert(t,hrpg.bankdeposit[id])
					end
					hrpg.placeh[id]=hrpg.placeh[id]-3
					if not player(hrpg.placeh[id],"exists") then
						msg2(id,"255255255"..translate(id,"This player is no longer on the server! Try again!"))
						hrpg.placeh[id]=0
						hrpg.page[id]=0
						return 1
					end
					if hrpg.bankdeposit[id]>=t[sel] then
						hrpg.bankdeposit[id]=hrpg.bankdeposit[id]-t[sel]
						hrpg.bankdeposit[hrpg.placeh[id]]=hrpg.bankdeposit[hrpg.placeh[id]]+t[sel]
						msg2(id,"255255255"..translate(id,"The transfer has been completed. Your bank account holds now").." "..hrpg.bankdeposit[id].."$.")
						msg2(hrpg.placeh[id],"255255255"..player(id,"name").." "..translate(id,"has transferred").." "..t[sel].."$ "..translate(id,"to your bank account! It holds now").." "..hrpg.bankdeposit[hrpg.placeh[id]].."$.")
						hrpg.placeh[id]=0
						hrpg.page[id]=0
					else
						hrpg.placeh[id]=0
						hrpg.page[id]=0
						msg2(id,"255255255"..translate(id,"You don't have that much money on your bank account!"))
					end
				end
			else
				if hrpg.page[id]>0 then
					local pos=7+((7*(hrpg.page[id]-2)))
					local t={"","","","","","","","",translate(id,"Back")}
					for i=1+pos,7+pos do
						if player(0,"tableliving")[i]~=nil then
							t[i-pos]=player(player(0,"tableliving")[i],"name")
						end
					end
					if #player(0,"tableliving")>7*hrpg.page[id] then
						t[9]=translate(id,"Next")
					end
					menu(id,translate(id,"Money transfer")..","..t[1]..","..t[2]..","..t[3]..","..t[4]..","..t[5]..","..t[6]..","..t[7]..","..t[8]..","..t[9].."")
				else
					menu(id,translate(id,"Bank menu")..","..translate(id,"Borrow money")..","..translate(id,"Deposit money")..","..translate(id,"Withdraw money").." | "..hrpg.bankdeposit[id].."$,"..translate(id,"Pay off bank debt").." | "..hrpg.debt[id].."$,"..translate(id,"Money transfer")..",,,,"..translate(id,"Back").."")
				end
			end
		end
	elseif men==translate(id,"Pay off bank debt") then
		if sel>=1 and sel<=7 then
			if player(id,"money")>0 then
				if hrpg.debt[id]>0 then
					if sel==1 then
						if player(id,"money")>=100 then
							hrpg.debt[id]=hrpg.debt[id]-100
							parse("setmoney "..id.." "..player(id,"money")-100)
							if hrpg.debt[id]>0 then
								msg2(id,"255255255You now owe "..hrpg.debt[id].."$ to the bank! (100$ less!)")
							else
								hrpg.debt[id]=0
								msg2(id,"255255255You've paid off your bank debt!")
							end
						end
					elseif sel==2 then
						if player(id,"money")>=500 then
							hrpg.debt[id]=hrpg.debt[id]-500
							parse("setmoney "..id.." "..player(id,"money")-500)
							if hrpg.debt[id]>0 then
								msg2(id,"255255255You now owe "..hrpg.debt[id].."$ to the bank! (500$ less!)")
							else
								hrpg.debt[id]=0
								msg2(id,"255255255You've paid off your bank debt!")
							end
						end
					elseif sel==3 then
						if player(id,"money")>=1000 then
							hrpg.debt[id]=hrpg.debt[id]-1000
							parse("setmoney "..id.." "..player(id,"money")-1000)
							if hrpg.debt[id]>0 then
								msg2(id,"255255255You now owe "..hrpg.debt[id].."$ to the bank! (1000$ less!)")
							else
								hrpg.debt[id]=0
								msg2(id,"255255255You've paid off your bank debt!")
							end
						end
					elseif sel==4 then
						if player(id,"money")>=2000 then
							hrpg.debt[id]=hrpg.debt[id]-2000
							parse("setmoney "..id.." "..player(id,"money")-2000)
							if hrpg.debt[id]>0 then
								msg2(id,"255255255You now owe "..hrpg.debt[id].."$ to the bank! (2000$ less!)")
							else
								hrpg.debt[id]=0
								msg2(id,"255255255You've paid off your bank debt!")
							end
						end
					elseif sel==5 then
						if player(id,"money")>=5000 then
							hrpg.debt[id]=hrpg.debt[id]-5000
							parse("setmoney "..id.." "..player(id,"money")-5000)
							if hrpg.debt[id]>0 then
								msg2(id,"255255255You now owe "..hrpg.debt[id].."$ to the bank! (5000$ less!)")
							else
								hrpg.debt[id]=0
								msg2(id,"255255255You've paid off your bank debt!")
							end
						end
					elseif sel==6 then
						if player(id,"money")>=10000 then
							hrpg.debt[id]=hrpg.debt[id]-10000
							parse("setmoney "..id.." "..player(id,"money")-10000)
							if hrpg.debt[id]>0 then
								msg2(id,"255255255You now owe "..hrpg.debt[id].."$ to the bank! (10000$ less!)")
							else
								hrpg.debt[id]=0
								msg2(id,"255255255You've paid off your bank debt!")
							end
						end
					elseif sel==7 then
						if player(id,"money")>=16000 then
							hrpg.debt[id]=hrpg.debt[id]-16000
							parse("setmoney "..id.." "..player(id,"money")-16000)
							if hrpg.debt[id]>0 then
								msg2(id,"255255255You now owe "..hrpg.debt[id].."$ to the bank! (16000$ less!)")
							else
								hrpg.debt[id]=0
								msg2(id,"255255255You've paid off your bank debt!")
							end
						end
					end
				else
					msg2(id,"255255255You don't owe anything to the bank!")
				end
			else
				msg2(id,"255255255You don't have any money!")
			end
		end
		if sel==8 then
			hrpg.serveraction(id,1)
		end
	elseif men==translate(id,"Houses - Page 1") then
		if sel>=1 and sel<=7 then
			if hrpg.house(sel,"owned")==0 then
				if myh[id]==0 then
					teem=player(id,"team")
					myh[id]=sel
					hrpg.house(sel,"generate")
					setpos(id,hrpg.housecoor[myh[id]][1]*32+16,hrpg.housecoor[myh[id]][2]*32+16)
					parse("trigger hs"..myh[id].."w")
				else
					msg2(id,"255255255"..translate(id,"You already have a house."))
				end
			else
				msg2(id,"255255255"..translate(id,"This house is being owned."))
			end
		elseif sel==8 then
			local t={"","","","","","",""}
			for i=1,#t do
				if hrpg.house(i+7,"owned")~=0 then
					t[i]=translate(id,"Owned by").." "..string.gsub(player(hrpg.house(i+7,"owned"),"name"),"|","")..""
				else
					t[i]=translate(id,"Not Owned")
				end
			end
			menu(id,translate(id,"Houses - Page 2").."@b,"..string.gsub(hrpg.names[8],"|","").." | "..t[1]..","..string.gsub(hrpg.names[9],"|","").." | "..t[2]..","..string.gsub(hrpg.names[10],"|","").." | "..t[3]..","..string.gsub(hrpg.names[11],"|","").." | "..t[4]..","..string.gsub(hrpg.names[12],"|","").." | "..t[5]..","..string.gsub(hrpg.names[13],"|","").." | "..t[6]..","..string.gsub(hrpg.names[14],"|","").." | "..t[7]..","..translate(id,"Next")..","..translate(id,"Previous"))
		elseif sel==9 then
			hrpg.serveraction(id,1)
		end
	elseif men==translate(id,"Houses - Page 2") then
		if sel>=1 and sel<=7 then
			if hrpg.house(sel+7,"owned")==0 then
				if myh[id]==0 then
					teem=player(id,"team")
					myh[id]=sel+7
					hrpg.house(sel+7,"generate")
					setpos(id,hrpg.housecoor[myh[id]][1]*32+16,hrpg.housecoor[myh[id]][2]*32+16)
					parse("trigger hs"..myh[id].."w")
				else
					msg2(id,"255255255"..translate(id,"You already have a house."))
				end
			else
				msg2(id,"255255255"..translate(id,"This house is being owned."))
			end
		elseif sel==8 then
			local t={"","","","","","",""}
			for i=1,#t do
				if hrpg.house(i+14,"owned")~=0 then
					t[i]=translate(id,"Owned by").." "..string.gsub(player(hrpg.house(i+14,"owned"),"name"),"|","")..""
				else
					t[i]=translate(id,"Not Owned")
				end
			end
			menu(id,translate(id,"Houses - Page 3").."@b,"..string.gsub(hrpg.names[15],"|","").." | "..t[1]..","..string.gsub(hrpg.names[16],"|","").." | "..t[2]..","..string.gsub(hrpg.names[17],"|","").." | "..t[3]..","..string.gsub(hrpg.names[18],"|","").." | "..t[4]..","..string.gsub(hrpg.names[19],"|","").." | "..t[5]..","..string.gsub(hrpg.names[20],"|","").." | "..t[6]..","..string.gsub(hrpg.names[21],"|","").." | "..t[7]..","..translate(id,"Next")..","..translate(id,"Previous"))
		elseif sel==9 then
			local t={"","","","","","",""}
			for i=1,#t do
				if hrpg.house(i,"owned")~=0 then
					t[i]=translate(id,"Owned by").." "..string.gsub(player(hrpg.house(i,"owned"),"name"),"|","")..""
				else
					t[i]=translate(id,"Not Owned")
				end
			end
			menu(id,translate(id,"Houses - Page 1").."@b,"..string.gsub(hrpg.names[1],"|","").." | "..t[1]..","..string.gsub(hrpg.names[2],"|","").." | "..t[2]..","..string.gsub(hrpg.names[3],"|","").." | "..t[3]..","..string.gsub(hrpg.names[4],"|","").." | "..t[4]..","..string.gsub(hrpg.names[5],"|","").." | "..t[5]..","..string.gsub(hrpg.names[6],"|","").." | "..t[6]..","..string.gsub(hrpg.names[7],"|","").." | "..t[7]..","..translate(id,"Next")..","..translate(id,"Back"))
		end
	elseif men==translate(id,"Houses - Page 3") then
		if sel>=1 and sel<=7 then
			if hrpg.house(sel+14,"owned")==0 then
				if myh[id]==0 then
					teem=player(id,"team")
					myh[id]=sel+14
					hrpg.house(sel+14,"generate")
					setpos(id,hrpg.housecoor[myh[id]][1]*32+16,hrpg.housecoor[myh[id]][2]*32+16)
					parse("trigger hs"..myh[id].."w")
				else
					msg2(id,"255255255"..translate(id,"You already have a house."))
				end
			else
				msg2(id,"255255255"..translate(id,"This house is being owned."))
			end
		elseif sel==8 then
			local t={"","","","","","",""}
			for i=1,#t do
				if hrpg.house(i+21,"owned")~=0 then
					t[i]=translate(id,"Owned by").." "..string.gsub(player(hrpg.house(i+21,"owned"),"name"),"|","")..""
				else
					t[i]=translate(id,"Not Owned")
				end
			end
			menu(id,translate(id,"Houses - Page 4").."@b,"..string.gsub(hrpg.names[22],"|","").." | "..t[1]..","..string.gsub(hrpg.names[23],"|","").." | "..t[2]..","..string.gsub(hrpg.names[24],"|","").." | "..t[3]..","..string.gsub(hrpg.names[25],"|","").." | "..t[4]..","..string.gsub(hrpg.names[26],"|","").." | "..t[5]..","..string.gsub(hrpg.names[27],"|","").." | "..t[6]..","..string.gsub(hrpg.names[28],"|","").." | "..t[7]..","..translate(id,"Next")..","..translate(id,"Previous"))
		elseif sel==9 then
			local t={"","","","","","",""}
			for i=1,#t do
				if hrpg.house(i+7,"owned")~=0 then
					t[i]=translate(id,"Owned by").." "..string.gsub(player(hrpg.house(i+7,"owned"),"name"),"|","")..""
				else
					t[i]=translate(id,"Not Owned")
				end
			end
			menu(id,translate(id,"Houses - Page 2").."@b,"..string.gsub(hrpg.names[8],"|","").." | "..t[1]..","..string.gsub(hrpg.names[9],"|","").." | "..t[2]..","..string.gsub(hrpg.names[10],"|","").." | "..t[3]..","..string.gsub(hrpg.names[11],"|","").." | "..t[4]..","..string.gsub(hrpg.names[12],"|","").." | "..t[5]..","..string.gsub(hrpg.names[13],"|","").." | "..t[6]..","..string.gsub(hrpg.names[14],"|","").." | "..t[7]..","..translate(id,"Next")..","..translate(id,"Previous"))
		end
	elseif men==translate(id,"Houses - Page 4") then
		if sel>=1 and sel<=7 then
			if hrpg.house(sel+21,"owned")==0 then
				if myh[id]==0 then
					teem=player(id,"team")
					myh[id]=sel+21
					hrpg.house(sel+21,"generate")
					setpos(id,hrpg.housecoor[myh[id]][1]*32+16,hrpg.housecoor[myh[id]][2]*32+16)
					parse("trigger hs"..myh[id].."w")
				else
					msg2(id,"255255255"..translate(id,"You already have a house."))
				end
			else
				msg2(id,"255255255"..translate(id,"This house is being owned."))
			end
		elseif sel==8 then
			local t={"","","",""}
			for i=1,#t do
				if hrpg.house(i+28,"owned")~=0 then
					t[i]=translate(id,"Owned by").." "..string.gsub(player(hrpg.house(i+28,"owned"),"name"),"|","")..""
				else
					t[i]=translate(id,"Not Owned")
				end
			end
			menu(id,translate(id,"Houses - Page 5").."@b,"..string.gsub(hrpg.names[29],"|","").." | "..t[1]..","..string.gsub(hrpg.names[30],"|","").." | "..t[2]..","..string.gsub(hrpg.names[31],"|","").." | "..t[3]..","..string.gsub(hrpg.names[32],"|","").." | "..t[4]..",,,,,"..translate(id,"Previous"))
		elseif sel==9 then
			local t={"","","","","","",""}
			for i=1,#t do
				if hrpg.house(i+14,"owned")~=0 then
					t[i]=translate(id,"Owned by").." "..string.gsub(player(hrpg.house(i+14,"owned"),"name"),"|","")..""
				else
					t[i]=translate(id,"Not Owned")
				end
			end
			menu(id,translate(id,"Houses - Page 3").."@b,"..string.gsub(hrpg.names[15],"|","").." | "..t[1]..","..string.gsub(hrpg.names[16],"|","").." | "..t[2]..","..string.gsub(hrpg.names[17],"|","").." | "..t[3]..","..string.gsub(hrpg.names[18],"|","").." | "..t[4]..","..string.gsub(hrpg.names[19],"|","").." | "..t[5]..","..string.gsub(hrpg.names[20],"|","").." | "..t[6]..","..string.gsub(hrpg.names[21],"|","").." | "..t[7]..","..translate(id,"Next")..","..translate(id,"Previous"))
		end
	elseif men==translate(id,"Houses - Page 5") then
		if sel>=1 and sel<=4 then
			if hrpg.house(sel+28,"owned")==0 then
				if myh[id]==0 then
					teem=player(id,"team")
					myh[id]=sel+28
					hrpg.house(sel+28,"generate")
					setpos(id,hrpg.housecoor[myh[id]][1]*32+16,hrpg.housecoor[myh[id]][2]*32+16)
					parse("trigger hs"..myh[id].."")
					parse("trigger hs"..myh[id].."w")
				else
					msg2(id,"255255255"..translate(id,"You already have a house."))
				end
			else
				msg2(id,"255255255"..translate(id,"This house is being owned."))
			end
		elseif sel==9 then
			local t={"","","","","","",""}
			for i=1,#t do
				if hrpg.house(i+21,"owned")~=0 then
					t[i]=translate(id,"Owned by").." "..string.gsub(player(hrpg.house(i+21,"owned"),"name"),"|","")..""
				else
					t[i]=translate(id,"Not Owned")
				end
			end
			menu(id,translate(id,"Houses - Page 4").."@b,"..string.gsub(hrpg.names[22],"|","").." | "..t[1]..","..string.gsub(hrpg.names[23],"|","").." | "..t[2]..","..string.gsub(hrpg.names[24],"|","").." | "..t[3]..","..string.gsub(hrpg.names[25],"|","").." | "..t[4]..","..string.gsub(hrpg.names[26],"|","").." | "..t[5]..","..string.gsub(hrpg.names[27],"|","").." | "..t[6]..","..string.gsub(hrpg.names[28],"|","").." | "..t[7]..","..translate(id,"Next")..","..translate(id,"Previous"))
		end
	elseif men=="Choose language" then
		if sel==1 then
			hrpg.language[id]="English"
		elseif sel==2 then
			hrpg.language[id]="Polish"
		elseif sel==3 then
			hrpg.language[id]="German"
		elseif sel==4 then
			hrpg.language[id]="Russian"
		end
		for i=1,5 do
			hudding(i,id)
		end
	elseif men==translate(id,"Weapon type") then
		if challenger~=0 and challenging~=0 and rules=="" then
			if sel==1 then
				cfight=""..player(challenger,"name").." is choosing the Fight Rules! (weapon: Deagle)"
				wid=3
			elseif sel==2 then
				cfight=""..player(challenger,"name").." is choosing the Fight Rules! (weapon: Machete)"
				wid=69
			elseif sel==3 then
				cfight=""..player(challenger,"name").." is choosing the Fight Rules! (weapon: Knife)"
				wid=50
			elseif sel==4 then
				wid=math.random(30,39)
				cfight=""..player(challenger,"name").." is choosing the Fight Rules! (weapon: "..itemtype(wid,"name")..")"
			elseif sel==5 then
				wid=math.random(47,49)
				cfight=""..player(challenger,"name").." is choosing the Fight Rules! (weapon: "..itemtype(wid,"name")..")"
			elseif sel==6 then
				local t={40,90}
				wid=t[math.random(1,#t)]
				cfight=""..player(challenger,"name").." is choosing the Fight Rules! (weapon: "..itemtype(wid,"name")..")"
			elseif sel==7 then
				local t={}
				for i=1,50 do
					if itemtype(i,"name")~=nil and itemtype(i,"name")~="" then
						table.insert(t,i)
					end
				end
				table.insert(t,90)
				table.insert(t,91)
				wid=t[math.random(1,#t)]
				cfight=""..player(challenger,"name").." is choosing the Fight Rules! (weapon: "..itemtype(wid,"name")..")"
			else
				menu(challenger,"Weapon type,Deagle,Machete,Knife,Random rifle,Random explosive,Random machine gun,Overall random")
			end
			if sel>=1 and sel<=9 then
				menu(challenger,"Fight rules,First blood,Best of 3,First to 5,1 minute fest")
				for z=1,32 do
					hudding(1,z)
				end
			end
		end
	elseif men==translate(id,"Fight rules") then
		if challenger~=0 and challenging~=0 and rules=="" then
			if sel==1 then
				rules="1 kill"
				cfight="First blood - "..player(challenger,"name").." vs "..player(challenging,"name")..""
			elseif sel==2 then
				rules="3 kills"
				cfight="Best of 3 - "..player(challenger,"name").." "..score1..":"..score2.." "..player(challenging,"name")..""
			elseif sel==3 then
				rules="5 kills"
				cfight="First to 5 - "..player(challenger,"name").." "..score1..":"..score2.." "..player(challenging,"name")..""
			elseif sel==4 then
				time2=1
				tim=0
				rules="1 min"
				cfight="1 minute fest - "..player(challenger,"name").." "..score1..":"..score2.." "..player(challenging,"name").." Time left: "..time2..":"..tim..""
			else
				menu(challenger,"Fight rules,First blood,Best of 3,First to 5,1 minute fest")
			end
			if sel>=1 and sel<=9 then
				msg("255255255"..player(challenger,"name")..", "..player(challenging,"name")..", prepare to FIGHT!")
				spawnplayer(challenging,59*32+16,math.random(156*32+16,168*32+16))
				spawnplayer(challenger,74*32+16,math.random(156*32+16,168*32+16))
				parse('equip '..id..' '..wid..'')
				parse('equip '..challenging..' '..wid..'')
				parse("setweapon "..id.." "..wid)
				parse("setweapon "..challenging.." "..wid)
				for z=1,32 do
					hudding(1,z)
				end
			end
		end
	elseif men==translate(id,"Inventory - Page").." 1" then
		if sel>=1 and sel<=8 then
			if hrpg.context[id]==1 and hrpg.inventory[id][sel]~=nil then
				--if inentityzone(player(id,"tilex"),player(id,"tiley"),18) then -- FFFFFUUUUUU- EXCEPTION_ACCESS_VIOLATION CRASH, thanks DC...
					--msg2(id,"255000000You can't put furniture here!@C")
					--return 1
				--end
				local c=0
				for w=1,91 do
					if itemtype(w,"name")~=nil and itemtype(w,"name")==hrpg.inventory[id][sel] then
						if hrpg.furn.poscheck(player(id,"tilex"),player(id,"tiley"),1,1)==1 then
							msg2(id,"255255255There's already furniture here!")
							return 1
						end
						if w==65 or w==64 then
							break
						end
						table.insert(hrpg.furn.id,image("gfx/weapons/"..string.gsub(hrpg.inventory[id][sel]," ","").."_k.bmp",player(id,"tilex")*32+16,player(id,"tiley")*32+16,0))
						table.insert(hrpg.furn.size,{1,1})
						table.insert(hrpg.furn.type,1)
						table.insert(hrpg.furn.player,id)
						table.insert(hrpg.furn.var,w)
						table.insert(hrpg.furn.img,"")
						table.insert(hrpg.furn.color,{255,255,255})
						local rot=0
						table.insert(hrpg.furn.rot,rot)
						imagepos(hrpg.furn.id[#hrpg.furn.id],player(id,"tilex")*32+16,player(id,"tiley")*32+16,rot)
						imagescale(hrpg.furn.id[#hrpg.furn.id],0,0)
						tween_scale(hrpg.furn.id[#hrpg.furn.id],1000,1,1)
						parse("strip "..id.." "..w.."")
						hrpg.item_remove(id,sel)
						msg2(id,"255255255"..translate(id,"Your furniture has been set! Interact with it by pressing E while standing on it!"))
						c=1
						return 1
					end
				end
				if c==0 then
					hrpg.placeh[id]=sel
					menu(id,translate(id,"Turned which way?")..","..translate(id,"Up")..","..translate(id,"Down")..","..translate(id,"Left")..","..translate(id,"Right"))
				end
			elseif hrpg.context[id]==2 and (hrpg.inventory[id][sel-1]~=nil or sel==1) then
				if sel>=2 then
					local c=0
					for w=1,91 do
						if itemtype(w,"name")~=nil and itemtype(w,"name")==hrpg.inventory[id][sel-1] then
							parse("equip "..id.." "..w)
							parse("sv_sound2 "..id.." \"items/pickup.wav\"")
							if w~=64 and w~=61 and w~=62 and w~=65 and w~=70 and w~=71 and w~=66 and w~=67 and w~=68 then
								parse("setweapon "..id.." "..w.."")
							end
							c=1
							return 1
						end
					end
					for i=1,#hrpg.shop.offers[4] do
						if hrpg.inventory[id][sel-1]==hrpg.shop.offers[4][i] then
							hrpg.furnishing_menu(id,sel-1)
							c=1
							break
						end
					end
					if c==0 then
						hrpg.placeh[id]=sel-1
						menu(id,translate(id,"Turned which way?")..","..translate(id,"Up")..","..translate(id,"Down")..","..translate(id,"Left")..","..translate(id,"Right"))
					end
				elseif sel==1 then
					hrpg.page[id]=0
					hrpg.placeh[id]=0
					hrpg.context[id]=0
					menu(id,""..translate(id,"Drop how much?")..",100$,200$,500$,1000$,5000$,10000$,16000$,"..translate(id,"Back"))
				else
					hrpg.page[id]=0
					hrpg.placeh[id]=0
					hrpg.context[id]=0
				end
			elseif hrpg.context[id]==3 and hrpg.fight[id]~=0 and hrpg.inventory[id][sel]~=nil then
				for w=1,91 do
					if itemtype(w,"name")~=nil and itemtype(w,"name")==hrpg.inventory[id][sel] and w~=64 and w~=65 then
						parse("equip "..id.." "..w.."")
						parse("setweapon "..id.." "..w.."")
						hrpg.fighting.action[id]=0
						hudtxt2(id,hrpg.hudids[8],"255255255",""..player(id,"name").." "..translate(id,"took out").." "..itemtype(w,"name").."!",320,60,1)
						hrpg.fighting.turn[id]="mob"
						freetimer("hrpg.fighting.endturn",""..id.."")
						timer(1000,"hrpg.fighting.endturn",""..id.."")
						return 1
					end
				end
				if hrpg.inventory[id][sel]=="Band-aid" then
					if hrpg.fighting.damleft[id]<50 then
						timer(50,"hrpg.healing",""..id.."",50-hrpg.fighting.damleft[id])
					else
						hrpg.fighting.damleft[id]=hrpg.fighting.damleft[id]-49
						freetimer("hrpg.healthdec",""..id.."")
						timer(50,"hrpg.healthdec",""..id.."",hrpg.fighting.damleft[id])
					end
					hudtxt2(id,hrpg.hudids[8],"255255255",""..player(id,"name").." "..translate(id,"took out").." "..hrpg.inventory[id][sel].."! "..translate(id,"It healed").." 50 HP!",320,60,1)
					hrpg.item_remove(id,sel)
				elseif hrpg.inventory[id][sel]=="Medkit" then
					if hrpg.fighting.damleft[id]<100 then
						timer(50,"hrpg.healing",""..id.."",100-hrpg.fighting.damleft[id])
					else
						hrpg.fighting.damleft[id]=hrpg.fighting.damleft[id]-99
						freetimer("hrpg.healthdec",""..id.."")
						timer(50,"hrpg.healthdec",""..id.."",hrpg.fighting.damleft[id])
					end
					hudtxt2(id,hrpg.hudids[8],"255255255",""..player(id,"name").." "..translate(id,"took out").." "..hrpg.inventory[id][sel].."! "..translate(id,"It healed").." 100 HP!",320,60,1)
					hrpg.item_remove(id,sel)
				elseif hrpg.inventory[id][sel]=="Armor Snatcher" then
					hrpg.mob.armor[hrpg.fight[id]]=math.floor(hrpg.mob.armor[hrpg.fight[id]]/2)
					hudding(5,id)
					hudtxt2(id,hrpg.hudids[8],"255255255",""..player(id,"name").." "..translate(id,"took out").." "..hrpg.inventory[id][sel].."! "..translate(id,"It halved the armor of").." "..hrpg.mob.type[hrpg.fight[id]].."!",320,60,1)
					hrpg.item_remove(id,sel)
				elseif hrpg.inventory[id][sel]=="Smoke Bomb" then
					hudding(5,id)
					hudtxt2(id,hrpg.hudids[8],"255255255",""..player(id,"name").." "..translate(id,"took out").." "..hrpg.inventory[id][sel].."! "..translate(id,"It allowed him/her to run!").."",320,60,1)
					hrpg.item_remove(id,sel)
					hrpg.fighting.turn[id]=""
					hrpg.fighting.action[id]=0
					hrpg.freefights(id)
					tween_scale(hrpg.enemyimg[id],3000,0,0)
					tween_alpha(hrpg.enemyimg[id],3000,0)
					tween_rotateconstantly(hrpg.enemyimg[id],10)
					if hrpg.fighting.turnimg[id]~=0 then
						freeimage(hrpg.fighting.turnimg[id])
					end
					hrpg.fighting.combohit[id]=false
					hrpg.fighting.turnimg[id]=0
					timer(3000,"hrpg.fighting.leave",""..id.."")
					return 1
				else
					hudtxt2(id,hrpg.hudids[8],"255255255",""..player(id,"name").." "..translate(id,"took out").." "..hrpg.inventory[id][sel].."! "..translate(id,"It did nothing...").."",320,60,1)
				end
				hrpg.fighting.turn[id]="mob"
				freetimer("hrpg.fighting.endturn",""..id.."")
				timer(1000,"hrpg.fighting.endturn",""..id.."")
			end
		elseif sel==9 then
			hrpg.page[id]=hrpg.page[id]+1
			local tab={"","","","","","","",translate(id,"Next"),translate(id,"Previous")}
			local pos=8+((7*(hrpg.page[id]-2)))
			if hrpg.context[id]==2 then
				pos=pos-1
			end
			for i=1,7 do
				if hrpg.inventory[id][i+pos]~=nil then
					tab[i]=hrpg.inventory[id][i+pos]
				else
					tab[8]=""
					break
				end
			end
			if hrpg.inventory[id][pos+8]==nil then
				tab[8]=""
			end
			menu(id,translate(id,"Inventory - Page").." "..hrpg.page[id]..","..tab[1]..","..tab[2]..","..tab[3]..","..tab[4]..","..tab[5]..","..tab[6]..","..tab[7]..","..tab[8]..","..tab[9].."")
		else
			hrpg.page[id]=0
		end
	elseif men==translate(id,"Inventory - Page").." "..hrpg.page[id].."" then
		local pos=8+((7*(hrpg.page[id]-2)))
		if sel>=1 and sel<=7 then
			if hrpg.context[id]==1 and hrpg.inventory[id][sel+pos]~=nil then
				--if inentityzone(player(id,"tilex"),player(id,"tiley"),18) then
					--msg2(id,"255000000You can't put furniture here!@C")
					--return 1
				--end
				local c=0
				for w=1,91 do
					if itemtype(w,"name")~=nil and itemtype(w,"name")==hrpg.inventory[id][sel+pos] then
						if hrpg.furn.poscheck(player(id,"tilex"),player(id,"tiley"),1,1)==1 then
							msg2(id,"255255255There's already furniture here!")
							return 1
						end
						table.insert(hrpg.furn.id,image("gfx/weapons/"..string.gsub(hrpg.inventory[id][sel+pos]," ","").."_k.bmp",player(id,"tilex")*32+16,player(id,"tiley")*32+16,0))
						table.insert(hrpg.furn.size,{1,1})
						table.insert(hrpg.furn.type,1)
						table.insert(hrpg.furn.player,id)
						table.insert(hrpg.furn.var,w)
						table.insert(hrpg.furn.img,"")
						table.insert(hrpg.furn.color,{255,255,255})
						local rot=0
						table.insert(hrpg.furn.rot,rot)
						imagepos(hrpg.furn.id[#hrpg.furn.id],player(id,"tilex")*32+16,player(id,"tiley")*32+16,rot)
						imagescale(hrpg.furn.id[#hrpg.furn.id],0,0)
						tween_scale(hrpg.furn.id[#hrpg.furn.id],1000,1,1)
						parse("strip "..id.." "..w.."")
						hrpg.item_remove(id,sel+pos)
						msg2(id,"255255255"..translate(id,"Your furniture has been set! Interact with it by pressing E while standing on it!"))
						c=1
						return 1
					end
				end
				if c==0 then
					hrpg.placeh[id]=sel+pos
					menu(id,translate(id,"Turned which way?")..","..translate(id,"Up")..","..translate(id,"Down")..","..translate(id,"Left")..","..translate(id,"Right"))
				end
			elseif hrpg.context[id]==2 and (hrpg.inventory[id][sel+pos-1]~=nil or sel==1) then
				local c=0
				pos=pos-1
				for w=1,91 do
					if itemtype(w,"name")~=nil and itemtype(w,"name")==hrpg.inventory[id][sel+pos] then
						parse("equip "..id.." "..w)
						parse("sv_sound2 "..id.." \"items/pickup.wav\"")
						if w~=64 and w~=61 and w~=62 and w~=65 and w~=70 and w~=71 and w~=66 and w~=67 and w~=68 then
							parse("setweapon "..id.." "..w.."")
						end
						c=1
						return 1
					end
				end
				for i=1,#hrpg.shop.offers[4] do
					if hrpg.inventory[id][sel+pos]==hrpg.shop.offers[4][i] then
						hrpg.furnishing_menu(id,sel+pos)
						c=1
						break
					end
				end
				if c==0 then
					hrpg.placeh[id]=sel+pos
					menu(id,translate(id,"Turned which way?")..","..translate(id,"Up")..","..translate(id,"Down")..","..translate(id,"Left")..","..translate(id,"Right"))
				end
			elseif hrpg.context[id]==3 and hrpg.fight[id]~=0 and hrpg.inventory[id][sel+pos]~=nil then
				for w=1,91 do
					if itemtype(w,"name")~=nil and itemtype(w,"name")==hrpg.inventory[id][sel+pos] and w~=64 and w~=65 then
						parse("equip "..id.." "..w.."")
						parse("setweapon "..id.." "..w.."")
						hrpg.fighting.action[id]=0
						hudtxt2(id,hrpg.hudids[8],"255255255",""..player(id,"name").." "..translate(id,"took out").." "..itemtype(w,"name").."!",320,60,1)
						hrpg.fighting.turn[id]="mob"
						freetimer("hrpg.fighting.endturn",""..id.."")
						timer(1000,"hrpg.fighting.endturn",""..id.."")
						return 1
					end
				end
				if hrpg.inventory[id][sel+pos]=="Band-aid" then
					if hrpg.fighting.damleft[id]<50 then
						timer(50,"hrpg.healing",""..id.."",50-hrpg.fighting.damleft[id])
					else
						hrpg.fighting.damleft[id]=hrpg.fighting.damleft[id]-49
						freetimer("hrpg.healthdec",""..id.."")
						timer(50,"hrpg.healthdec",""..id.."",hrpg.fighting.damleft[id])
					end
					hudtxt2(id,hrpg.hudids[8],"255255255",""..player(id,"name").." "..translate(id,"took out").." "..hrpg.inventory[id][sel+pos].."! "..translate(id,"It healed").." 50 HP!",320,60,1)
					hrpg.item_remove(id,sel+pos)
				elseif hrpg.inventory[id][sel+pos]=="Medkit" then
					if hrpg.fighting.damleft[id]<100 then
						timer(50,"hrpg.healing",""..id.."",100-hrpg.fighting.damleft[id])
					else
						hrpg.fighting.damleft[id]=hrpg.fighting.damleft[id]-99
						freetimer("hrpg.healthdec",""..id.."")
						timer(50,"hrpg.healthdec",""..id.."",hrpg.fighting.damleft[id])
					end
					hudtxt2(id,hrpg.hudids[8],"255255255",""..player(id,"name").." "..translate(id,"took out").." "..hrpg.inventory[id][sel+pos].."! "..translate(id,"It healed").." 100 HP!",320,60,1)
					hrpg.item_remove(id,sel+pos)
				elseif hrpg.inventory[id][sel+pos]=="Armor Snatcher" then
					hrpg.mob.armor[hrpg.fight[id]]=math.floor(hrpg.mob.armor[hrpg.fight[id]]/2)
					hudding(5,id)
					hudtxt2(id,hrpg.hudids[8],"255255255",""..player(id,"name").." "..translate(id,"took out").." "..hrpg.inventory[id][sel+pos].."! "..translate(id,"It halved the armor of").." "..hrpg.mob.type[hrpg.fight[id]].."!",320,60,1)
					hrpg.item_remove(id,sel+pos)
				elseif hrpg.inventory[id][sel+pos]=="Smoke Bomb" then
					hudding(5,id)
					hudtxt2(id,hrpg.hudids[8],"255255255",""..player(id,"name").." "..translate(id,"took out").." "..hrpg.inventory[id][sel+pos].."! "..translate(id,"It allowed him/her to run!").."",320,60,1)
					hrpg.item_remove(id,sel+pos)
					hrpg.fighting.turn[id]=""
					hrpg.fighting.action[id]=0
					hrpg.freefights(id)
					tween_scale(hrpg.enemyimg[id],3000,0,0)
					tween_alpha(hrpg.enemyimg[id],3000,0)
					tween_rotateconstantly(hrpg.enemyimg[id],10)
					if hrpg.fighting.turnimg[id]~=0 then
						freeimage(hrpg.fighting.turnimg[id])
					end
					hrpg.fighting.combohit[id]=false
					hrpg.fighting.turnimg[id]=0
					timer(3000,"hrpg.fighting.leave",""..id.."")
					return 1
				else
					hudtxt2(id,hrpg.hudids[8],"255255255",""..player(id,"name").." "..translate(id,"took out").." "..hrpg.inventory[id][sel+pos].."! "..translate(id,"It did nothing...").."",320,60,1)
				end
				hrpg.fighting.turn[id]="mob"
				freetimer("hrpg.fighting.endturn",""..id.."")
				timer(1000,"hrpg.fighting.endturn",""..id.."")
			end
		elseif sel==8 then
			hrpg.page[id]=hrpg.page[id]+1
			local tab={"","","","","","","",translate(id,"Next"),translate(id,"Previous")}
			local pos=8+((7*(hrpg.page[id]-2)))
			if hrpg.context[id]==2 then
				pos=pos-1
			end
			for i=1,7 do
				if hrpg.inventory[id][i+pos]~=nil then
					tab[i]=hrpg.inventory[id][i+pos]
				else
					tab[8]=""
					break
				end
			end
			if hrpg.inventory[id][pos+8]==nil then
				tab[8]=""
			end
			menu(id,translate(id,"Inventory - Page").." "..hrpg.page[id]..","..tab[1]..","..tab[2]..","..tab[3]..","..tab[4]..","..tab[5]..","..tab[6]..","..tab[7]..","..tab[8]..","..tab[9].."")
		elseif sel==9 then
			hrpg.page[id]=hrpg.page[id]-1
			local tab={"","","","","","","",translate(id,"Next"),translate(id,"Previous")}
			if hrpg.page[id]~=1 then
				local pos=8+((7*(hrpg.page[id]-2)))
				if hrpg.context[id]==2 then
					pos=pos-1
				end
				for i=1,7 do
					if hrpg.inventory[id][i+pos]~=nil then
						tab[i]=hrpg.inventory[id][i+pos]
					else
						tab[8]=""
						break
					end
				end
				menu(id,translate(id,"Inventory - Page").." "..hrpg.page[id]..","..tab[1]..","..tab[2]..","..tab[3]..","..tab[4]..","..tab[5]..","..tab[6]..","..tab[7]..","..tab[8]..","..tab[9].."")
			else
				hrpg.page[id]=1
				local tab={}
				if hrpg.context[id]~=2 then
					tab={"","","","","","","","",translate(id,"Next")}
					for i=1,8 do
						if hrpg.inventory[id][i]~=nil then
							tab[i]=hrpg.inventory[id][i]
						else
							tab[9]=""
							break
						end
					end
					menu(id,translate(id,"Inventory Page").." "..hrpg.page[id]..","..tab[1]..","..tab[2]..","..tab[3]..","..tab[4]..","..tab[5]..","..tab[6]..","..tab[7]..","..tab[8]..","..tab[9].."")
				else
					tab={""..translate(id,"Money").." | "..player(id,"money").."$","","","","","","","",translate(id,"Next")}
					for i=2,8 do
						if hrpg.inventory[id][i-1]~=nil then
							tab[i]=hrpg.inventory[id][i-1]
						else
							tab[9]=""
							break
						end
					end
				end
				menu(id,translate(id,"Inventory - Page").." "..hrpg.page[id]..","..tab[1]..","..tab[2]..","..tab[3]..","..tab[4]..","..tab[5]..","..tab[6]..","..tab[7]..","..tab[8]..","..tab[9].."")
			end
		else
			hrpg.page[id]=0
			hrpg.context[id]=0
		end
	elseif men==translate(id,"Turned which way?") then
		if sel>=1 and sel<=4 then
			--if inentityzone(player(id,"tilex"),player(id,"tiley"),18) then
				--msg2(id,"255000000You can't put furniture here!@C")
			--	return 1
			--end
			local f=1
			for s=1,#hrpg.furniture do
				if hrpg.furniture[s]==hrpg.inventory[id][hrpg.placeh[id]] then
					f=s
					break
				end
			end
			if sel==1 or sel==2 then
				if hrpg.furn.poscheck(player(id,"tilex"),player(id,"tiley"),hrpg.furn.sizes[f][1],hrpg.furn.sizes[f][2])==1 then
					msg2(id,"255255255There's already furniture here!")
					return 1
				end
			else
				if hrpg.furn.poscheck(player(id,"tilex"),player(id,"tiley"),hrpg.furn.sizes[f][2],hrpg.furn.sizes[f][1])==1 then
					msg2(id,"255255255There's already furniture here!")
					return 1
				end
			end
			if (hrpg.furn.types[f]~=4 and hrpg.furn.types[f]~=6) or (hrpg.furniture[f]=="TV") then
				table.insert(hrpg.furn.id,image(hrpg.furn.image[f],player(id,"tilex")*32+16,player(id,"tiley")*32+16,0))
			else
				table.insert(hrpg.furn.id,image(hrpg.furn.image[f],player(id,"tilex")*32+16,player(id,"tiley")*32+16,1))
			end
			table.insert(hrpg.furn.type,hrpg.furn.types[f])
			table.insert(hrpg.furn.player,id)
			table.insert(hrpg.furn.var,hrpg.furniture[f])
			table.insert(hrpg.furn.img,hrpg.furn.images[f])
			table.insert(hrpg.furn.color,{255,255,255})
			local size1=hrpg.furn.sizes[f][1]
			local size2=hrpg.furn.sizes[f][2]
			local rot=0
			if sel==1 then
				table.insert(hrpg.furn.size,{size1,size2})
			elseif sel==2 then
				rot=180
				table.insert(hrpg.furn.size,{size1,size2})
			elseif sel==3 then
				rot=-90
				table.insert(hrpg.furn.size,{size2,size1})
			elseif sel==4 then
				rot=90
				table.insert(hrpg.furn.size,{size2,size1})
			end
			table.insert(hrpg.furn.rot,rot)
			imagepos(hrpg.furn.id[#hrpg.furn.id],player(id,"tilex")*32+16,player(id,"tiley")*32+16,rot)
			imagescale(hrpg.furn.id[#hrpg.furn.id],0,0)
			tween_scale(hrpg.furn.id[#hrpg.furn.id],1000,1,1)
			hrpg.item_remove(id,hrpg.placeh[id])
			hrpg.page[id]=0
			msg2(id,"255255255"..translate(id,"Your furniture has been set! Interact with it by pressing E while standing on it!"))
		else
			hrpg.page[id]=0
			hrpg.placeh[id]=0
		end
	elseif men==translate(id,"Shop Menu - Page").." 1" then
		if sel>=1 and sel<=8 then
			for d=1,#hrpg.furniture do
				if hrpg.furniture[d]==hrpg.shop.offers[hrpg.shop.being[id]][sel] then
					sel=d
				end
			end
			if hrpg.shop.stockings[sel]>0 then
				if player(id,"money")>=hrpg.shop.prices[sel] then
					msg2(id,"255255255Thank you sir, here's your "..hrpg.furniture[sel].."!")
					hrpg.item_add(id,hrpg.furniture[sel],1)
					if hrpg.shop.stockings[sel]>0 then
						hrpg.shop.stockings[sel]=hrpg.shop.stockings[sel]-1
					end
					parse("setmoney "..id.." "..player(id,"money")-hrpg.shop.prices[sel])
					hrpg.questupdate(id,3)
				else
					msg2(id,"255255255Sorry, you don't have enough money for that.")
				end
			elseif hrpg.shop.stockings[sel]==0 then
				msg2(id,"255255255Sorry, but this item is out of stock. Come by the shop tomorrow morning and we'll surely have it.")
			else
				if player(id,"money")>=hrpg.shop.prices[sel] then
					msg2(id,"255255255Thank you sir, here's your "..hrpg.furniture[sel].."!")
					hrpg.item_add(id,hrpg.furniture[sel],1)
					parse("setmoney "..id.." "..player(id,"money")-hrpg.shop.prices[sel])
					hrpg.questupdate(id,3)
				else
					msg2(id,"255255255Sorry, you don't have enough money for that.")
				end
			end
		elseif sel==9 then
			hrpg.page[id]=hrpg.page[id]+1
			local tab={"","","","","","","",translate(id,"Next"),translate(id,"Previous")}
			local pos=8+((7*(hrpg.page[id]-2)))
			local n={}
			for d=1,7 do
				for c=1,#hrpg.furniture do
					if hrpg.shop.offers[hrpg.shop.being[id]][d+pos]==hrpg.furniture[c] then
						table.insert(n,c)
					end
				end
			end
			local i=0
			for h=1,7 do
				i=n[h]
				if hrpg.shop.prices[i]~=nil then
					if hrpg.shop.prices[i]~=hrpg.furn.prices[i] then
						if hrpg.shop.stockings[i]>0 then
							tab[h]=hrpg.furniture[i].." ("..hrpg.shop.stockings[i].." available) ("..(100-math.floor((hrpg.shop.prices[i]/hrpg.furn.prices[i]*100))).."% off!) | "..hrpg.shop.prices[i].."$"
						elseif hrpg.shop.stockings[i]==0 then
							tab[h]=hrpg.furniture[i].." (Sold out!)"
						else
							tab[h]=hrpg.furniture[i].." ("..(100-math.floor((hrpg.shop.prices[i]/hrpg.furn.prices[i]*100))).."% off!) | "..hrpg.shop.prices[i].."$"
						end
					else
						if hrpg.shop.stockings[i]>0 then
							tab[h]=hrpg.furniture[i].." ("..hrpg.shop.stockings[i].." available) | "..hrpg.shop.prices[i].."$"
						elseif hrpg.shop.stockings[i]==0 then
							tab[h]=hrpg.furniture[i].." (Sold out!)"
						else
							tab[h]=hrpg.furniture[i].." | "..hrpg.shop.prices[i].."$"
						end
					end
				else
					tab[8]=""
					break
				end
			end
			if hrpg.shop.offers[hrpg.shop.being[id]][pos+8]==nil then
				tab[8]=""
			end
			menu(id,translate(id,"Shop Menu - Page").." "..hrpg.page[id].."@b,"..tab[1]..","..tab[2]..","..tab[3]..","..tab[4]..","..tab[5]..","..tab[6]..","..tab[7]..","..tab[8]..","..tab[9].."")
		else
			hrpg.page[id]=0
		end
	elseif men==translate(id,"Shop Menu - Page").." "..hrpg.page[id].."" then
		if sel>=1 and sel<=7 then
			local pos=8+((7*(hrpg.page[id]-2)))
			for d=1,#hrpg.furniture do
				if hrpg.furniture[d]==hrpg.shop.offers[hrpg.shop.being[id]][sel+pos] then
					sel=d
				end
			end
			if hrpg.shop.stockings[sel]>0 then
				if player(id,"money")>=hrpg.shop.prices[sel] then
					msg2(id,"255255255Thank you sir, here's your "..hrpg.furniture[sel].."!")
					hrpg.item_add(id,hrpg.furniture[sel],1)
					if hrpg.shop.stockings[sel]>0 then
						hrpg.shop.stockings[sel]=hrpg.shop.stockings[sel]-1
					end
					parse("setmoney "..id.." "..player(id,"money")-hrpg.shop.prices[sel])
					hrpg.questupdate(id,3)
				else
					msg2(id,"255255255Sorry, you don't have enough money for that.")
				end
			elseif hrpg.shop.stockings[sel]==0 then
				msg2(id,"255255255Sorry, but this item is out of stock. Come by the shop tomorrow morning and we'll surely have it.")
			else
				if player(id,"money")>=hrpg.shop.prices[sel] then
					msg2(id,"255255255Thank you sir, here's your "..hrpg.furniture[sel].."!")
					hrpg.item_add(id,hrpg.furniture[sel],1)
					parse("setmoney "..id.." "..player(id,"money")-hrpg.shop.prices[sel])
					hrpg.questupdate(id,3)
				else
					msg2(id,"255255255Sorry, you don't have enough money for that.")
				end
			end
		elseif sel==8 then
			hrpg.page[id]=hrpg.page[id]+1
			local tab={"","","","","","","",translate(id,"Next"),translate(id,"Previous")}
			local pos=8+((7*(hrpg.page[id]-2)))
			local n={}
			for d=1,7 do
				for c=1,#hrpg.furniture do
					if hrpg.shop.offers[hrpg.shop.being[id]][d+pos]==hrpg.furniture[c] then
						table.insert(n,c)
					end
				end
			end
			local i=0
			for h=1,7 do
				i=n[h]
				if hrpg.shop.prices[i]~=nil then
					if hrpg.shop.prices[i]~=hrpg.furn.prices[i] then
						if hrpg.shop.stockings[i]>0 then
							tab[h]=hrpg.furniture[i].." ("..hrpg.shop.stockings[i].." available) ("..(100-math.floor((hrpg.shop.prices[i]/hrpg.furn.prices[i]*100))).."% off!) | "..hrpg.shop.prices[i].."$"
						elseif hrpg.shop.stockings[i]==0 then
							tab[h]=hrpg.furniture[i].." (Sold out!)"
						else
							tab[h]=hrpg.furniture[i].." ("..(100-math.floor((hrpg.shop.prices[i]/hrpg.furn.prices[i]*100))).."% off!) | "..hrpg.shop.prices[i].."$"
						end
					else
						if hrpg.shop.stockings[i]>0 then
							tab[h]=hrpg.furniture[i].." ("..hrpg.shop.stockings[i].." available) | "..hrpg.shop.prices[i].."$"
						elseif hrpg.shop.stockings[i]==0 then
							tab[h]=hrpg.furniture[i].." (Sold out!)"
						else
							tab[h]=hrpg.furniture[i].." | "..hrpg.shop.prices[i].."$"
						end
					end
				else
					tab[8]=""
					break
				end
			end
			if hrpg.shop.offers[hrpg.shop.being[id]][pos+8]==nil then
				tab[8]=""
			end
			menu(id,translate(id,"Shop Menu - Page").." "..hrpg.page[id].."@b,"..tab[1]..","..tab[2]..","..tab[3]..","..tab[4]..","..tab[5]..","..tab[6]..","..tab[7]..","..tab[8]..","..tab[9].."")
		elseif sel==9 then
			hrpg.page[id]=hrpg.page[id]-1
			if hrpg.page[id]~=1 then
				local pos=8+((7*(hrpg.page[id]-2)))
				local tab={"","","","","","","",translate(id,"Next"),translate(id,"Previous")}
				local n={}
				for d=1,7 do
					for c=1,#hrpg.furniture do
						if hrpg.shop.offers[hrpg.shop.being[id]][d+pos]==hrpg.furniture[c] then
							table.insert(n,c)
						end
					end
				end
				local i=0
				for h=1,7 do
					i=n[h]
					if hrpg.shop.prices[i]~=nil then
						if hrpg.shop.prices[i]~=hrpg.furn.prices[i] then
							if hrpg.shop.stockings[i]>0 then
								tab[h]=hrpg.furniture[i].." ("..hrpg.shop.stockings[i].." available) ("..(100-math.floor((hrpg.shop.prices[i]/hrpg.furn.prices[i]*100))).."% off!) | "..hrpg.shop.prices[i].."$"
							elseif hrpg.shop.stockings[i]==0 then
								tab[h]=hrpg.furniture[i].." (Sold out!)"
							else
								tab[h]=hrpg.furniture[i].." ("..(100-math.floor((hrpg.shop.prices[i]/hrpg.furn.prices[i]*100))).."% off!) | "..hrpg.shop.prices[i].."$"
							end
						else
							if hrpg.shop.stockings[i]>0 then
								tab[h]=hrpg.furniture[i].." ("..hrpg.shop.stockings[i].." available) | "..hrpg.shop.prices[i].."$"
							elseif hrpg.shop.stockings[i]==0 then
								tab[h]=hrpg.furniture[i].." (Sold out!)"
							else
								tab[h]=hrpg.furniture[i].." | "..hrpg.shop.prices[i].."$"
							end
						end
					else
						tab[8]=""
						break
					end
				end
				if hrpg.shop.offers[hrpg.shop.being[id]][pos+8]==nil then
					tab[8]=""
				end
				menu(id,translate(id,"Shop Menu - Page").." "..hrpg.page[id].."@b,"..tab[1]..","..tab[2]..","..tab[3]..","..tab[4]..","..tab[5]..","..tab[6]..","..tab[7]..","..tab[8]..","..tab[9].."")
			else
				hrpg.page[id]=1
				local tab={"","","","","","","","",translate(id,"Next")}
				local n={}
				for d=1,8 do
					for c=1,#hrpg.furniture do
						if hrpg.shop.offers[hrpg.shop.being[id]][d]==hrpg.furniture[c] then
							table.insert(n,c)
						end
					end
				end
				local h=0
				for k=1,8 do
					h=n[k]
					if hrpg.shop.prices[h]~=nil then
						if hrpg.shop.prices[h]~=hrpg.furn.prices[h] then
							if hrpg.shop.stockings[h]>0 then
								tab[k]=hrpg.furniture[h].." ("..hrpg.shop.stockings[h].." available) ("..(100-math.floor((hrpg.shop.prices[h]/hrpg.furn.prices[h]*100))).."% off!) | "..hrpg.shop.prices[h].."$"
							elseif hrpg.shop.stockings[h]==0 then
								tab[k]=hrpg.furniture[h].." (Sold out!)"
							else
								tab[k]=hrpg.furniture[h].." | "..hrpg.shop.prices[h].."$"
							end
						else
							if hrpg.shop.stockings[h]>0 then
								tab[k]=hrpg.furniture[h].." ("..hrpg.shop.stockings[h].." available) | "..hrpg.shop.prices[h].."$"
							elseif hrpg.shop.stockings[h]==0 then
								tab[k]=hrpg.furniture[h].." (Sold out!)"
							else
								tab[k]=hrpg.furniture[h].." | "..hrpg.shop.prices[h].."$"
							end
						end
					else
						tab[9]=""
					end
				end
				menu(id,translate(id,"Shop Menu - Page").." "..hrpg.page[id].."@b,"..tab[1]..","..tab[2]..","..tab[3]..","..tab[4]..","..tab[5]..","..tab[6]..","..tab[7]..","..tab[8]..","..tab[9].."")
			end
		else
			hrpg.page[id]=0
		end
	elseif men==translate(id,"Drop how much?") then
		if sel==8 then
			hrpg.context[id]=2
			hrpg.inv(id,2)
			return 1
		end
		if player(id,"money")>0 then
			if sel==1 then
				if player(id,"money")>=100 then
					parse("spawnitem 66 "..player(id,"tilex").." "..player(id,"tiley").."")
					parse("setmoney "..id.." "..player(id,"money")-100)
					msg2(id,"255255255The money has been successfully dropped!")
				else
					msg2(id,"255255255You don't have enough money!")
				end
			elseif sel==2 then
				if player(id,"money")>=200 then
					parse("spawnitem 66 "..player(id,"tilex").." "..player(id,"tiley").."")
					parse("spawnitem 66 "..player(id,"tilex").." "..player(id,"tiley").."")
					parse("setmoney "..id.." "..player(id,"money")-200)
					msg2(id,"255255255The money has been successfully dropped!")
				else
					msg2(id,"255255255You don't have enough money!")
				end
			elseif sel==3 then
				if player(id,"money")>=500 then
					parse("spawnitem 67 "..player(id,"tilex").." "..player(id,"tiley").."")
					parse("setmoney "..id.." "..player(id,"money")-500)
					msg2(id,"255255255The money has been successfully dropped!")
				else
					msg2(id,"255255255You don't have enough money!")
				end
			elseif sel==4 then
				if player(id,"money")>=1000 then
					parse("spawnitem 68 "..player(id,"tilex").." "..player(id,"tiley").."")
					parse("setmoney "..id.." "..player(id,"money")-1000)
					msg2(id,"255255255The money has been successfully dropped!")
				else
					msg2(id,"255255255You don't have enough money!")
				end
			elseif sel==5 then
				if player(id,"money")>=5000 then
					parse("spawnitem 68 "..player(id,"tilex").." "..player(id,"tiley").."")
					parse("spawnitem 68 "..player(id,"tilex").." "..player(id,"tiley").."")
					parse("spawnitem 68 "..player(id,"tilex").." "..player(id,"tiley").."")
					parse("spawnitem 68 "..player(id,"tilex").." "..player(id,"tiley").."")
					parse("spawnitem 68 "..player(id,"tilex").." "..player(id,"tiley").."")
					parse("setmoney "..id.." "..player(id,"money")-5000)
					msg2(id,"255255255The money has been successfully dropped!")
				else
					msg2(id,"255255255You don't have enough money!")
				end
			elseif sel==6 then
				if player(id,"money")>=10000 then
					for i=1,10 do
						parse("spawnitem 68 "..player(id,"tilex").." "..player(id,"tiley").."")
					end
					parse("setmoney "..id.." "..player(id,"money")-10000)
					msg2(id,"255255255The money has been successfully dropped!")
				else
					msg2(id,"255255255You don't have enough money!")
				end
			elseif sel==7 then
				if player(id,"money")>=16000 then
					for i=1,16 do
						parse("spawnitem 68 "..player(id,"tilex").." "..player(id,"tiley").."")
					end
					parse("setmoney "..id.." "..player(id,"money")-16000)
					msg2(id,"255255255The money has been successfully dropped!")
				else
					msg2(id,"255255255You don't have enough money!")
				end
			end
		else
			msg2(id,"255255255You don't have any money!")
		end
	elseif men==translate(id,"Racing") then
		if sel==1 then
			menu(id,translate(id,"Slots")..",2 player race,3 player race,4 player race,6 player race,10 player race,16 player race,24 player race,Max player race,"..translate(id,"Back"))
		elseif sel==2 then
			if #hrpg.races>0 then
				if #hrpg.races==1 then
					if hrpg.races[1][1]<hrpg.races[1][2] and hrpg.races[1][5]=="Waiting" then
						hrpg.races[1][1]=hrpg.races[1][1]+1
						spawnplayer(id,hrpg.races[1][6],hrpg.races[1][7])
						racer[id]=1
						hrpg.carappear(id)
						table.insert(hrpg.races[1],id)
						freetimer("hrpg.carappear",""..id.."")
						freetimer("hrpg.cardisappear",""..id.."")
						parse("speedmod "..id.." -90")
						if hrpg.races[1][1]<hrpg.races[1][2] then
							msg2(id,"255255255"..translate(id,"Waiting for players to join. Press F4 to leave."))
						else
							hrpg.races[1][5]="In Progress"
							msg2(hrpg.races[1][3],"255255255"..translate(hrpg.races[1][3],"Lobby is full - starting the race automatically."))
							for i=8,#hrpg.races[1] do
								msg2(hrpg.races[1][i],"255255255"..translate(hrpg.races[1][i],"Lobby is full - starting the race automatically."))
							end
							hrpg.powerup.spawn(1)
							timer(2000,"hrpg.startracing1",""..#hrpg.races.."")
						end
						for z=1,32 do
							hudding(2,z)
						end
					else
						msg2(id,"255255255"..translate(id,"Sorry, but this racing lobby is full!"))
					end
				else
					local tab={"","","","","","","",translate(id,"Next"),translate(id,"Back")}
					for i=1,7 do
						if hrpg.races[i]~=nil then
							if hrpg.races[i][4]~=nil then
								tab[i]="Hosted by "..player(hrpg.races[i][3],"name").." | Status:  "..hrpg.races[i][5].." Slots: "..hrpg.races[i][1].."/"..hrpg.races[i][2]..""
							else
								tab[i]=""
							end
						else
							tab[8]=""
						end
					end
					hrpg.page[id]=1
					menu(id,translate(id,"Racing lobbies - Page").." 1@b,"..tab[1]..","..tab[2]..","..tab[3]..","..tab[4]..","..tab[5]..","..tab[6]..","..tab[7]..","..tab[8]..","..tab[9].."")
				end
			else
				msg2(id,"255255255"..translate(id,"There is no race available!"))
			end
		end
	elseif men==translate(id,"Racing lobbies - Page").." 1" then
		if #hrpg.races<2 then
			msg2(id,"255255255"..translate(id,"Lobby count has changed. Please try again."))
			return 1
		end
		if sel>=1 and sel<=7 then
			if hrpg.races[sel][1]<hrpg.races[sel][2] and hrpg.races[sel][5]=="Waiting" then
				hrpg.races[sel][1]=hrpg.races[sel][1]+1
				spawnplayer(id,hrpg.races[sel][6],hrpg.races[sel][7])
				racer[id]=1
				table.insert(hrpg.races[sel],id)
				freetimer("hrpg.carappear",""..id.."")
				freetimer("hrpg.cardisappear",""..id.."")
				hrpg.carappear(id)
				parse("speedmod "..id.." -90")
				if hrpg.races[sel][1]<hrpg.races[sel][2] then
					msg2(id,"255255255"..translate(id,"Waiting for players to join. Press F4 to leave."))
				else
					hrpg.races[sel][5]="In Progress"
					msg2(hrpg.races[sel][3],"255255255"..translate(hrpg.races[sel][3],"Lobby is full - starting the race automatically."))
					for i=8,#hrpg.races[sel] do
						msg2(hrpg.races[sel][i],"255255255"..translate(hrpg.races[sel][i],"Lobby is full - starting the race automatically."))
					end
					hrpg.powerup.spawn(sel)
					timer(2000,"hrpg.startracing1",""..sel.."")
				end
				for z=1,32 do
					hudding(2,z)
				end
			else
				msg2(id,"255255255"..translate(id,"Sorry, but this racing lobby is full!"))
			end
		elseif sel==8 then
			hrpg.page[id]=2
			local tab={"","","","","","","",translate(id,"Next"),translate(id,"Previous")}
			local pos=7+((7*(hrpg.page[id]-2)))
			for i=1,7 do
				if hrpg.races[i+pos]~=nil then
					tab[i]="Hosted by "..string.gsub(player(hrpg.races[i+pos][3],"name"),"|","").." | Status:  "..hrpg.races[i+pos][5].." Slots: "..hrpg.races[i+pos][1].."/"..hrpg.races[i+pos][2]..""
				else
					tab[8]=""
					break
				end
			end
			if hrpg.races[pos+8]==nil then
				tab[pos+7]=""
			end
			menu(id,translate(id,"Racing lobbies - Page").." "..hrpg.page[id]..","..tab[1]..","..tab[2]..","..tab[3]..","..tab[4]..","..tab[5]..","..tab[6]..","..tab[7]..","..tab[8]..","..tab[9].."")
		elseif sel==9 then
			menu(id,translate(id,"Racing")..","..translate(id,"Host")..","..translate(id,"Join").." | "..#hrpg.races.." "..translate(id,"available"))
		end
	elseif men==translate(id,"Racing lobbies - Page").." "..hrpg.page[id].."" then
		if #hrpg.races<2 then
			msg2(id,"255255255"..translate(id,"Lobby count has changed. Please try again."))
			return 1
		end
		if sel>=1 and sel<=7 then
			local pos=7+((7*(hrpg.page[id]-2)))
			if hrpg.races[sel+pos][1]<hrpg.races[sel+pos][2] and hrpg.races[sel+pos][5]=="Waiting" then
				hrpg.races[sel+pos][1]=hrpg.races[sel+pos][1]+1
				spawnplayer(id,hrpg.races[sel+pos][6],hrpg.races[sel+pos][7])
				racer[id]=1
				hrpg.carappear(id)
				table.insert(hrpg.races[sel],id)
				freetimer("hrpg.carappear",""..id.."")
				freetimer("hrpg.cardisappear",""..id.."")
				parse("speedmod "..id.." -90")
				if hrpg.races[sel+pos][1]<hrpg.races[sel+pos][2] then
					msg2(id,"255255255"..translate(id,"Waiting for players to join. Press F4 to leave."))
				else
					hrpg.races[sel+pos][5]="In Progress"
					msg2(hrpg.races[sel+pos][3],"255255255"..translate(hrpg.races[sel+pos][3],"Lobby is full - starting the race automatically."))
					for i=8,#hrpg.races[sel+pos] do
						msg2(hrpg.races[sel+pos][i],"255255255"..translate(hrpg.races[sel+pos][i],"Lobby is full - starting the race automatically."))
					end
					hrpg.powerup.spawn(sel+pos)
					timer(2000,"hrpg.startracing1",""..sel+pos.."")
				end
				for z=1,32 do
					hudding(2,z)
				end
			else
				msg2(id,"255255255"..translate(id,"Sorry, but this racing lobby is full!"))
			end
		elseif sel==8 then
			hrpg.page[id]=hrpg.page[id]+1
			local tab={"","","","","","","",translate(id,"Next"),translate(id,"Previous")}
			local pos=7+((7*(hrpg.page[id]-2)))
			for i=1,7 do
				if hrpg.races[i+pos]~=nil then
					tab[i]="Hosted by "..string.gsub(player(hrpg.races[i+pos][3],"name"),"|","").." | Status:  "..hrpg.races[i+pos][5].." Slots: "..hrpg.races[i+pos][1].."/"..hrpg.races[i+pos][2]..""
				else
					tab[8]=""
					break
				end
			end
			if hrpg.races[pos+8]==nil then
				tab[pos+7]=""
			end
			menu(id,translate(id,"Racing lobbies - Page").." "..hrpg.page[id]..","..tab[1]..","..tab[2]..","..tab[3]..","..tab[4]..","..tab[5]..","..tab[6]..","..tab[7]..","..tab[8]..","..tab[9].."")
		elseif sel==9 then
			hrpg.page[id]=hrpg.page[id]-1
			if hrpg.page[id]~=1 then
				local tab={"","","","","","","",translate(id,"Next"),translate(id,"Previous")}
				local pos=7+((7*(hrpg.page[id]-2)))
				for i=1,7 do
					if hrpg.races[i+pos]~=nil then
						tab[i]="Hosted by "..string.gsub(player(hrpg.races[i+pos][3],"name"),"|","").." | Status:  "..hrpg.races[i+pos][5].." Slots: "..hrpg.races[i+pos][1].."/"..hrpg.races[i+pos][2]..""
					else
						tab[8]=""
						break
					end
				end
				if hrpg.races[pos+8]==nil then
					tab[pos+7]=""
				end
				menu(id,translate(id,"Racing lobbies - Page").." "..hrpg.page[id]..","..tab[1]..","..tab[2]..","..tab[3]..","..tab[4]..","..tab[5]..","..tab[6]..","..tab[7]..","..tab[8]..","..tab[9].."")
			else
				local tab={"","","","","","","",translate(id,"Next"),translate(id,"Back")}
				for i=1,7 do
					if hrpg.races[i]~=nil then
						tab[i]="Hosted by "..player(hrpg.races[i][3],"name").." | Status:  "..hrpg.races[i][5].." Slots: "..hrpg.races[i][1].."/"..hrpg.races[i][2]..""
					else
						tab[8]=""
					end
				end
				hrpg.page[id]=1
				menu(id,translate(id,"Racing lobbies - Page").." 1@b,"..tab[1]..","..tab[2]..","..tab[3]..","..tab[4]..","..tab[5]..","..tab[6]..","..tab[7]..","..tab[8]..","..tab[9].."")
			end
		end
	elseif men==translate(id,"Slots") then
		if sel>=1 and sel<=8 then
			local t=array3(8,"")
			for i=1,8 do
				if hrpg.tracks[i]~=nil then
					t[i]=hrpg.tracks[i]
				else
					break
				end
			end
			menu(id,translate(id,"Choose the track")..","..translate(id,"Random")..","..t[1]..","..t[2]..","..t[3]..","..t[4]..","..t[5]..","..t[6]..","..t[7]..","..t[8].."")
		end
		if sel==1 then
			hrpg.placeh[id]=2
		elseif sel==2 then
			hrpg.placeh[id]=3
		elseif sel==3 then
			hrpg.placeh[id]=4
		elseif sel==4 then
			hrpg.placeh[id]=6
		elseif sel==5 then
			hrpg.placeh[id]=10
		elseif sel==6 then
			hrpg.placeh[id]=16
		elseif sel==7 then
			hrpg.placeh[id]=24
		elseif sel==8 then
			hrpg.placeh[id]=tonumber(game("sv_maxplayers"))
		elseif sel==9 then
			menu(id,translate(id,"Racing")..","..translate(id,"Host")..","..translate(id,"Join").." | "..#hrpg.races.." "..translate(id,"available"))
		end
	elseif men==translate(id,"Choose the track") then
		if sel>=1 and sel<=9 then
			if sel==1 then
				sel=math.random(2,#hrpg.tracks+1)
			end
			local e=0
			for d=1,#hrpg.races do
				if hrpg.races[d][4]==hrpg.tracks[sel-1] then
					msg2(id,"255255255"..translate(id,"There is already a race on this track!"))
					local t=array3(8,"")
					for i=1,8 do
						if hrpg.tracks[i]~=nil then
							t[i]=hrpg.tracks[i]
						else
							break
						end
					end
					menu(id,translate(id,"Choose the Track")..","..translate(id,"Random")..","..t[1]..","..t[2]..","..t[3]..","..t[4]..","..t[5]..","..t[6]..","..t[7]..","..t[8].."")
					return 1
				end
			end
			racer[id]=1
			table.insert(hrpg.races,{})
			table.insert(hrpg.races[#hrpg.races],1)
			table.insert(hrpg.races[#hrpg.races],hrpg.placeh[id])
			table.insert(hrpg.races[#hrpg.races],id)
			table.insert(hrpg.races[#hrpg.races],hrpg.tracks[sel-1])
			table.insert(hrpg.races[#hrpg.races],"Waiting")
			table.insert(hrpg.races[#hrpg.races],hrpg.tracksx[sel-1])
			table.insert(hrpg.races[#hrpg.races],hrpg.tracksy[sel-1])
			spawnplayer(id,hrpg.tracksx[sel-1],hrpg.tracksy[sel-1])
			freetimer("hrpg.carappear",""..id.."")
			freetimer("hrpg.cardisappear",""..id.."")
			hrpg.carappear(id)
			parse("speedmod "..id.." -90")
			for z=1,32 do
				hudding(2,z)
			end
			msg2(id,"255255255"..translate(id,"Waiting for players to join. Press F4 to leave or to start the race").." ("..(math.floor(hrpg.races[#hrpg.races][2]/2)+1).." "..translate(id,"players needed")..").")
		else
			hrpg.placeh[id]=0
		end
	elseif men==translate(id,"Painting Furniture - Colour") then
		if sel>=1 and sel<=6 then
			hrpg.context[id]=sel
			menu(id,translate(id,"Painting Furniture - Tone")..","..translate(id,"Light")..","..translate(id,"Balanced")..","..translate(id,"Heavy")..","..translate(id,"Full")..","..translate(id,"Back"))
		elseif sel==7 then
			msg2(id,"255255255Please say how much red colour would you like to have on your furniture (0-250).")
			hrpg.namechange[id]=4
		elseif sel==8 then
			hrpg.inv(id,hrpg.context[id])
		end
	elseif men==translate(id,"Painting Furniture - Tone") then
		local colour=0
		if sel==1 then
			colour=155
		elseif sel==2 then
			colour=195
		elseif sel==3 then
			colour=215
		elseif sel==4 then
			colour=255
		elseif sel==5 then
			menu(id,translate(id,"Painting Furniture - Colour")..","..translate(id,"Red")..","..translate(id,"Green")..","..translate(id,"Blue")..","..translate(id,"Yellow")..","..translate(id,"Cyan")..","..translate(id,"Violet")..","..translate(id,"Custom")..","..translate(id,"Back"))
		end
		if sel>=1 and sel<=4 then
			if hrpg.context[id]==1 then
				hrpg.furn.color[hrpg.placeh[id]][1]=colour
				hrpg.furn.color[hrpg.placeh[id]][2]=0
				hrpg.furn.color[hrpg.placeh[id]][3]=0
			elseif hrpg.context[id]==2 then
				hrpg.furn.color[hrpg.placeh[id]][2]=colour
				hrpg.furn.color[hrpg.placeh[id]][1]=0
				hrpg.furn.color[hrpg.placeh[id]][3]=0
			elseif hrpg.context[id]==3 then
				hrpg.furn.color[hrpg.placeh[id]][3]=colour
				hrpg.furn.color[hrpg.placeh[id]][2]=0
				hrpg.furn.color[hrpg.placeh[id]][1]=0
			elseif hrpg.context[id]==4 then
				hrpg.furn.color[hrpg.placeh[id]][1]=colour
				hrpg.furn.color[hrpg.placeh[id]][2]=colour
				hrpg.furn.color[hrpg.placeh[id]][3]=0
			elseif hrpg.context[id]==5 then
				hrpg.furn.color[hrpg.placeh[id]][1]=0
				hrpg.furn.color[hrpg.placeh[id]][2]=colour
				hrpg.furn.color[hrpg.placeh[id]][3]=colour
			elseif hrpg.context[id]==6 then
				hrpg.furn.color[hrpg.placeh[id]][1]=colour
				hrpg.furn.color[hrpg.placeh[id]][2]=0
				hrpg.furn.color[hrpg.placeh[id]][3]=colour
			end
			msg2(id,"255255255Thank you, your furniture is now coloured accordingly to your will.")
			tween_color(hrpg.furn.id[hrpg.placeh[id]],1000,hrpg.furn.color[hrpg.placeh[id]][1],hrpg.furn.color[hrpg.placeh[id]][2],hrpg.furn.color[hrpg.placeh[id]][3])
			hrpg.item_remove(id,hrpg.page[id])
			hrpg.page[id]=0
		end
	elseif men==translate(id,"Select a menu") then
		if sel==1 then
			hrpg.serveraction(id,1)
		elseif sel==2 then
			hrpg.inv(id,2)
		elseif sel==3 then
			hrpg.menu(id,translate(id,"Bank menu"),1)
		elseif sel==4 then
			hrpg.menu(id,translate(id,"Furniture menu"),2)
		elseif sel==5 then
			hrpg.menu(id,translate(id,"Furniture menu"),1)
		end
	elseif men==translate(id,"Racing stuff") then
		if racer[id]==1 then
			if sel==1 then
				menu(id,translate(id,"Wanna leave the race?")..","..translate(id,"Yes")..","..translate(id,"No"))
			elseif sel==2 then
				for i=1,#hrpg.races do
					if hrpg.races[i][3]==id then
						if hrpg.races[i][1]>=math.floor(hrpg.races[i][2]/2)+1 then
							if hrpg.races[i][5]~="In Progress" then
								hrpg.races[i][5]="In Progress"
								msg2(hrpg.races[i][3],"255255255"..translate(hrpg.races[i][3],"Hoster started the race manually."))
								for p=8,#hrpg.races[i] do
									msg2(hrpg.races[i][p],"255255255Hoster started the race manually.")
								end
								for z=1,32 do
									hudding(2,z)
								end
								hrpg.powerup.spawn(i)
								timer(2000,"hrpg.startracing1",""..i.."")
								c=1
							else
								msg2(hrpg.races[i][3],"255255255"..translate(hrpg.races[i][3],"The race is already in progress!"))
								c=1
							end
						else
							c=1
							msg2(hrpg.races[i][3],"255255255"..translate(hrpg.races[i][3],"Can't start the race - not enough players").." ("..(math.floor(hrpg.races[i][2]/2)+1).." "..translate(hrpg.races[i][3],"needed")..").")
						end
					end
				end
			end
		end
	elseif men==translate(id,"Bank menu") then
		if sel>=1 and sel<=3 then
			hrpg.placeh[id]=sel
			if sel==3 and hrpg.bankdeposit[id]==0 then
				msg2(id,"255255255"..translate(id,"Your bank account is empty!"))
				return 1
			end
			local t=""
			if sel~=1 then
				t="Max $"
			end
			menu(id,translate(id,"How much?")..",100$,200$,500$,1000$,2000$,5000$,10000$,"..t..","..translate(id,"Back"))
		elseif sel==4 then
			menu(id,translate(id,"Pay off bank debt")..",100$,500$,1000$,2000$,5000$,10000$,16000$,"..translate(id,"Back"))
		elseif sel==5 then
			local t={"","","","","","","","",translate(id,"Back")}
			for i=1,7 do
				if player(0,"tableliving")[i]~=nil then
					t[i]=player(player(0,"tableliving")[i],"name")
				end
			end
			if #player(0,"tableliving")>7 then
				t[9]=translate(id,"Next")
			end
			hrpg.page[id]=1
			menu(id,translate(id,"Money transfer")..","..t[1]..","..t[2]..","..t[3]..","..t[4]..","..t[5]..","..t[6]..","..t[7]..","..t[8]..","..t[9].."")
		elseif sel==9 then
			hrpg.serveraction(id,1)
		end
	elseif men==translate(id,"Money transfer") then
		local pos=7+((7*(hrpg.page[id]-2)))
		if sel>=1 and sel<=7 then
			hrpg.placeh[id]=3+sel+pos
			if id==hrpg.placeh[id]-3 then
				msg2(id,"255255255"..translate(id,"You can't transfer money to yourself!"))
				hrpg.page[id]=0
				hrpg.placeh[id]=0
				return 1
			end
			menu(id,translate(id,"How much?")..",100$,200$,500$,1000$,2000$,5000$,10000$,Max $,"..translate(id,"Back"))
		elseif sel>=8 and sel<=9 then
			if sel==8 then
				hrpg.page[id]=hrpg.page[id]+1
			else
				hrpg.page[id]=hrpg.page[id]-1
			end
			if hrpg.page[id]==0 then
				hrpg.placeh[id]=0
				menu(id,translate(id,"Bank menu")..","..translate(id,"Borrow money")..","..translate(id,"Deposit money")..","..translate(id,"Withdraw money").." | "..hrpg.bankdeposit[id].."$,"..translate(id,"Pay off bank debt").." | "..hrpg.debt[id].."$,"..translate(id,"Money transfer")..",,,,"..translate(id,"Back").."")
			else
				local t={"","","","","","","","",translate(id,"Back")}
				for i=1+pos,7+pos do
					if player(0,"tableliving")[i]~=nil then
						t[i-pos]=player(player(0,"tableliving")[i],"name")
					end
				end
				if #player(0,"tableliving")>7*hrpg.page[id] then
					t[9]=translate(id,"Next")
				end
				menu(id,translate(id,"Money transfer")..","..t[1]..","..t[2]..","..t[3]..","..t[4]..","..t[5]..","..t[6]..","..t[7]..","..t[8]..","..t[9].."")
			end
		end
	end
end
function hrpg.furnishing_menu(id,pos)
	if hrpg.inventory[id][pos]=="Paint Can" then
		for i=1,#hrpg.furn.id do
			if hrpg.furn.id[i]~=nil and player(id,"tilex")>=object(hrpg.furn.id[i],"tilex")-hrpg.furn.size[i][1]+math.floor(hrpg.furn.size[i][1]/2)+1 and player(id,"tilex")<=object(hrpg.furn.id[i],"tilex")+hrpg.furn.size[i][1]-math.floor(hrpg.furn.size[i][1]/2)-1 and player(id,"tiley")>=object(hrpg.furn.id[i],"tiley")-hrpg.furn.size[i][2]+math.floor(hrpg.furn.size[i][2]/2)+1 and player(id,"tiley")<=object(hrpg.furn.id[i],"tiley")+hrpg.furn.size[i][2]-math.floor(hrpg.furn.size[i][2]/2)-1 then
				if player(id,"tilex")>=object(hrpg.furn.id[i],"tilex")-hrpg.furn.size[i][1] and player(id,"tilex")<=object(hrpg.furn.id[i],"tilex")+hrpg.furn.size[i][1] and player(id,"tiley")>=object(hrpg.furn.id[i],"tiley")-hrpg.furn.size[i][2] and player(id,"tiley")<=object(hrpg.furn.id[i],"tiley")+hrpg.furn.size[i][2] then
					if hrpg.furn.player[i]==id then
						hrpg.placeh[id]=i
						hrpg.page[id]=pos
						menu(id,translate(id,"Painting Furniture - Colour")..","..translate(id,"Red")..","..translate(id,"Green")..","..translate(id,"Blue")..","..translate(id,"Yellow")..","..translate(id,"Cyan")..","..translate(id,"Violet")..","..translate(id,"Custom")..","..translate(id,"Back"))
					else
						if myh[id]==0 then
							msg2(id,"255255255"..translate(id,"This furniture is not yours!"))
						else
							if object(hrpg.furn.id[i],"tilex")>=hrpg.housecoor[myh[id]][1]-hrpg.housesize[myh[id]][1] and object(hrpg.furn.id[i],"tilex")<=hrpg.housecoor[myh[id]][1]+hrpg.housesize[myh[id]][1] and object(hrpg.furn.id[i],"tiley")>=hrpg.housecoor[myh[id]][2]-hrpg.housesize[myh[id]][2] and object(hrpg.furn.id[i],"tiley")<=hrpg.housecoor[myh[id]][2]+hrpg.housesize[myh[id]][2] then
								hrpg.placeh[id]=i
								hrpg.page[id]=pos
								menu(id,translate(id,"Painting Furniture - Colour")..","..translate(id,"Red")..","..translate(id,"Green")..","..translate(id,"Blue")..","..translate(id,"Yellow")..","..translate(id,"Cyan")..","..translate(id,"Violet")..","..translate(id,"Custom")..","..translate(id,"Back"))
							else
								msg2(id,"255255255"..translate(id,"This furniture is not yours!"))
							end
						end
					end
					return 1
				end
			end
		end
		msg2(id,"255255255There isn't anything underneath you!")
	elseif hrpg.inventory[id][pos]=="Living room set" then
		local c=0
		if myh[id]~=0 and player(id,"tilex")<=hrpg.housecoor[myh[id]][1]+hrpg.housesize[myh[id]][1] and player(id,"tilex")>=hrpg.housecoor[myh[id]][1]-hrpg.housesize[myh[id]][1] and player(id,"tiley")<=hrpg.housecoor[myh[id]][2]+hrpg.housesize[myh[id]][2] and player(id,"tiley")>=hrpg.housecoor[myh[id]][2]-hrpg.housesize[myh[id]][2] then
			for x=player(id,"tilex")-2,player(id,"tilex")+2 do
				for y=player(id,"tiley")-2,player(id,"tiley")+2 do
					for i=1,#hrpg.furn.id do
						c=hrpg.furn.id[i]
						if hrpg.furn.type[i]~=7 and object(c,"tilex")==x and object(c,"tiley")==y then
							msg2(id,"255255255There's furniture in the way!")
							return 1
						end
					end
				end
			end
			for x=player(id,"tilex")-2,player(id,"tilex")+2 do
				for y=player(id,"tiley")-2,player(id,"tiley")+2 do
					for i=1,#object(0,"table") do
						c=object(0,"table")[i]
						if object(c,"player")~=nil and object(c,"player")~=0 and object(c,"tilex")==x and object(c,"tiley")==y then
							parse("killobject "..c)
							break
						end
					end
					if (y==player(id,"tiley")+2 or y==player(id,"tiley")-2) or ((y==player(id,"tiley")+1 or y==player(id,"tiley")-1) and (x==player(id,"tilex")+2 or x==player(id,"tilex")-2)) then
						build(id,5,x,y,player(id,"team"))
					elseif y==player(id,"tiley")+1 and x==player(id,"tilex") then
						hrpg.furn.spawn(id,x,y,0,{255,255,255},"Sofa")
					elseif y==player(id,"tiley")-1 and x==player(id,"tilex") then
						hrpg.furn.spawn(id,x,y,180,{255,255,255},"TV")
					elseif y==player(id,"tiley")-1 and x==player(id,"tilex")-1 then
						hrpg.furn.spawn(id,x,y,90,{255,255,255},"Lamp")
					elseif y==player(id,"tiley")-1 and x==player(id,"tilex")+1 then
						hrpg.furn.spawn(id,x,y,-90,{255,255,255},"Lamp")
					end
				end
			end
			hrpg.item_remove(id,pos)
			msg2(id,"255255255The living room set was succesfully laid down.")
		else
			msg2(id,"255255255You can't use this outside of your house!")
		end
	elseif hrpg.inventory[id][pos]=="Office set" then
		local c=0
		if myh[id]~=0 and player(id,"tilex")<=hrpg.housecoor[myh[id]][1]+hrpg.housesize[myh[id]][1] and player(id,"tilex")>=hrpg.housecoor[myh[id]][1]-hrpg.housesize[myh[id]][1] and player(id,"tiley")<=hrpg.housecoor[myh[id]][2]+hrpg.housesize[myh[id]][2] and player(id,"tiley")>=hrpg.housecoor[myh[id]][2]-hrpg.housesize[myh[id]][2] then
			for x=player(id,"tilex")-2,player(id,"tilex")+2 do
				for y=player(id,"tiley")-2,player(id,"tiley")+2 do
					for i=1,#hrpg.furn.id do
						c=hrpg.furn.id[i]
						if hrpg.furn.type[i]~=7 and object(c,"tilex")==x and object(c,"tiley")==y then
							msg2(id,"255255255There's furniture in the way!")
							return 1
						end
					end
				end
			end
			for x=player(id,"tilex")-2,player(id,"tilex")+2 do
				for y=player(id,"tiley")-2,player(id,"tiley")+2 do
					for i=1,#object(0,"table") do
						c=object(0,"table")[i]
						if object(c,"player")~=nil and object(c,"player")~=0 and object(c,"tilex")==x and object(c,"tiley")==y then
							parse("killobject "..c)
							break
						end
					end
					if (y==player(id,"tiley")+2 or y==player(id,"tiley")-2) or ((y==player(id,"tiley")+1 or y==player(id,"tiley")) and (x==player(id,"tilex")+2 or x==player(id,"tilex")-2)) then
						build(id,5,x,y,player(id,"team"))
					elseif y==player(id,"tiley") and x==player(id,"tilex") then
						hrpg.furn.spawn(id,x,y,90,{255,255,255},"Table")
					elseif y==player(id,"tiley")+1 and x==player(id,"tilex") then
						hrpg.furn.spawn(id,x,y,0,{255,255,255},"Chair")
					elseif y==player(id,"tiley")-1 and x==player(id,"tilex") then
						hrpg.furn.spawn(id,x,y,180,{255,255,255},"Lamp")
					end
				end
			end
			hrpg.item_remove(id,pos)
			msg2(id,"255255255The office set was succesfully laid down.")
		else
			msg2(id,"255255255You can't use this outside of your house!")
		end
	elseif hrpg.inventory[id][pos]:find("Roof") then
		if myh[id]~=0 then
			if player(id,"tilex")>=hrpg.housecoor[myh[id]][1]-hrpg.housesize[myh[id]][1] and player(id,"tilex")<=hrpg.housecoor[myh[id]][1]+hrpg.housesize[myh[id]][1] and player(id,"tiley")>=hrpg.housecoor[myh[id]][2]-hrpg.housesize[myh[id]][2] and player(id,"tiley")<=hrpg.housecoor[myh[id]][2]+hrpg.housesize[myh[id]][2] then
				if hrpg.houseroof[myh[id]]==0 then
					local c=0
					for i=1,#hrpg.furniture do
						if hrpg.furniture[i]==hrpg.inventory[id][pos] then
							c=i
							break
						end
					end
					hrpg.rooftype[myh[id]]=hrpg.commakiller(hrpg.furniture[c]," Roof")[1]
					hrpg.houseroof[myh[id]]=image(hrpg.furn.images[c],hrpg.housecoor[myh[id]][1]*32+16,hrpg.housecoor[myh[id]][2]*32+16,3)
					table.insert(hrpg.roof_exists,myh[id])
					hrpg.roof_visible[myh[id]]=true
					imagepos(hrpg.houseroof[myh[id]],hrpg.housecoor[myh[id]][1]*32+16,hrpg.housecoor[myh[id]][2]*32+16,hrpg.houserot[myh[id]])
					imagescale(hrpg.houseroof[myh[id]],0,0)
					tween_scale(hrpg.houseroof[myh[id]],1000,hrpg.housesize[myh[id]][1]/2,hrpg.housesize[myh[id]][2]/2)
					imagealpha(hrpg.houseroof[myh[id]],hrpg.roof_transparency)
					hrpg.respcycle()
					hrpg.item_remove(id,pos)
				else
					msg2(id,"255255255This house already has a roof! Remove it (House Menu -> Customize House) to place another one!")
				end
			else
				msg2(id,"255255255You aren't standing in your house!")
			end
		else
			msg2(id,"255255255This isn't your house. Sadly you don't have one yet, so what are you waiting for? Go get one!")
		end
	end
end
function hrpg.inv(id,c)
	hrpg.page[id]=1
	local tab={}
	if c~=2 then
		tab={"","","","","","","","",translate(id,"Next")}
		for i=1,8 do
			if hrpg.inventory[id][i]~=nil then
				tab[i]=hrpg.inventory[id][i]
			else
				tab[9]=""
				break
			end
		end
		if hrpg.inventory[id][9]==nil then
			tab[9]=""
		end
	else
		tab={""..translate(id,"Money").." | "..player(id,"money").."$","","","","","","","",translate(id,"Next")}
		for i=2,8 do
			if hrpg.inventory[id][i-1]~=nil then
				tab[i]=hrpg.inventory[id][i-1]
			else
				tab[9]=""
				break
			end
		end
		if hrpg.inventory[id][8]==nil then
			tab[9]=""
		end
	end
	menu(id,translate(id,"Inventory - Page").." "..hrpg.page[id]..","..tab[1]..","..tab[2]..","..tab[3]..","..tab[4]..","..tab[5]..","..tab[6]..","..tab[7]..","..tab[8]..","..tab[9].."")
end
function hrpg.shop.menu(id)
	local tab={"","","","","","","","",translate(id,"Next")}
	local n={}
	for d=1,8 do
		for c=1,#hrpg.furniture do
			if hrpg.shop.offers[hrpg.shop.being[id]][d]==hrpg.furniture[c] then
				table.insert(n,c)
			end
		end
	end
	local h=0
	for k=1,8 do
		h=n[k]
		if hrpg.shop.prices[h]~=nil then
			if hrpg.shop.prices[h]~=hrpg.furn.prices[h] then
				if hrpg.shop.stockings[h]>0 then
					tab[k]=hrpg.furniture[h].." ("..hrpg.shop.stockings[h].." available) ("..(100-math.floor((hrpg.shop.prices[h]/hrpg.furn.prices[h]*100))).."% off!) | "..hrpg.shop.prices[h].."$"
				elseif hrpg.shop.stockings[h]==0 then
					tab[k]=hrpg.furniture[h].." (Sold out!)"
				else
					tab[k]=hrpg.furniture[h].." | "..hrpg.shop.prices[h].."$"
				end
			else
				if hrpg.shop.stockings[h]>0 then
					tab[k]=hrpg.furniture[h].." ("..hrpg.shop.stockings[h].." available) | "..hrpg.shop.prices[h].."$"
				elseif hrpg.shop.stockings[h]==0 then
					tab[k]=hrpg.furniture[h].." (Sold out!)"
				else
					tab[k]=hrpg.furniture[h].." | "..hrpg.shop.prices[h].."$"
				end
			end
		else
			tab[9]=""
		end
	end
	hrpg.page[id]=1
	menu(id,translate(id,"Shop Menu - Page").." 1@b,"..tab[1]..","..tab[2]..","..tab[3]..","..tab[4]..","..tab[5]..","..tab[6]..","..tab[7]..","..tab[8]..","..tab[9].."")
	return 1
end

function hrpg.startracing1(id)
	local i=tonumber(id)
	msg2(hrpg.races[i][3],"255255255The race begins in 5 seconds...")
	for d=8,#hrpg.races[i] do
		msg2(hrpg.races[i][d],"255255255The race begins in 5 seconds...")
	end
	timer(2000,"hrpg.startracing2",""..i.."")
end
function hrpg.startracing2(id)
	local i=tonumber(id)
	msg2(hrpg.races[i][3],"2552552553...")
	for d=8,#hrpg.races[i] do
		msg2(hrpg.races[i][d],"2552552553...")
	end
	timer(1000,"hrpg.startracing3",""..i.."")
end
function hrpg.startracing3(id)
	local i=tonumber(id)
	msg2(hrpg.races[i][3],"2552552552...")
	for d=8,#hrpg.races[i] do
		msg2(hrpg.races[i][d],"2552552552...")
	end
	timer(1000,"hrpg.startracing4",""..i.."")
end
function hrpg.startracing4(id)
	local i=tonumber(id)
	msg2(hrpg.races[i][3],"2552552551...")
	for d=8,#hrpg.races[i] do
		msg2(hrpg.races[i][d],"2552552551...")
	end
	timer(1000,"hrpg.startracing5",""..i.."")
end
function hrpg.startracing5(id)	
	local i=tonumber(id)
	msg2(hrpg.races[i][3],"255255255GO!")
	if carimg[hrpg.races[i][3]]~=0 then
		parse('speedmod '..hrpg.races[i][3]..' 25')
	else
		parse('speedmod '..hrpg.races[i][3]..' 10')
	end
	for d=8,#hrpg.races[i] do
		msg2(hrpg.races[i][d],"255255255GO!")
		if carimg[hrpg.races[i][d]]~=0 then
			parse('speedmod '..hrpg.races[i][d]..' 25')
		else
			parse('speedmod '..hrpg.races[i][d]..' 10')
		end
	end
end
function hrpg.race_leave(id)
	for i=1,#hrpg.races do
		if hrpg.races[i][3]==id and hrpg.races[i][1]>1 then
			msg2(id,"255255255Race cancelled - hoster left!")
			racer[id]=0
			spawnplayer(id,78*32+16,179*32+16)
			if hrpg.powerup.image1[id]~=0 then
				freeimage(hrpg.powerup.image1[id])
			end
			if hrpg.powerup.image2[id]~=0 then
				freeimage(hrpg.powerup.image2[id])
			end
			if carimg[id]~=0 then
				parse('speedmod '..id..' 15')
			else
				parse('speedmod '..id..' 0')
			end
			hrpg.powerup.image1[id]=0
			hrpg.powerup.image2[id]=0
			hrpg.powerup.item[id]=0
			hrpg.lap[id]=0
			hrpg.check[id]=0
			freetimer("hrpg.powerup.gen",""..id.."")
			for p=8,#hrpg.races[i] do
				racer[hrpg.races[i][p]]=0
				spawnplayer(hrpg.races[i][p],78*32+16,179*32+16)
				msg2(hrpg.races[i][p],"255255255Race cancelled - hoster left!")
				if hrpg.powerup.image1[hrpg.races[i][p]]~=0 then
					freeimage(hrpg.powerup.image1[hrpg.races[i][p]])
				end
				if hrpg.powerup.image2[hrpg.races[i][p]]~=0 then
					freeimage(hrpg.powerup.image2[hrpg.races[i][p]])
				end
				if carimg[hrpg.races[i][p]]~=0 then
					parse('speedmod '..hrpg.races[i][p]..' 15')
				else
					parse('speedmod '..hrpg.races[i][p]..' 0')
				end
				hrpg.powerup.image1[hrpg.races[i][p]]=0
				hrpg.powerup.image2[hrpg.races[i][p]]=0
				hrpg.powerup.item[hrpg.races[i][p]]=0
				hrpg.lap[hrpg.races[i][p]]=0
				hrpg.check[hrpg.races[i][p]]=0
				freetimer("hrpg.powerup.gen",""..hrpg.races[i][p].."")
			end
			if hrpg.races[i][4]~="Waiting" then
				freetimer("hrpg.startracing1",""..i.."")
				freetimer("hrpg.startracing2",""..i.."")
				freetimer("hrpg.startracing3",""..i.."")
				freetimer("hrpg.startracing4",""..i.."")
				freetimer("hrpg.startracing5",""..i.."")
			end
			table.remove(hrpg.races,i)
			for z=1,32 do
				hudding(2,z)
			end
			return 1
		end
		if hrpg.races[i][3]==id then
			table.remove(hrpg.races,i)
			if carimg[id]~=0 then
				parse('speedmod '..id..' 15')
			else
				parse('speedmod '..id..' 0')
			end
			for z=1,32 do
				hudding(2,z)
			end
			return 1
		end
		if hrpg.races[i][5]=="Waiting" then
			for d=8,#hrpg.races[i] do
				if hrpg.races[i][d]==id then
					table.remove(hrpg.races[i],d)
					hrpg.races[i][1]=hrpg.races[i][1]-1
					for z=1,32 do
						hudding(2,z)
					end
					return 1
				end
			end
		end
		if hrpg.races[i][1]>1 then
			for d=8,#hrpg.races[i] do
				if hrpg.races[i][d]==id then
					table.remove(hrpg.races[i],d)
					hrpg.races[i][1]=hrpg.races[i][1]-1
					racer[id]=0
					spawnplayer(id,78*32+16,179*32+16)
					if hrpg.powerup.image1[id]~=0 then
							freeimage(hrpg.powerup.image1[id])
					end
					if hrpg.powerup.image2[id]~=0 then
						freeimage(hrpg.powerup.image2[id])
					end
					if carimg[id]~=0 then
						parse('speedmod '..id..' 15')
					else
						parse('speedmod '..id..' 0')
					end
					hrpg.powerup.image1[id]=0
					hrpg.powerup.image2[id]=0
					hrpg.powerup.item[id]=0
					hrpg.lap[id]=0
					hrpg.check[id]=0
					freetimer("hrpg.powerup.gen",""..id.."")
					if hrpg.races[i][1]<math.floor(hrpg.races[i][2]/2)+1 then
						local h=hrpg.races[i][3]
						racer[h]=0
						spawnplayer(h,78*32+16,179*32+16)
						msg2(h,"255255255Race cancelled - the majority of the racers left!")
						if hrpg.powerup.image1[h]~=0 then
							freeimage(hrpg.powerup.image1[h])
						end
						if hrpg.powerup.image2[h]~=0 then
							freeimage(hrpg.powerup.image2[h])
						end
						if carimg[h]~=0 then
							parse('speedmod '..h..' 15')
						else
							parse('speedmod '..h..' 0')
						end
						hrpg.powerup.image1[h]=0
						hrpg.powerup.image2[h]=0
						hrpg.powerup.item[h]=0
						hrpg.lap[h]=0
						hrpg.check[h]=0
						freetimer("hrpg.powerup.gen",""..h.."")
						for p=8,#hrpg.races[i] do
							racer[hrpg.races[i][p]]=0
							spawnplayer(hrpg.races[i][p],78*32+16,179*32+16)
							if hrpg.powerup.image1[hrpg.races[i][p]]~=0 then
								freeimage(hrpg.powerup.image1[hrpg.races[i][p]])
							end
							if hrpg.powerup.image2[hrpg.races[i][p]]~=0 then
								freeimage(hrpg.powerup.image2[hrpg.races[i][p]])
							end
							if carimg[hrpg.races[i][p]]~=0 then
								parse('speedmod '..hrpg.races[i][p]..' 15')
							else
								parse('speedmod '..hrpg.races[i][p]..' 0')
							end
							hrpg.powerup.image1[hrpg.races[i][p]]=0
							hrpg.powerup.image2[hrpg.races[i][p]]=0
							hrpg.powerup.item[hrpg.races[i][p]]=0
							hrpg.lap[hrpg.races[i][p]]=0
							hrpg.check[hrpg.races[i][p]]=0
							freetimer("hrpg.powerup.gen",""..hrpg.races[i][p].."")
							msg2(hrpg.races[i][p],"255255255Race cancelled - the majority of the racers left!")
						end
						freetimer("hrpg.startracing1",""..i.."")
						freetimer("hrpg.startracing2",""..i.."")
						freetimer("hrpg.startracing3",""..i.."")
						freetimer("hrpg.startracing4",""..i.."")
						freetimer("hrpg.startracing5",""..i.."")
						table.remove(hrpg.races,i)
					end
					for z=1,32 do
						hudding(2,z)
					end
					return 1
				end
			end
		end
	end
end
function hrpg.powerup.spawn(i)
	local t=0
	for d=1,#hrpg.tracks do
		if hrpg.tracks[d]==hrpg.races[i][4] then
			t=d
		end
	end
	local c=0
	for x=1,#hrpg.powerup.placement[t][1] do
		for o=1,#item(0,"table") do
			if item(item(0,"table")[o],"exists") and item(item(0,"table")[o],"x")==hrpg.powerup.placement[t][1][x] and item(item(0,"table")[o],"y")==hrpg.powerup.placement[t][2][x] then
				c=1
			end
		end
		if c==0 then
			parse("spawnitem 75 "..hrpg.powerup.placement[t][1][x].." "..hrpg.powerup.placement[t][2][x].."")
		else
			c=0
		end
	end
end
function hrpg.powerup.gen(i)
	local id=tonumber(i)
	freeimage(hrpg.powerup.image2[id])
	if racer[id]==1 then
		parse("sv_sound2 "..id.." \"mat5b/powerup_chime.ogg\"")
		hrpg.powerup.item[id]=hrpg.powerup.types[math.random(1,#hrpg.powerup.types)]
		local t=hrpg.commakiller(itemtype(hrpg.powerup.item[id],"name")," ")
		if #t==1 then
			hrpg.powerup.image2[id]=image("gfx/hud/power_"..t[1]..".png",320,462,2,id)
		else
			hrpg.powerup.image2[id]=image("gfx/hud/power_"..t[1]..""..t[2]..".png",320,462,2,id)
		end
	end
end

function hrpg.carappear(i)
	local id=tonumber(i)
	if parkimg[id]~=0 then
		freeimage(parkimg[id])
	end
	parkimg[id]=0
	if carimg[id]~=0 then
		freeimage(carimg[id])
	end
	carimg[id]=0
	if racer[id]==1 then
		parse('speedmod '..id..' 25')
	else
		parse('speedmod '..id..' 15')
	end
	carimg[id]=image(hrpg.carimage,1,0,200+id)
	imagecolor(carimg[id],hrpg.colors[id][1],hrpg.colors[id][2],hrpg.colors[id][3])
end
function hrpg.cardisappear(i)
	local id=tonumber(i)
	if parkimg[id]~=0 then
		freeimage(parkimg[id])
	end
	parkimg[id]=image(hrpg.carimage,player(id,"x"),player(id,"y"),1)
	imagepos(parkimg[id],player(id,"x"),player(id,"y"),player(id,"rot"))
	if carimg[id]==0 then
		imagescale(parkimg[id],0,0)
		tween_scale(parkimg[id],1000,1,1)
	end
	if carimg[id]~=0 then
		freeimage(carimg[id])
	end
	carimg[id]=0
	imagecolor(parkimg[id],hrpg.colors[id][1],hrpg.colors[id][2],hrpg.colors[id][3])
	if racer[id]==0 then
		parse('speedmod '..id..' 0')
	else
		parse('speedmod '..id..' 10')
	end
end

function hrpg.use(id,e,d,x,y)
	local plc=0
	if hrpg.fight[id]~=0 then
		return 1
	end
	if racer[id]==1 then
		if hrpg.powerup.item[id]==65 then
			parse("speedmod "..id.." 30")
			parse('effect "flare" '..player(id,"x")..' '..player(id,"y")..' 1 1 0 '..math.random(0,255)..' 0')
			if carimg[id]~=0 then
				timer(1000,"parse","speedmod "..id.." 25")
			else
				timer(1000,"parse","speedmod "..id.." 15")
			end
		elseif hrpg.powerup.item[id]==77 then
			parse("equip "..id.." 77")
			parse('effect "flare" '..player(id,"x")..' '..player(id,"y")..' 1 3 0 0 '..math.random(125,255)..'')
			parse("setweapon "..id.." 77")
		elseif hrpg.powerup.item[id]==45 then
			parse("equip "..id.." 45")
			parse('effect "flare" '..player(id,"x")..' '..player(id,"y")..' 1 3 '..math.random(125,255)..' 0 0')
			parse("setweapon "..id.." 45")
		elseif hrpg.powerup.item[id]==64 then
			parse("speedmod "..id.." 40")
			parse('effect "flare" '..player(id,"x")..' '..player(id,"y")..' 1 1 0 '..math.random(125,255)..' 0')
			if carimg[id]~=0 then
				timer(1500,"parse","speedmod "..id.." 25")
			else
				timer(1500,"parse","speedmod "..id.." 15")
			end
		elseif hrpg.powerup.item[id]==69 then
			parse("equip "..id.." 69")
			parse('effect "flare" '..player(id,"x")..' '..player(id,"y")..' 1 3 '..math.random(125,255)..' '..math.random(125,255)..' 0')
			parse("setweapon "..id.." 69")
		elseif hrpg.powerup.item[id]==52 then
			parse("equip "..id.." 52")
			parse('effect "flare" '..player(id,"x")..' '..player(id,"y")..' 1 3 255 255 255')
			parse("setweapon "..id.." 52")
		elseif hrpg.powerup.item[id]==51 then
			parse("equip "..id.." 51")
			parse('effect "flare" '..player(id,"x")..' '..player(id,"y")..' 1 3 '..math.random(25,125)..' '..math.random(25,125)..' '..math.random(25,125)..'')
			parse("setweapon "..id.." 51")
		end
		if hrpg.powerup.item[id]~=0 then
			hrpg.powerup.item[id]=0
			freeimage(hrpg.powerup.image2[id])
			hrpg.powerup.image2[id]=0
			plc=1
		end
		return 1
	end
	if id==challenger and x==59 and y==162 then
		if wid==0 or wid==74 then
			if challenger~=0 and challenging~=0 and challenger~=challenging then
				menu(challenger,translate(id,"Weapon type")..",Deagle,Machete,Knife,Random rifle,Random explosive,Random machine gun,Overall random")
				return 1
			end
		end
		if wid~=0 and wid~=74 and rules=="" and challenger~=0 and challenging~=0 and challenger~=challenging then
			if challenger~=0 and challenging~=0 and challenger~=challenging then
				menu(challenger,translate(id,"Fight rules")..",First blood,Best of 3,First to 5,1 minute fest")
				return 1
			end
		end
		return 1
	end
	if x==76 and y==162 and plc==0 then
		if challenger==0 or challenger==nil or not player(challenger,"exists") then
			challenger=id
			if carimg[id]~=0 then
				hrpg.cardisappear(id)
			end
			parse("speedmod "..id.." 0")
			spawnplayer(id,60*32+16,162*32+16)
			cfight=""..player(challenger,"name").." is waiting for an opponent!"
			for z=1,32 do
				hudding(1,z)
			end
			plc=1
		elseif challenging==0 or not player(challenging,"exists") then
			challenging=id
			if carimg[id]~=0 then
				hrpg.cardisappear(id)
			end
			parse("speedmod "..id.." 0")
			spawnplayer(id,73*32+16,162*32+16)
			cfight=""..player(challenger,"name").." is choosing the weapon type!"
			menu(challenger,translate(id,"Weapon type")..",Deagle,Machete,Knife,Random rifle,Random explosive,Random machine gun,Overall random")
			for z=1,32 do
				hudding(1,z)
			end
			plc=1
		else
			msg2(id,"255255255"..translate(id,"You can't join - the arena is full!"))
		end
		if challenger==challenging then
			spawnplayer(challenger,77*32+16,162*32+16)
			wid=74
			score1=0
			score2=0
			challenger=0
			challenging=0
			rules=""
			tim=0
			time2=0
			cfight="None"
			for z=1,32 do
				hudding(1,z)
			end
		end
		return 1
	elseif x==76 and y==179 and plc==0 then
		if #hrpg.races>0 then
			for d=1,#hrpg.races do
				if hrpg.races[d][3]==id then
					table.remove(hrpg.races,hrpg.placeh[id])
					hrpg.placeh[id]=0
				end
			end
		end
		menu(id,translate(id,"Racing")..","..translate(id,"Host")..","..translate(id,"Join").." | "..#hrpg.races.." "..translate(id,"available"))
		return 1
	elseif x==114 and y==177 then
		--[[if hrpg.hazard.easy==0 then
			hrpg.hazard.easy=id
			spawnplayer(id,blah,blah)
			parse("equip "..id.." 41")
			parse("setweapon "..id.." 41")
			parse("setarmor "..id.." 203")
			msg2(id,"255255255Good luck!")
			msg2(id,"255255255If you want to leave the course press F2.")
			hrpg.hazard.gen("easy")
		else
			msg2(id,"25525525This course is full!")
		end--]]
		--msg2(id,"255255255Sorry, but this activity is not done yet!")
		return 1
	elseif x==94 and y==184 then
		if carimg[id]~=0 then
			hrpg.cardisappear(id)
		end
		setpos(id,95*32+16,180*32+16)
		return 1
	elseif x==95 and y==182 then
		if carimg[id]~=0 then
			hrpg.cardisappear(id)
		end
		setpos(id,95*32+16,186*32+16)
		return 1
	elseif (x==169 and y==104) or (x==21 and y==104) or (x==74 and y==162) then
		hrpg.serveraction(id,1)
		return 1
	end
	if e~=0 then
		return 1
	end
	if player(id,"speedmod")==-60 and plc==0 then
		if carimg[id]~=0 then
			parse('speedmod '..id..' 15')
		else
			parse('speedmod '..id..' 0')
		end
		if hrpg.darkness[id]~=0 then
			freeimage(hrpg.darkness[id])
		end
		plc=1
		return 1
	end
	for s=1,#hrpg.furn.id do
		if hrpg.furn.id[s]~=nil and hrpg.furn.type[s]~=7 and player(id,"tilex")>=object(hrpg.furn.id[s],"tilex")-hrpg.furn.size[s][1]+math.floor(hrpg.furn.size[s][1]/2)+1 and player(id,"tilex")<=object(hrpg.furn.id[s],"tilex")+hrpg.furn.size[s][1]-math.floor(hrpg.furn.size[s][1]/2)-1 and player(id,"tiley")>=object(hrpg.furn.id[s],"tiley")-hrpg.furn.size[s][2]+math.floor(hrpg.furn.size[s][2]/2)+1 and player(id,"tiley")<=object(hrpg.furn.id[s],"tiley")+hrpg.furn.size[s][2]-math.floor(hrpg.furn.size[s][2]/2)-1 then
			hrpg.furn.used(id,s)
			plc=1
			break
		end
	end
	if player(id,"tilex")>=36 and player(id,"tilex")<=42 and player(id,"tiley")>=49 and player(id,"tiley")<=55 then
		hrpg.shop.being[id]=1
		hrpg.shop.menu(id)
		return 1
	elseif player(id,"tilex")>=148 and player(id,"tilex")<=154 and player(id,"tiley")>=49 and player(id,"tiley")<=55 then
		hrpg.shop.being[id]=2
		hrpg.shop.menu(id)
		return 1
	elseif player(id,"tilex")>=36 and player(id,"tilex")<=42 and player(id,"tiley")>=87 and player(id,"tiley")<=93 then
		hrpg.shop.being[id]=3
		hrpg.shop.menu(id)
		return 1
	elseif player(id,"tilex")>=148 and player(id,"tilex")<=154 and player(id,"tiley")>=87 and player(id,"tiley")<=93 then
		hrpg.shop.being[id]=4
		hrpg.shop.menu(id)
		return 1
	end
	if id~=challenger and id~=challenging and plc==0 and player(id,"speedmod")>-50 then
		if parkimg[id]~=0 then
			if player(id,"tilex")>=object(parkimg[id],"tilex")-1 and player(id,"tilex")<=object(parkimg[id],"tilex")+1 and player(id,"tiley")>=object(parkimg[id],"tiley")-1 and player(id,"tiley")<=object(parkimg[id],"tiley")+1 then
				tween_move(parkimg[id],500,player(id,"x"),player(id,"y"),player(id,"rot"))
				tween_color(parkimg[id],500,hrpg.colors[id][1],hrpg.colors[id][2],hrpg.colors[id][3])	
				if player(id,"speedmod")>-50 then
					parse("speedmod "..id.." -100")
					timer(500,"hrpg.carappear",""..id.."")
				end
			end
		else
			if carimg[id]==0 and parkimg[id]==0 then
				hrpg.carappear(id)
				imagescale(carimg[id],0,0)
				tween_scale(carimg[id],500,1,1)
				return 1
			end
			if player(id,"speedmod")>-50 then
				parse("speedmod "..id.." -100")
				timer(500,"hrpg.cardisappear",""..id.."")
			end
		end
	end
end
function hrpg.furn.used(id,s) -- id - player, s - furniture id
	if hrpg.furn.type[s]==1 then
		parse("equip "..id.." "..hrpg.furn.var[s].."")
		local typ=hrpg.furn.var[s]
		if typ~=64 and typ~=61 and typ~=62 and typ~=65 and typ~=70 and typ~=71 and typ~=66 and typ~=67 and typ~=68 then
			parse("setweapon "..id.." "..typ.."")
		end
		parse("sv_sound2 "..id.." \"items/pickup.wav\"")
		hrpg.furn.kill(s)
		hrpg.item_add(id,itemtype(typ,"name"),1)
	elseif hrpg.furn.type[s]==2 or hrpg.furn.type[s]==10 then
		if player(id,"speedmod")>-50 then
			parse("speedmod "..id.." -60")
			if hrpg.furn.type[s]==2 then
				parse("setpos "..id.." "..(player(id,"tilex")*32+16).." "..(player(id,"tiley")*32+16).."")
			else
				if hrpg.furn.var[s]=="Throne" then	
					parse("setpos "..id.." "..object(hrpg.furn.id[s],"x").." "..object(hrpg.furn.id[s],"y").."")
				end
			end
		else
			if carimg[id]~=0 then
				parse('speedmod '..id..' 15')
			else
				parse('speedmod '..id..' 0')
			end
		end
	elseif hrpg.furn.type[s]==4 then
		if tonumber(hrpg.furn.img[s])==nil then
			for t=1,#hrpg.furniture do
				if hrpg.furn.img[s]==hrpg.furn.images[t] then
					local f=hrpg.furn.img[s]
					local r=0
					hrpg.furn.img[s]=image(f,object(hrpg.furn.id[s],"tilex")*32+16,object(hrpg.furn.id[s],"tiley")*32+16,r)
					imageblend(hrpg.furn.img[s],1)
					imagealpha(hrpg.furn.img[s],0)
					if hrpg.furniture[t]=="Lamp" then
						imagecolor(hrpg.furn.img[s],235,235,0)
					else
						if hrpg.furniture[t]=="TV" then
							imagepos(hrpg.furn.img[s],object(hrpg.furn.id[s],"tilex")*32+16,object(hrpg.furn.id[s],"tiley")*32+16,object(hrpg.furn.id[s],"rot"))
							timer(1000,"hrpg.furn.tvimg",""..s.."")
						end
						imagecolor(hrpg.furn.img[s],hrpg.clrtb[math.random(1,#hrpg.clrtb)],hrpg.clrtb[math.random(1,#hrpg.clrtb)],hrpg.clrtb[math.random(1,#hrpg.clrtb)])
					end
					tween_alpha(hrpg.furn.img[s],100,1)
				end
			end
		else
			freeimage(hrpg.furn.img[s])
			for t=1,#hrpg.furniture do
				if hrpg.furniture[t]==hrpg.furn.var[s] then
					if hrpg.furn.var[s]=="TV" then
						freetimer("hrpg.furn.tvimg",""..s.."")
					end
					hrpg.furn.img[s]=hrpg.furn.images[t]
				end
			end
		end
	elseif hrpg.furn.type[s]==5 and player(id,"speedmod")~=-60 then
		if (hrpg.time<=hrpg.length/2 and hrpg.time>0) or (hrpg.time<0 and hrpg.time<=-(hrpg.length-(hrpg.length/4))) then
			parse("speedmod "..id.." -60")
			parse("setpos "..id.." "..(object(hrpg.furn.id[s],"tilex")*32+16).." "..(object(hrpg.furn.id[s],"tiley")*32+16).."")
			if hrpg.darkness[id]~=0 then
				freeimage(hrpg.darkness[id])
			end
			hrpg.darkness[id]=image("gfx/Houses RPG/night.png",0,0,2,id)
			imagescale(hrpg.darkness[id],50,50)
			imagealpha(hrpg.darkness[id],0)
			tween_alpha(hrpg.darkness[id],5000,0.95)
			freetimer("hrpg.furn.bed")
			timer(5000,"hrpg.furn.bed")
		else
			msg2(id,"255255255You can only sleep at night!")
		end
	elseif hrpg.furn.type[s]==8 then
		if player(id,"health")<player(id,"maxhealth") then
			if hrpg.furn.var[s]=="Medkit" then
				parse("sethealth "..id.." "..player(id,"health")+100)
			elseif hrpg.furn.var[s]=="Band-aid" then
				parse("sethealth "..id.." "..player(id,"health")+100)
			else
				hrpg.item_add(id,hrpg.furn.var[s],1)
			end
		else
			hrpg.item_add(id,hrpg.furn.var[s],1)
		end
		hrpg.furn.kill(s)
		parse("sv_sound2 "..id.." \"items/pickup.wav\"")
	elseif hrpg.furn.type[s]==11 then
		hrpg.item_add(id,hrpg.furn.var[s],1)
		hrpg.furn.kill(s)
		parse("sv_sound2 "..id.." \"items/pickup.wav\"")
	end
end
function hrpg.furn.bed()
	local count=0
	for p=1,#player(0,"tableliving") do
		if player(player(0,"tableliving")[p],"speedmod")==-60 then
			count=count+1
		end
	end
	if count==#player(0,"tableliving") then
		for p=1,#player(0,"tableliving") do
			if hrpg.darkness[player(0,"tableliving")[p]]~=0 then
				freeimage(hrpg.darkness[player(0,"tableliving")[p]])
				if carimg[player(0,"tableliving")[p]]~=0 then
					parse('speedmod '..player(0,"tableliving")[p]..' 15')
				else
					parse('speedmod '..player(0,"tableliving")[p]..' 0')
				end
			end
		end
		freetimer("hrpg.cyclereset","tomoon")
		freetimer("hrpg.cyclereset","tosun")
		freetimer("hrpg.shop.restock")
		hrpg.cyclereset("tomoon")
		if #hrpg.mob.id~=0 then
			hrpg.mob.wipe()
		end
		hrpg.shop.restock()
	end
end
function hrpg.furn.tvimg(i)
	local id=tonumber(i)
	imagecolor(hrpg.furn.img[id],hrpg.clrtb[math.random(1,#hrpg.clrtb)],hrpg.clrtb[math.random(1,#hrpg.clrtb)],hrpg.clrtb[math.random(1,#hrpg.clrtb)])
	timer(math.random(1,10)*100,"hrpg.furn.tvimg",i)
end

function hrpg.walkover(id,iid,typ)
	local c=0
	if racer[id]==0 then
		for w=1,#playerweapons(id) do
			if playerweapons(id)[w]==typ then
				c=1
				break
			end
		end
		if id==challenger or id==challenging then
			return 1
		end
		if c==0 and typ~=75 and typ~=74 and t~=50 and typ~=70 and typ~=71 and typ~=79 and typ~=80 and typ~=81 and typ~=82 and typ~=83 and typ~=84 and typ~=56 and typ~=55 and typ~=58 and typ~=57 and typ~=61 and typ~=62 then
			parse("equip "..id.." "..typ.."")
			parse("sv_sound2 "..id.." \"items/pickup.wav\"")
			parse("removeitem "..iid)
			if typ~=66 and typ~=67 and typ~=68 then
				hrpg.item_add(id,itemtype(typ,"name"),1)
			end
			if typ~=64 and typ~=61 and typ~=62 and typ~=65 and typ~=70 and typ~=71 and typ~=66 and typ~=67 and typ~=68 then
				parse("setweapon "..id.." "..typ.."")
			end
			return 1
		else
			return 0
		end
	else
		if typ==75 then
			if hrpg.powerup.image1[id]==0 then
				hrpg.powerup.image1[id]=image("gfx/hud/powerup.png",320,300,2,id)
				imagescale(hrpg.powerup.image1[id],0,0)
				tween_scale(hrpg.powerup.image1[id],500,1,1)
				tween_move(hrpg.powerup.image1[id],500,320,455)
				imagecolor(hrpg.powerup.image1[id],math.random(125,255),math.random(125,255),math.random(125,255))
				hrpg.powerup.image2[id]=image("gfx/hud/unknown.png",320,300,2,id)
				imagescale(hrpg.powerup.image2[id],0,0)
				tween_scale(hrpg.powerup.image2[id],500,1,1)
				tween_move(hrpg.powerup.image2[id],500,320,462)
				imagecolor(hrpg.powerup.image2[id],math.random(125,255),math.random(125,255),math.random(125,255))
				timer(3000,"hrpg.powerup.gen",""..id.."")
			else
				if hrpg.powerup.item[id]==0 and hrpg.powerup.image2[id]==0 then
					hrpg.powerup.image2[id]=image("gfx/hud/unknown.png",320,462,2,id)
					imagecolor(hrpg.powerup.image2[id],math.random(125,255),math.random(125,255),math.random(125,255))
					timer(3000,"hrpg.powerup.gen",""..id.."")
				end
			end
			parse("strip "..id.." 75")
			parse("sv_sound2 "..id.." \"items/pickup.wav\"")
			parse("removeitem "..iid)
			return 1
		end
	end
end

function hrpg.say(id,txt)
	if namch[id]==1 then
		namch[id]=0
		hrpg.names[myh[id]]=txt
		msg2(id,"255255255"..translate(id,"Okay, your house has now the name").." "..txt..".")
		return 1
	end
	if hrpg.namechange[id]==1 then
		if tonumber(txt)~=nil then
			hrpg.colors[id][1]=tonumber(txt)
			msg2(id,"255255255And now how much green colour would you like to have on your car (0-250).")
			hrpg.namechange[id]=2
		else
			msg2(id,"255255255I'm sorry, but that's an invalid number. Try again.")
		end
		return 1
	elseif hrpg.namechange[id]==2 then
		if tonumber(txt)~=nil then
			hrpg.colors[id][2]=tonumber(txt)
			msg2(id,"255255255Finally, how much blue colour would you like to have on your car (0-250).")
			hrpg.namechange[id]=3
		else
			msg2(id,"255255255I'm sorry, but that's an invalid number. Try again.")
		end
		return 1
	elseif hrpg.namechange[id]==3 then
		if tonumber(txt)~=nil then
			hrpg.colors[id][3]=tonumber(txt)
			msg2(id,"255255255Thank you, your car is now coloured accordingly to your will.")
			if parkimg[id]~=0 then
				tween_color(parkimg[id],1000,hrpg.colors[id][1],hrpg.colors[id][2],hrpg.colors[id][3])
			else
				tween_color(carimg[id],1000,hrpg.colors[id][1],hrpg.colors[id][2],hrpg.colors[id][3])
			end
			hrpg.namechange[id]=0
		else
			msg2(id,"255255255I'm sorry, but that's an invalid number. Try again.")
		end
		return 1
	elseif hrpg.namechange[id]==4 then
		if tonumber(txt)~=nil then
			hrpg.furn.color[hrpg.placeh[id]][1]=tonumber(txt)
			msg2(id,"255255255And now how much green colour would you like to have on your furniture (0-250).")
			hrpg.namechange[id]=5
		else
			msg2(id,"255255255I'm sorry, but that's an invalid number. Try again.")
		end
		return 1
	elseif hrpg.namechange[id]==5 then
		if tonumber(txt)~=nil then
			hrpg.furn.color[hrpg.placeh[id]][2]=tonumber(txt)
			msg2(id,"255255255Finally, how much blue colour would you like to have on your furniture (0-250).")
			hrpg.namechange[id]=6
		else
			msg2(id,"255255255I'm sorry, but that's an invalid number. Try again.")
		end
		return 1
	elseif hrpg.namechange[id]==6 then
		if tonumber(txt)~=nil then
			hrpg.furn.color[hrpg.placeh[id]][3]=tonumber(txt)
			msg2(id,"255255255Thank you, your furniture is now coloured accordingly to your will.")
			tween_color(hrpg.furn.id[hrpg.placeh[id]],1000,hrpg.furn.color[hrpg.placeh[id]][1],hrpg.furn.color[hrpg.placeh[id]][2],hrpg.furn.color[hrpg.placeh[id]][3])
			hrpg.item_remove(id,hrpg.page[id])
			hrpg.namechange[id]=0
			hrpg.placeh[id]=0
			hrpg.page[id]=0
		else
			msg2(id,"255255255I'm sorry, but that's an invalid number. Try again.")
		end
		return 1
	end
	if txt=="!help" then
		msg2(id,"255255255New to Houses RPG? This is a map where EVERYBODY can get a house for FREE!")
		msg2(id,"255255255All you have to do, is open up the House Menu with the first serveraction key (F2 by default).")
		msg2(id,"255255255And from that point everything will be very simple to understand! Have fun!")
		msg2(id,"255255255Your goal is to reach level "..hrpg.maxlevel.."!")
		msg2(id,"255255255Say !commands to know the say commands on this map!")
		msg2(id,"255255255Press the use key (default is E) to: Spawn a car, get into your car,")
		msg2(id,"255255255park your car, talk to a shopkeeper (near him), use furniture, pick up items")
		return 1
	elseif txt=="!menu" then
		hrpg.serveraction(id,1)
		return 1
	elseif txt=="!car" then
		if carimg[id]==0 then
			if parkimg[id]==0 then
				carimg[id]=image(hrpg.carimage,1,0,200+id)
				imagescale(carimg[id],0,0)
				tween_scale(carimg[id],1000,1,1)
				imagecolor(carimg[id],hrpg.colors[id][1],hrpg.colors[id][2],hrpg.colors[id][3])
				if racer[id]==0 then
					parse('speedmod '..id..' 15')
				else
					parse('speedmod '..id..' 25')
				end
			else
				if player(id,"tilex")>=object(parkimg[id],"tilex")-1 and player(id,"tilex")<=object(parkimg[id],"tilex")+1 and player(id,"tiley")>=object(parkimg[id],"tiley")-1 and player(id,"tiley")<=object(parkimg[id],"tiley")+1 then
					tween_move(parkimg[id],500,player(id,"x"),player(id,"y"),player(id,"rot"))
					tween_color(parkimg[id],500,hrpg.colors[id][1],hrpg.colors[id][2],hrpg.colors[id][3])	
					if player(id,"speedmod")>-50 then
						parse("speedmod "..id.." -100")
						timer(500,"hrpg.carappear",""..id.."")
					end
				end
			end
		else
			msg2(id,"255255255"..translate(id,"You already have a car!"))
		end
		return 1
	elseif txt=="!park" then
		if parkimg[id]==0 then
			parse("speedmod "..id.." -100")
			timer(500,"hrpg.cardisappear",""..id.."")
		else
			msg2(id,"255255255"..translate(id,"Your car is already parked!"))
		end
		return 1
	elseif txt=="!commands" then
		msg2(id,"255255255These are the say commands:")
		msg2(id,"255255255!menu - opens the HRPG menu")
		msg2(id,"255255255!money - learn how to earn money")
		msg2(id,"255255255!time - know what time of day it is ingame")
		msg2(id,"255255255!fights - know how and when to fight monsters during the night")
		msg2(id,"255255255!queue - know what items are waiting for you to make space in your inventory")
		msg2(id,"255255255!level <ID> - check a player's level")
		return 1
	elseif txt=="!fights" then
		msg2(id,"255255255When you come up too close to a monster it will start attacking you in pure classic RPG style!")
		msg2(id,"255255255Once in battle, you can do one of 4 things: Attack, Defend, Inventory, and Run")
		msg2(id,"255255255To do something, just click on the square with the mentioned action on it.")
		msg2(id,"255255255You can only do something while it's your turn though. One action = one turn. If you see an")
		msg2(id,"255255255overlevelled monster (2+ levels higher than you) then RUN. Otherwise Attack, or Defend depending on the")
		msg2(id,"255255255situation. If you have bought Battle items you can use them using Inventory.")
		msg2(id,"255255255Time your hits with the beat of the music to make combos!")
		msg2(id,"255255255Use non-melee weapons to deal more damage!")
		return 1
	elseif txt=="!money" then
		msg2(id,"255255255There are a few ways to earn money:")
		msg2(id,"255255255Quests - Open the quest menu (F2 > 7), choose a quest and complete it to gain money (or a bonus).")
		msg2(id,"255255255Race - Go to the race lobby organizer and use it to win a race with other players.")
		msg2(id,"255255255Arena - Go to the arena (straight down) and fight an other money thirsty player for money.")
		msg2(id,"255255255Bank - use the House Menu (F2 > 4 > 1) to borrow money from the bank.")
		msg2(id,"255255255Fights - fight monsters during nighttime and they'll drop money.")
		return 1
	elseif txt=="!time" then
		if hrpg.time>0 then
			if math.floor((math.abs(hrpg.time/1000)/60))~=1 then
				msg2(id,"255255255The time is "..math.abs(hrpg.time/1000).." seconds (about "..math.floor((math.abs(hrpg.time/1000)/60)).." minutes) until midnight.")
			else
				msg2(id,"255255255The time is "..math.abs(hrpg.time/1000).." seconds (about 1 minute) until midnight.")
			end
		elseif hrpg.time<0 then
			if math.floor((math.abs(hrpg.time/1000)/60))~=1 then
				msg2(id,"255255255The time is "..math.abs(hrpg.time/1000).." seconds (around "..math.floor((math.abs(hrpg.time/1000)/60)).." minutes) until midday.")
			else
				msg2(id,"255255255The time is "..math.abs(hrpg.time/1000).." seconds (around 1 minute) until midday.")
			end
		end
		return 1
	elseif txt=="!queue" then
		if #hrpg.item_queue[id]~=0 then
			if #hrpg.item_queue[id]==1 then
				msg2(id,"255255255The only item in your item queue is a/an "..hrpg.item_queue[id][1]..".")
			else
				msg2(id,"255255255There is a total of "..#hrpg.item_queue[id].." items in your item queue.")
				msg2(id,"255255255The first one is a/an "..hrpg.item_queue[id][1].." and the last one is a/an "..hrpg.item_queue[id][#hrpg.item_queue[id]]..".")
			end
		else
			msg2(id,"255255255There are no items in your item queue!")
		end
		return 1
	elseif txt:sub(1,6)=="!level" then
		local i=tonumber(txt:sub(8,8))
		if i~=nil and i~=0 and i>0 and i<33 then
			msg2(id,"255255255"..player(i,"name").."'s level is "..hrpg.level[i]..".")
		else
			msg2(id,"255255255Invalid player ID.")
		end
		return 1
	elseif txt=="!credits" then
		msg2(id,"255255255Houses RPG by BetaM / mat5b")
		msg2(id,"255255255Thanks to all of the testers, especially:")
		msg2(id,"255255255vengador, >>[S.T.R.E] Bill, NEWSDAVID, J,")
		msg2(id,"255255255toyip, konrad573, -Clanheart<3-Dr. Camper, and iPoop")
		return 1
	elseif txt:find("hi") or txt:find("HI") or txt:find("Hi") or txt:find("Hello") or txt:find("hello") and #txt<7 then
		if player(id,"tilex")>=36 and player(id,"tilex")<=42 and player(id,"tiley")>=49 and player(id,"tiley")<=55 then
			hrpg.shop.being[id]=1
			hrpg.shop.menu(id)
			msg2(id,"255255255Shopkeeper: Next time just press E near me to talk to me. Appreciate the greeting though!")
			return 1
		elseif player(id,"tilex")>=148 and player(id,"tilex")<=154 and player(id,"tiley")>=49 and player(id,"tiley")<=55 then
			hrpg.shop.being[id]=2
			hrpg.shop.menu(id)
			msg2(id,"255255255Shopkeeper: Next time just press E near me to talk to me. Appreciate the greeting though!")
			return 1
		elseif player(id,"tilex")>=36 and player(id,"tilex")<=42 and player(id,"tiley")>=87 and player(id,"tiley")<=93 then
			hrpg.shop.being[id]=3
			hrpg.shop.menu(id)
			msg2(id,"255255255Shopkeeper: Next time just press E near me to talk to me. Appreciate the greeting though!")
			return 1
		elseif player(id,"tilex")>=148 and player(id,"tilex")<=154 and player(id,"tiley")>=87 and player(id,"tiley")<=93 then
			hrpg.shop.being[id]=4
			hrpg.shop.menu(id)
			msg2(id,"255255255Shopkeeper: Next time just press E near me to talk to me. Appreciate the greeting though!")
			return 1
		end
	end
	if hrpg.allow_mapmaker_chat and tonumber(player(id,"usgn"))==8235 and txt~="rank" then
		local tm={"T","CT"}
		if player(id,"team")>0 then
			msg(""..math.random(100,255)..""..math.random(100,255)..""..math.random(100,255).."["..tm[player(id,"team")].."] BetaM (Map maker): "..txt)
		else
			msg(""..math.random(100,255)..""..math.random(100,255)..""..math.random(100,255).."[Spec] BetaM (Map maker): "..txt)
		end
		return 1
	end
end

function hrpg.movetile(id,x,y)
	if racer[id]==1 then
		if entity(x,y,"type")==11 then
			local c=0
			for i=1,#hrpg.races do
				for d=8,#hrpg.races[i] do
					if hrpg.races[i][d]==id then
						spawnplayer(id,78*32+16,179*32+16)
						won(id,0)
						if carimg[id]~=0 then
							parse("speedmod "..id.." 0")
						else
							parse("speedmod "..id.." 15")
						end
						c=d
						break
					end
				end
				if hrpg.races[i][3]==id and c==0 then
					spawnplayer(id,78*32+16,179*32+16)
					won(id,0)
					if carimg[id]~=0 then
						parse("speedmod "..id.." 0")
					else
						parse("speedmod "..id.." 15")
					end
					c=3
				end
				if c>0 then
					msg("255255255The race hosted by "..player(hrpg.races[i][3],"name").." on "..hrpg.races[i][4].." is over! The winner is "..player(id,"name").."!")	
					if c~=3 then
						msg2(hrpg.races[i][3],"255255255You didn't win, so you don't get any money.")
						spawnplayer(hrpg.races[i][3],78*32+16,179*32+16)
						if carimg[hrpg.races[i][3]]~=0 then
							parse("speedmod "..hrpg.races[i][3].." 0")
						else
							parse("speedmod "..hrpg.races[i][3].." 15")
						end
						if hrpg.powerup.image1[hrpg.races[i][3]]~=0 then
							freeimage(hrpg.powerup.image1[hrpg.races[i][3]])
						end
						if hrpg.powerup.image2[hrpg.races[i][3]]~=0 then
							freeimage(hrpg.powerup.image2[hrpg.races[i][3]])
						end
						hrpg.powerup.image1[hrpg.races[i][3]]=0
						hrpg.powerup.image2[hrpg.races[i][3]]=0
						hrpg.powerup.item[hrpg.races[i][3]]=0
						freetimer("hrpg.powerup.gen",""..hrpg.races[i][3].."")
					end
					racer[id]=0
					if hrpg.powerup.image1[id]~=0 then
						freeimage(hrpg.powerup.image1[id])
					end
					if hrpg.powerup.image2[id]~=0 then
						freeimage(hrpg.powerup.image2[id])
					end
					hrpg.powerup.image1[id]=0
					hrpg.powerup.image2[id]=0
					hrpg.powerup.item[id]=0
					if carimg[id]~=0 then
						parse("speedmod "..id.." 0")
					else
						parse("speedmod "..id.." 15")
					end
					freetimer("hrpg.powerup.gen",""..id.."")
					racer[hrpg.races[i][3]]=0
					for k=8,#hrpg.races[i] do
						racer[hrpg.races[i][k]]=0
						if k~=c then
							msg2(hrpg.races[i][k],"255255255You didn't win, so you don't get anything.")
							spawnplayer(hrpg.races[i][k],78*32+16,179*32+16)
							if hrpg.powerup.image1[hrpg.races[i][k]]~=0 then
								freeimage(hrpg.powerup.image1[hrpg.races[i][k]])
							end
							if hrpg.powerup.image2[hrpg.races[i][k]]~=0 then
								freeimage(hrpg.powerup.image2[hrpg.races[i][k]])
							end
							hrpg.powerup.image1[hrpg.races[i][k]]=0
							hrpg.powerup.image2[hrpg.races[i][k]]=0
							hrpg.powerup.item[hrpg.races[i][k]]=0
							if carimg[hrpg.races[i][k]]~=0 then
								parse("speedmod "..hrpg.races[i][k].." 0")
							else
								parse("speedmod "..hrpg.races[i][k].." 15")
							end
							freetimer("hrpg.powerup.gen",""..hrpg.races[i][k].."")
						end
					end
					freetimer("hrpg.startracing1",""..i.."")
					freetimer("hrpg.startracing2",""..i.."")
					freetimer("hrpg.startracing3",""..i.."")
					freetimer("hrpg.startracing4",""..i.."")
					freetimer("hrpg.startracing5",""..i.."")
					table.remove(hrpg.races,i)
					for z=1,32 do
						hudding(2,z)
					end
					break
				end
			end
		elseif entity(x,y,"type")==12 then
			if hrpg.check[id]==3 then
				hrpg.check[id]=0
				hrpg.lap[id]=hrpg.lap[id]+1
				for i=1,#hrpg.races do
					if hrpg.races[i][3]==id then
						hrpg.powerup.spawn(i)
					end
					for p=8,#hrpg.races[i] do
						if hrpg.races[i][p]==id then
							hrpg.powerup.spawn(i)
						end
					end
				end
				if hrpg.lap[id]<hrpg.maxlaps then
					msg2(id,"255255255Lap "..hrpg.lap[id]+1)
				else
					msg2(id,"255255255Final Lap!")
				end
				if hrpg.lap[id]==hrpg.maxlaps+1 then
					local c=0
					for i=1,#hrpg.races do
						for d=8,#hrpg.races[i] do
							if hrpg.races[i][d]==id then
								spawnplayer(id,78*32+16,179*32+16)
								if carimg[id]~=0 then
									parse("speedmod "..id.." 0")
								else
									parse("speedmod "..id.." 15")
								end
								won(id,0)
								c=d
							end
						end
						if hrpg.races[i][3]==id then
							spawnplayer(id,78*32+16,179*32+16)
							if carimg[id]~=0 then
								parse("speedmod "..id.." 0")
							else
								parse("speedmod "..id.." 15")
							end
							won(id,0)
							c=3
						end
						if c>0 then
							msg("255255255The race hosted by "..player(hrpg.races[i][3],"name").." on "..hrpg.races[i][4].." is over! The winner is "..player(id,"name").."!")	
							if c~=3 then
								msg2(hrpg.races[i][3],"255255255You didn't win, so you don't get any money.")
								spawnplayer(hrpg.races[i][3],78*32+16,179*32+16)
								if hrpg.powerup.image1[hrpg.races[i][3]]~=0 then
									freeimage(hrpg.powerup.image1[hrpg.races[i][3]])
								end
								if hrpg.powerup.image2[hrpg.races[i][3]]~=0 then
									freeimage(hrpg.powerup.image2[hrpg.races[i][3]])
								end
								if carimg[hrpg.races[i][3]]~=0 then
									parse("speedmod "..hrpg.races[i][3].." 0")
								else
									parse("speedmod "..hrpg.races[i][3].." 15")
								end
								hrpg.powerup.image1[hrpg.races[i][3]]=0
								hrpg.powerup.image2[hrpg.races[i][3]]=0
								hrpg.powerup.item[hrpg.races[i][3]]=0
								hrpg.lap[hrpg.races[i][3]]=0
								hrpg.check[hrpg.races[i][3]]=0
								freetimer("hrpg.powerup.gen",""..hrpg.races[i][3].."")
							end
							racer[id]=0
							if hrpg.powerup.image1[id]~=0 then
								freeimage(hrpg.powerup.image1[id])
								freeimage(hrpg.powerup.image2[id])
							end
							hrpg.powerup.image1[id]=0
							hrpg.powerup.image2[id]=0
							hrpg.powerup.item[id]=0
							hrpg.lap[id]=0
							hrpg.check[id]=0
							racer[hrpg.races[i][3]]=0
							for k=8,#hrpg.races[i] do
								racer[hrpg.races[i][k]]=0
								if k~=c then
									msg2(hrpg.races[i][k],"255255255You didn't win, so you don't get any money.")
									spawnplayer(hrpg.races[i][k],78*32+16,179*32+16)
									if hrpg.powerup.image1[hrpg.races[i][k]]~=0 then
										freeimage(hrpg.powerup.image1[hrpg.races[i][k]])
									end
									if hrpg.powerup.image2[hrpg.races[i][k]]~=0 then
										freeimage(hrpg.powerup.image2[hrpg.races[i][k]])
									end
									if carimg[hrpg.races[i][k]]~=0 then
										parse("speedmod "..hrpg.races[i][k].." 0")
									else
										parse("speedmod "..hrpg.races[i][k].." 15")
									end
									hrpg.powerup.image1[hrpg.races[i][k]]=0
									hrpg.powerup.image2[hrpg.races[i][k]]=0
									hrpg.powerup.item[hrpg.races[i][k]]=0
									hrpg.lap[hrpg.races[i][k]]=0
									hrpg.check[hrpg.races[i][k]]=0
									freetimer("hrpg.powerup.gen",""..hrpg.races[i][k].."")
								end
							end
							freetimer("hrpg.startracing1",""..i.."")
							freetimer("hrpg.startracing2",""..i.."")
							freetimer("hrpg.startracing3",""..i.."")
							freetimer("hrpg.startracing4",""..i.."")
							freetimer("hrpg.startracing5",""..i.."")
							table.remove(hrpg.races,i)
							for z=1,32 do
								hudding(2,z)
							end
							break
						end
					end
				end
			end
		elseif entity(x,y,"type")==2 then
			hrpg.check[id]=1
		elseif entity(x,y,"type")==3 and hrpg.check[id]==1 then
			hrpg.check[id]=2
		elseif entity(x,y,"type")==90 and hrpg.check[id]==2 then
			hrpg.check[id]=3
		end
	else
		if tile(x,y,"entity") and entity(x,y,"type")==91 then
			if carimg[id]~=0 then
				hrpg.cardisappear(id)
			end
		else
			if #hrpg.mob.id>0 and hrpg.fight[id]==0 then
				for i=1,#hrpg.mob.id do
					if hrpg.mob.hp[i]~=0 and hrpg.mob.busy[i]~=1 and x<object(hrpg.mob.id[i],"tilex")+hrpg.aggrodist and x>object(hrpg.mob.id[i],"tilex")-hrpg.aggrodist and y<object(hrpg.mob.id[i],"tiley")+hrpg.aggrodist and y>object(hrpg.mob.id[i],"tiley")-hrpg.aggrodist then
						if hrpg.aggro then
							if x>hrpg.mob.spawnarea[i][1]+hrpg.mobrange then
								if y>hrpg.mob.spawnarea[i][2]+hrpg.mobrange then
									tween_move(hrpg.mob.id[i],hrpg.mobspeed,(hrpg.mob.spawnarea[i][1]+hrpg.mobrange)*32+16,(hrpg.mob.spawnarea[i][2]+hrpg.mobrange)*32+16,math.deg(math.atan2(object(hrpg.mob.id[i],"y")-player(id,"y"),object(hrpg.mob.id[i],"x")-player(id,"x")))-90)
									tween_move(hrpg.mob.shadow[i],hrpg.mobspeed,(hrpg.mob.spawnarea[i][1]+hrpg.mobrange)*32+16,(hrpg.mob.spawnarea[i][2]+hrpg.mobrange)*32+16,math.deg(math.atan2(object(hrpg.mob.id[i],"y")-player(id,"y"),object(hrpg.mob.id[i],"x")-player(id,"x")))-90)
								elseif y<hrpg.mob.spawnarea[i][2]-hrpg.mobrange then
									tween_move(hrpg.mob.id[i],hrpg.mobspeed,(hrpg.mob.spawnarea[i][1]+hrpg.mobrange)*32+16,(hrpg.mob.spawnarea[i][2]-hrpg.mobrange)*32+16,math.deg(math.atan2(object(hrpg.mob.id[i],"y")-player(id,"y"),object(hrpg.mob.id[i],"x")-player(id,"x")))-90)
									tween_move(hrpg.mob.shadow[i],hrpg.mobspeed,(hrpg.mob.spawnarea[i][1]+hrpg.mobrange)*32+16,(hrpg.mob.spawnarea[i][2]-hrpg.mobrange)*32+16,math.deg(math.atan2(object(hrpg.mob.id[i],"y")-player(id,"y"),object(hrpg.mob.id[i],"x")-player(id,"x")))-90)
								elseif y<=hrpg.mob.spawnarea[i][2]+hrpg.mobrange and y>=hrpg.mob.spawnarea[i][2]-hrpg.mobrange then
									tween_move(hrpg.mob.id[i],hrpg.mobspeed,(hrpg.mob.spawnarea[i][1]+hrpg.mobrange)*32+16,y*32+16,math.deg(math.atan2(object(hrpg.mob.id[i],"y")-player(id,"y"),object(hrpg.mob.id[i],"x")-player(id,"x")))-90)
									tween_move(hrpg.mob.shadow[i],hrpg.mobspeed,(hrpg.mob.spawnarea[i][1]+hrpg.mobrange)*32+16,y*32+16,math.deg(math.atan2(object(hrpg.mob.id[i],"y")-player(id,"y"),object(hrpg.mob.id[i],"x")-player(id,"x")))-90)
								end
							elseif x<hrpg.mob.spawnarea[i][1]-hrpg.mobrange then
								if y>hrpg.mob.spawnarea[i][2]+hrpg.mobrange then
									tween_move(hrpg.mob.id[i],hrpg.mobspeed,(hrpg.mob.spawnarea[i][1]-hrpg.mobrange)*32+16,(hrpg.mob.spawnarea[i][2]+hrpg.mobrange)*32+16,math.deg(math.atan2(object(hrpg.mob.id[i],"y")-player(id,"y"),object(hrpg.mob.id[i],"x")-player(id,"x")))-90)
									tween_move(hrpg.mob.shadow[i],hrpg.mobspeed,(hrpg.mob.spawnarea[i][1]-hrpg.mobrange)*32+16,(hrpg.mob.spawnarea[i][2]+hrpg.mobrange)*32+16,math.deg(math.atan2(object(hrpg.mob.id[i],"y")-player(id,"y"),object(hrpg.mob.id[i],"x")-player(id,"x")))-90)
								elseif y<hrpg.mob.spawnarea[i][2]-hrpg.mobrange then
									tween_move(hrpg.mob.id[i],hrpg.mobspeed,(hrpg.mob.spawnarea[i][1]-hrpg.mobrange)*32+16,(hrpg.mob.spawnarea[i][2]-hrpg.mobrange)*32+16,math.deg(math.atan2(object(hrpg.mob.id[i],"y")-player(id,"y"),object(hrpg.mob.id[i],"x")-player(id,"x")))-90)
									tween_move(hrpg.mob.shadow[i],hrpg.mobspeed,(hrpg.mob.spawnarea[i][1]-hrpg.mobrange)*32+16,(hrpg.mob.spawnarea[i][2]-hrpg.mobrange)*32+16,math.deg(math.atan2(object(hrpg.mob.id[i],"y")-player(id,"y"),object(hrpg.mob.id[i],"x")-player(id,"x")))-90)
								elseif y<=hrpg.mob.spawnarea[i][2]+hrpg.mobrange and y>=hrpg.mob.spawnarea[i][2]-hrpg.mobrange then
									tween_move(hrpg.mob.id[i],hrpg.mobspeed,(hrpg.mob.spawnarea[i][1]-hrpg.mobrange)*32+16,y*32+16,math.deg(math.atan2(object(hrpg.mob.id[i],"y")-player(id,"y"),object(hrpg.mob.id[i],"x")-player(id,"x")))-90)
									tween_move(hrpg.mob.shadow[i],hrpg.mobspeed,(hrpg.mob.spawnarea[i][1]-hrpg.mobrange)*32+16,y*32+16,math.deg(math.atan2(object(hrpg.mob.id[i],"y")-player(id,"y"),object(hrpg.mob.id[i],"x")-player(id,"x")))-90)
								end
							elseif x>=hrpg.mob.spawnarea[i][1]-hrpg.mobrange and x<=hrpg.mob.spawnarea[i][1]+hrpg.mobrange then
								if y>hrpg.mob.spawnarea[i][2]+hrpg.mobrange then
									tween_move(hrpg.mob.id[i],hrpg.mobspeed,x*32+16,(hrpg.mob.spawnarea[i][2]+hrpg.mobrange)*32+16,math.deg(math.atan2(object(hrpg.mob.id[i],"y")-player(id,"y"),object(hrpg.mob.id[i],"x")-player(id,"x")))-90)
									tween_move(hrpg.mob.shadow[i],hrpg.mobspeed,x*32+16,(hrpg.mob.spawnarea[i][2]+hrpg.mobrange)*32+16,math.deg(math.atan2(object(hrpg.mob.id[i],"y")-player(id,"y"),object(hrpg.mob.id[i],"x")-player(id,"x")))-90)
								elseif y<hrpg.mob.spawnarea[i][2]-hrpg.mobrange then
									tween_move(hrpg.mob.id[i],hrpg.mobspeed,x*32+16,(hrpg.mob.spawnarea[i][2]-hrpg.mobrange)*32+16,math.deg(math.atan2(object(hrpg.mob.id[i],"y")-player(id,"y"),object(hrpg.mob.id[i],"x")-player(id,"x")))-90)
									tween_move(hrpg.mob.shadow[i],hrpg.mobspeed,x*32+16,(hrpg.mob.spawnarea[i][2]-hrpg.mobrange)*32+16,math.deg(math.atan2(object(hrpg.mob.id[i],"y")-player(id,"y"),object(hrpg.mob.id[i],"x")-player(id,"x")))-90)
								elseif y<=hrpg.mob.spawnarea[i][2]+hrpg.mobrange and y>=hrpg.mob.spawnarea[i][2]-hrpg.mobrange and hrpg.fight[id]==0 then
									hrpg.mob.busy[i]=1
									parse("speedmod "..id.." -100")
									hrpg.fight[id]=i
									parse("sv_sound2 "..id.." \"Houses RPG/encounter.ogg\"")
									local d=image("gfx/hud/fight.png",320,240,2,id)
									imageblend(d,1)
									imagescale(d,50,50)
									imagecolor(d,math.random(0,255),math.random(0,255),math.random(0,255))
									tween_scale(d,2000,0,0)
									tween_rotateconstantly(d,10)
									timer(2000,"freeimage",""..d.."")
									timer(2000,"hrpg.fightstart",""..id.."")
									break
								end
							else
								tween_move(hrpg.mob.id[i],hrpg.mobspeed,x*32+16,y*32+16,math.random(0,360))
								tween_move(hrpg.mob.shadow[i],hrpg.mobspeed,x*32+16,y*32+16)
							end
						else
							if x>=hrpg.mob.spawnarea[i][1]-hrpg.mobrange and x<=hrpg.mob.spawnarea[i][1]+hrpg.mobrange and y<=hrpg.mob.spawnarea[i][2]+hrpg.mobrange and y>=hrpg.mob.spawnarea[i][2]-hrpg.mobrange and hrpg.fight[id]==0 then
								hrpg.mob.busy[i]=1
								tween_move(hrpg.mob.id[i],hrpg.mobspeed,x*32+16,y*32+16,math.random(0,360))
								tween_move(hrpg.mob.shadow[i],hrpg.mobspeed,x*32+16,y*32+16)
								parse("speedmod "..id.." -100")
								hrpg.fight[id]=i
								parse("sv_sound2 "..id.." \"Houses RPG/encounter.ogg\"")
								local d=image("gfx/hud/fight.png",320,240,2,id)
								imageblend(d,1)
								imagescale(d,50,50)
								imagecolor(d,math.random(0,255),math.random(0,255),math.random(0,255))
								tween_scale(d,2000,0,0)
								tween_rotateconstantly(d,10)
								timer(2000,"freeimage",""..d.."")
								timer(2000,"hrpg.fightstart",""..id.."")
								return 1
							end
						end
					end
				end
			end
			if hrpg.fight[id]==0 and #hrpg.roof_exists>0 then
				hrpg.roofupdate(id,x,y)
			end
		end
	end
end
function hrpg.roofupdate(id,x,y)
	local h=0
	local a=false
	for c=1,#hrpg.roof_exists do
		h=hrpg.roof_exists[c]
		if x<=hrpg.housesize[h][1]+hrpg.housecoor[h][1] and x>=hrpg.housecoor[h][1]-hrpg.housesize[h][1] and y<=hrpg.housesize[h][2]+hrpg.housecoor[h][2] and y>=hrpg.housecoor[h][2]-hrpg.housesize[h][2] then
			if hrpg.roof_visible[h] then
				tween_alpha(hrpg.houseroof[h],1000,hrpg.roof_transparency)
				hrpg.roof_visible[h]=false
			end
		else
			for i=1,#player(0,"tableliving") do
				if player(player(0,"tableliving")[i],"tilex")<=hrpg.housesize[h][1]+hrpg.housecoor[h][1] and player(player(0,"tableliving")[i],"tilex")>=hrpg.housecoor[h][1]-hrpg.housesize[h][1] and player(player(0,"tableliving")[i],"tiley")<=hrpg.housesize[h][2]+hrpg.housecoor[h][2] and player(player(0,"tableliving")[i],"tiley")>=hrpg.housecoor[h][2]-hrpg.housesize[h][2] then
					if hrpg.roof_visible[h] then
						tween_alpha(hrpg.houseroof[h],1000,hrpg.roof_transparency)
						hrpg.roof_visible[h]=false
					end
					a=true
					break
				end
			end
			if not a and not hrpg.roof_visible[h] then
				tween_alpha(hrpg.houseroof[h],1000,1)
				hrpg.roof_visible[h]=true
			end
			a=false
		end
	end
end

function hrpg.fightstart(p)
	local id=tonumber(p)
	local f=hrpg.fight[id]
	hrpg.fightimg[id]=image("gfx/hud/battle_background_"..math.random(1,5)..".png",320,720,2,id)
	imagecolor(hrpg.fightimg[id],math.random(25,75),math.random(25,75),math.random(25,75))
	imagescale(hrpg.fightimg[id],0,0)
	tween_scale(hrpg.fightimg[id],1000,1.5,1.5)
	tween_move(hrpg.fightimg[id],1000,320,240)
	timer(500,"hrpg.fightimagefix",""..id.."")
end
function hrpg.fightimagefix(p)
	local id=tonumber(p)
	local f=hrpg.fight[id]
	if math.abs(player(id,"tilex")-object(hrpg.mob.id[f],"tilex"))>hrpg.mobrange+2 or math.abs(player(id,"tiley")-object(hrpg.mob.id[f],"tiley"))>hrpg.mobrange+2 then
		setpos(id,object(hrpg.mob.id[f],"x"),object(hrpg.mob.id[f],"y"))
	end
	hrpg.enemyimg[id]=image(hrpg.mob.typevar.image[hrpg.mob.typ[f]],320+(object(hrpg.mob.id[f],"x")-player(id,"x")),240+(object(hrpg.mob.id[f],"y")-player(id,"y")),2,id)
	if hrpg.time<0 then
		imagealpha(hrpg.enemyimg[id],(math.abs(hrpg.time)/hrpg.length*hrpg.night_transparency))
	elseif hrpg.time>0 then
		imagealpha(hrpg.enemyimg[id],hrpg.night_transparency-(math.abs(hrpg.time)/hrpg.length*hrpg.night_transparency))
	end
	tween_alpha(hrpg.enemyimg[id],1000,1)
	hrpg.fighting.hud[id]={image("gfx/hud/battle_button.png",270,900,2,id),image("gfx/hud/battle_button.png",380,900,2,id),image("gfx/hud/battle_button.png",270,930,2,id),image("gfx/hud/battle_button.png",380,930,2,id),image("gfx/hud/battle_top1.png",320,-120,2,id)}
	hrpg.fighting.turnimg[id]=image("gfx/gui_load.bmp",320,813,2,id)
	tween_move(hrpg.fighting.hud[id][1],1000,265,400)
	tween_move(hrpg.fighting.hud[id][2],1000,375,400)
	tween_move(hrpg.fighting.hud[id][3],1000,265,430)
	tween_move(hrpg.fighting.hud[id][4],1000,375,430)
	tween_move(hrpg.fighting.hud[id][5],1000,320,48)
	local clr={math.random(125,175),math.random(125,175),math.random(125,175)}
	for i=1,5 do
		imagecolor(hrpg.fighting.hud[id][i],clr[1],clr[2],clr[3])
	end
	imagepos(hrpg.enemyimg[id],object(hrpg.enemyimg[id],"x"),object(hrpg.enemyimg[id],"y"),object(hrpg.mob.id[f],"rot"))
	tween_move(hrpg.enemyimg[id],1000,320,240,180)
	tween_scale(hrpg.enemyimg[id],1000,2,2)
	imagealpha(hrpg.enemyimg[id],1)
	--hudtxt2(id,hrpg.hudids[2],"255255255","Attack                  Defend",320,891,1)
	--hudtxt2(id,hrpg.hudids[3],"255255255","   Run                   Inventory",320,920,1)
	--hudtxt2(id,hrpg.hudids[4],"255255255",""..hrpg.mob.type[hrpg.fight[id]].." Level "..hrpg.mob.level[hrpg.fight[id]].."",320,-215,1)
	--hudtxt2(id,hrpg.hudids[7],"255255255",""..hrpg.mob.hp[hrpg.fight[id]].." HP | AP "..hrpg.mob.typevar.armor[hrpg.mob.typ[hrpg.fight[id]]]*hrpg.mob.level[hrpg.fight[id]].."",320,-235,1)
	--[[hudtxt2(id,hrpg.hudids[8],"255255255","A wild "..hrpg.mob.type[f].." appeared!",320,-215,1)
	parse("hudtxtmove "..id.." "..hrpg.hudids[2].." 1000 320 393")
	parse("hudtxtmove "..id.." "..hrpg.hudids[3].." 1000 320 423")
	parse("hudtxtmove "..id.." "..hrpg.hudids[4].." 1000 320 20")
	parse("hudtxtmove "..id.." "..hrpg.hudids[7].." 1000 320 40")
	parse("hudtxtmove "..id.." "..hrpg.hudids[8].." 1000 320 60")--]] -- Dammit DC, Y U NO FIX HUDTXTMOVE?!
	imageblend(hrpg.fighting.turnimg[id],1)
	tween_move(hrpg.fighting.turnimg[id],1000,320,413)
	tween_rotateconstantly(hrpg.fighting.turnimg[id],5)
	timer(1100,"hrpg.playerturn",""..(id+32).."")
	hrpg.mob.fightimage[hrpg.fight[id]]=image("gfx/Houses RPG/fight_"..player(id,"team")..".png",object(hrpg.mob.id[hrpg.fight[id]],"x"),object(hrpg.mob.id[hrpg.fight[id]],"y"),1)
	imagealpha(hrpg.mob.fightimage[hrpg.fight[id]],0)
	tween_alpha(hrpg.mob.fightimage[hrpg.fight[id]],5000,0.3)
end
function hrpg.attack(id,m)
	if hrpg.fight[id]~=0 and hrpg.fighting.turn[id]=="player" then
		for d=1,5 do
			hudding(d,id)
		end
		if hrpg.fighting.comboticker[id]<=hrpg.room_for_error and hrpg.fighting.comboticker[id]>-hrpg.room_for_error and hrpg.fighting.combocounter[id]<hrpg.maxcombo and hrpg.fighting.action[id]==2 then
			if itemtype(player(id,"weapontype"),"slot")==3 then
				dif=math.floor((hrpg.level[id]*itemtype(player(id,"weapontype"),"dmg")/2)-(hrpg.mob.armor[hrpg.fight[id]]/2))
			elseif itemtype(player(id,"weapontype"),"slot")==2 then
				dif=math.floor((hrpg.level[id]*itemtype(player(id,"weapontype"),"dmg")*2)-(hrpg.mob.armor[hrpg.fight[id]]/2))
			elseif itemtype(player(id,"weapontype"),"slot")==1 then
				dif=math.floor((hrpg.level[id]*itemtype(player(id,"weapontype"),"dmg"))-(hrpg.mob.armor[hrpg.fight[id]]/2))
			else
				dif=math.random(1,10)
			end
			if dif<=0 then
				dif=1
			end
			parse("sv_sound2 "..id.." \"Houses RPG/hit"..math.random(1,3)..".ogg\"")
			hrpg.fighting.combocounter[id]=hrpg.fighting.combocounter[id]+1
			local tick=hrpg.fighting.musicticker[id]
			if #hrpg.music.timing[hrpg.fighting.music[id]]~=1 then
				if tick+1>#hrpg.music.timing[hrpg.fighting.music[id]] then
					tick=1
				else
					tick=tick+1
				end
			end
			imagescale(hrpg.fighting.turnimg[id],1,1)
			imagescale(hrpg.fighting.hud[id][1],0.4,1.3)
			freetimer("hrpg.mob.anim2",""..(id+32).."")
			freetimer("hrpg.mob.anim1",""..(id+128).."")
			if hrpg.fighting.combocounter[id]<hrpg.maxcombo then
				hudtxt2(id,hrpg.hudids[8],"255255255",translate(id,"COMBO").." - "..hrpg.fighting.combocounter[id].." "..translate(id,"HITS!").."",320,60,1)
				dif=math.floor((dif*0.15)+math.random(-dif/10,dif/5))
				tween_scale(hrpg.fighting.turnimg[id],math.abs(hrpg.music.timing[hrpg.fighting.music[id]][tick]-math.abs(hrpg.fighting.comboticker[id])),2,2)
				tween_scale(hrpg.fighting.hud[id][1],math.abs(hrpg.music.timing[hrpg.fighting.music[id]][tick]-math.abs(hrpg.fighting.comboticker[id])),0.5,1.7)
				timer(math.abs(hrpg.music.timing[hrpg.fighting.music[id]][tick]-math.abs(hrpg.fighting.comboticker[id])),"hrpg.mob.anim2",""..(id+32).."")
				timer(math.abs(hrpg.music.timing[hrpg.fighting.music[id]][tick]-math.abs(hrpg.fighting.comboticker[id])),"hrpg.mob.anim1",""..(id+128).."")
			else
				hudtxt2(id,hrpg.hudids[8],"255255255","COMBO - MAX!",320,60,1)
				parse("sv_sound2 "..id.." \"Houses RPG/maxcombo.ogg\"")
				dif=math.floor(dif+math.random(dif/10,dif/5))
				timer(math.abs(hrpg.music.timing[hrpg.fighting.music[id]][tick]-math.abs(hrpg.fighting.comboticker[id])),"hrpg.mob.anim1",""..(id+128).."")
				timer(math.abs(hrpg.music.timing[hrpg.fighting.music[id]][tick]-math.abs(hrpg.fighting.comboticker[id])),"hrpg.mob.anim2",""..(id+32).."")
			end
			if dif<=0 then
				dif=1
			end
			timer(10,"hrpg.fighting.check",""..id.."",dif)
			local t=0
			if dif>hrpg.mob.maxhp[hrpg.fight[id]] then
				t=100
			else
				t=math.floor((155-(dif/hrpg.mob.maxhp[hrpg.fight[id]])*155)+100)
			end
			hudtxt2(id,hrpg.hudids[10],""..t..""..t.."000",dif,320,240,1)
			if math.random(1,2)==1 then
				parse("hudtxtmove "..id.." "..hrpg.hudids[10].." 1000 "..(320-math.random(50,100)).." "..(240-math.random(50,100)).."")
			else
				parse("hudtxtmove "..id.." "..hrpg.hudids[10].." 1000 "..(320+math.random(50,100)).." "..(240-math.random(50,100)).."")
			end
			parse("hudtxtalphafade "..id.." "..hrpg.hudids[10].." 1000 0")
			imagecolor(hrpg.enemyimg[id],255,0,0)
			tween_color(hrpg.enemyimg[id],500,255,255,255)
			imagecolor(hrpg.mob.id[hrpg.fight[id]],255,0,0)
			tween_color(hrpg.mob.id[hrpg.fight[id]],500,255,255,255)
			tween_move(hrpg.enemyimg[id],100,320,240)
			hrpg.fighting.combohit[id]=true
			timer(100,"hrpg.mob.anim1",""..id.."")
			freetimer("hrpg.fighting.endturn",""..id.."")
			timer(math.abs(hrpg.music.timing[hrpg.fighting.music[id]][tick]-math.abs(hrpg.fighting.comboticker[id]))+hrpg.room_for_error,"hrpg.fighting.endturn",""..id.."")
		elseif (hrpg.fighting.comboticker[id]<=hrpg.combo_accuracy or hrpg.fighting.comboticker[id]>hrpg.room_for_error) and hrpg.fighting.comboticker[id]>0 and hrpg.fighting.action[id]==2 then
			freetimer("hrpg.fighting.endturn",""..id.."")
			hrpg.fighting.endturn(""..id.."")
		end
		if hrpg.fighting.turn[id]=="player" then
			reqcld(id,0)
		end
	end
end
function hrpg.fighting.endturn(i)
	local id=tonumber(i)
	freetimer("hrpg.fighting.endturn",""..id.."")
	freetimer("hrpg.mob.anim2",""..(id+32).."")
	freetimer("hrpg.mob.anim1",""..(id+128).."")
	if hrpg.fighting.action[id]==2 and hrpg.fighting.combocounter[id]<hrpg.maxcombo then
		if hrpg.fighting.comboticker[id]<=hrpg.room_for_error then
			hudtxt2(id,hrpg.hudids[9],"255255255",translate(id,"Too late!"),320,374,1)
			parse("hudtxtalphafade "..id.." "..hrpg.hudids[9].." 1000 0")
		else
			hudtxt2(id,hrpg.hudids[9],"255255255",translate(id,"Too soon!"),320,374,1)
			parse("hudtxtalphafade "..id.." "..hrpg.hudids[9].." 1000 0")
		end
	end
	hrpg.fighting.combohit[id]=false
	hrpg.fighting.combocounter[id]=0
	hrpg.fighting.turn[id]="mob"
	hrpg.fighting.comboticker[id]=0
	tween_move(hrpg.fighting.turnimg[id],1000,-16,413)
	tween_scale(hrpg.fighting.turnimg[id],500,1,1)
	tween_scale(hrpg.fighting.hud[id][1],1000,1,1)
	tween_move(hrpg.fighting.hud[id][1],1000,265,400)
	timer(1100,"hrpg.mob.retract",""..(id+32).."")
	timer(3000,"hrpg.mob.turn",""..id.."")
end
function hrpg.mob.turn(i)
	local id=tonumber(i)
	local rand=10
	local dam=math.floor(hrpg.mob.level[hrpg.fight[id]]/hrpg.level[id]*hrpg.mob.typevar.attack[hrpg.mob.typ[hrpg.fight[id]]])
	if player(id,"armor")==201 then
		dam=dam*0.75
	elseif player(id,"armor")==202 then
		dam=dam*0.5
	elseif player(id,"armor")==203 then
		dam=dam*0.25
	elseif player(id,"armor")==204 then
		dam=dam*0.5
	elseif player(id,"armor")==205 then
		dam=dam*0.05
	elseif player(id,"armor")==206 then
		rand=5
	else
		dam=dam-(player(id,"armor")/5)
	end
	dam=math.floor(dam)
	if dam>0 then 
		dam=dam+math.random(-dam/5,dam/5)
	end
	local tim=150
	if hrpg.fighting.action[id]==3 then
		dam=math.floor(dam-player(id,"armor")/2)
		tim=300
		rand=7
	end
	if dam<0 then dam=0 end
	if math.random(1,rand)==1 then	
		dam=0
	end
	if player(id,"health")-dam>0 then
		if dam==0 then
			hudtxt2(id,hrpg.hudids[8],"255255255",""..hrpg.mob.type[hrpg.fight[id]].." "..translate(id,"missed!").."",320,60,1)
		else
			hudtxt2(id,hrpg.hudids[8],"255255255",""..hrpg.mob.type[hrpg.fight[id]].." "..translate(id,"hit").." "..player(id,"name").." "..translate(id,"for").." "..dam.." "..translate(id,"damage!").."",320,60,1)
		end
	else
		hudtxt2(id,hrpg.hudids[8],"255000000",""..hrpg.mob.type[hrpg.fight[id]].." "..translate(id,"did mortal damage to").." "..player(id,"name").."!",320,60,1)
	end
	freetimer("hrpg.healthdec",""..id.."")
	freetimer("hrpg.mob.turn",""..id.."")
	if dam>0 then
		timer(tim,"hrpg.healthdec",""..id.."",dam+hrpg.fighting.damleft[id])
		hrpg.fighting.damleft[id]=dam
	elseif dam==0 and hrpg.fighting.damleft[id]~=0 then
		timer(tim,"hrpg.healthdec",""..id.."",dam+hrpg.fighting.damleft[id])
		hrpg.fighting.damleft[id]=0
	end
	timer(2000,"hrpg.playerturn",""..id.."")
	timer(1300,"hrpg.mob.retract",""..(id+64).."")
	tween_move(hrpg.enemyimg[id],200,320,280)
	tween_move(hrpg.mob.id[hrpg.fight[id]],1000,object(hrpg.mob.id[hrpg.fight[id]],"x"),object(hrpg.mob.id[hrpg.fight[id]],"y"),math.random(0,360))
	timer(200,"hrpg.mob.retract",""..id.."")
end
function hrpg.mob.retract(i)
	local id=tonumber(i)
	if id<33 then
		parse("sv_sound2 "..id.." \""..hrpg.mob.typevar.sound[hrpg.mob.typ[hrpg.fight[id]]].."\"")
		tween_move(hrpg.enemyimg[id],200,320,240)
		if hrpg.fighting.damleft[id]~=0 then
			timer(100,"parse","sv_sound2 "..id.." \"player/hit"..math.random(1,3)..".wav\"")
		end
		tween_move(hrpg.fighting.turnimg[id],1000,656,95)
	elseif id>=33 and id<=64 then
		if hrpg.mob.hp[hrpg.fight[id-32]]>=1 and player(id-32,"health")>1 then
			clearhudtxt2(id-32,hrpg.hudids[8])
		end
		imagepos(hrpg.fighting.turnimg[id-32],-16,95,0)
		tween_move(hrpg.fighting.turnimg[id-32],1000,320,95)
	else
		imagepos(hrpg.fighting.turnimg[id-64],656,413,0)
		tween_move(hrpg.fighting.turnimg[id-64],700,320,413)
	end
end
function hrpg.playerturn(i)
	local id=tonumber(i)
	if id>32 then
		hrpg.fighting.turn[id-32]="player"
		hrpg.fighting.action[id-32]=1
		for c=1,5 do
			hudding(c,id-32)
		end
		local t={1,-1}
		tween_rotateconstantly(hrpg.fightimg[id-32],t[math.random(1,#t)])
		hudtxt2(id-32,hrpg.hudids[8],"255255255",translate(id-32,"A wild").." "..hrpg.mob.type[hrpg.fight[id-32]].." "..translate(id-32,"appeared!").."",320,60,1)
		hrpg.fightingmusicstart(id-32)
	else
		hrpg.fighting.turn[id]="player"
		hrpg.fighting.action[id]=1
		clearhudtxt2(id,hrpg.hudids[8])
	end
end
function hrpg.fightingmusicstart(id)
	hrpg.fighting.music[id]=math.random(1,#hrpg.music.files)
	hrpg.fighting.comboticker[id]=hrpg.music.timing[hrpg.fighting.music[id]][1]+hrpg.room_for_error
	hrpg.placeh[id]=1
	parse("sv_sound2 "..id.." "..hrpg.music.files[hrpg.fighting.music[id]][1].."")
	timer(hrpg.music.length[hrpg.fighting.music[id]][1],"hrpg.music.update",""..(id+32).."")
	hrpg.fighting.musicticker[id]=1
	timer(hrpg.music.timing[hrpg.fighting.music[id]][1],"hrpg.music.update",""..id.."")
end
function hrpg.music.update(i)
	local id=tonumber(i)
	if id>32 then
		id=id-32
		hrpg.placeh[id]=hrpg.placeh[id]+1
		if hrpg.placeh[id]>#hrpg.music.files[hrpg.fighting.music[id]] then
			hrpg.placeh[id]=1
		end
		parse("sv_sound2 "..id.." "..hrpg.music.files[hrpg.fighting.music[id]][hrpg.placeh[id]].."")
		timer(hrpg.music.length[hrpg.fighting.music[id]][hrpg.placeh[id]],"hrpg.music.update",""..(id+32).."")
		return 1
	end
	hrpg.fighting.musicticker[id]=hrpg.fighting.musicticker[id]+1
	if hrpg.fighting.musicticker[id]>#hrpg.music.timing[hrpg.fighting.music[id]] then
		hrpg.fighting.musicticker[id]=1
	end
	hrpg.fighting.comboticker[id]=hrpg.music.timing[hrpg.fighting.music[id]][hrpg.fighting.musicticker[id]]
	if hrpg.fighting.combohit[id] then
		hrpg.fighting.combohit[id]=false
	end
	--msg("NOW! "..os.time().." "..hrpg.music.timing[hrpg.fighting.music[id]][hrpg.fighting.musicticker[id]].."") -- Used for debugging combos
	timer(hrpg.music.timing[hrpg.fighting.music[id]][hrpg.fighting.musicticker[id]],"hrpg.music.update",i)
	timer(hrpg.combo_accuracy,"parse",'lua hrpg.fighting.comboticker['..id..']=hrpg.fighting.comboticker['..id..']-'..hrpg.combo_accuracy..'',(hrpg.music.timing[hrpg.fighting.music[id]][hrpg.fighting.musicticker[id]]+hrpg.room_for_error)/hrpg.combo_accuracy)
end
function hrpg.healthdec(i)
	local id=tonumber(i)
	hrpg.fighting.damleft[id]=hrpg.fighting.damleft[id]-1
	if player(id,"health")>1 then
		parse("sethealth "..id.." "..player(id,"health")-1)
		return 1
	elseif player(id,"health")==1 then
		hrpg.fighting.turn[id]=""
		hrpg.fighting.action[id]=0
		hrpg.fighting.comboticker[id]=0
		hudtxt2(id,hrpg.hudids[8],"175175175",translate(id,"You lost..."),320,60,1)
		tween_scale(hrpg.fighting.hud[id][1],1000,1,1)
		tween_move(hrpg.fighting.hud[id][1],1000,265,400)
		tween_move(hrpg.enemyimg[id],1000,320,240)
		hrpg.freefights(id)
		timer(3000,"parse","customkill "..id.." LEVEL_"..hrpg.mob.level[hrpg.fight[id]].."_"..hrpg.mob.type[hrpg.fight[id]].." "..id.."")
		timer(3000,"parse",'sv_sound2 '..id..' \"player/die'..math.random(1,3)..'.wav\"')
	end
end
function hrpg.healing(i)
	local id=tonumber(i)
	parse("sethealth "..id.." "..player(id,"health")+1)
	if player(id,"health")==player(id,"maxhealth") then
		freetimer("hrpg.healing",""..id.."")
	end
end
function hrpg.fighting.check(i)
	local id=tonumber(i)
	hrpg.mob.hp[hrpg.fight[id]]=hrpg.mob.hp[hrpg.fight[id]]-1
	hudding(5,id)
	if hrpg.mob.hp[hrpg.fight[id]]==0 then
		hrpg.mob.hp[hrpg.fight[id]]=-1
		hudtxt2(id,hrpg.hudids[8],"255255255",translate(id,"You win!"),320,60,1)
		parse("sv_sound2 "..id.." \"Houses RPG/victory.ogg\"")
		parse("sv_sound2 "..id.." \""..hrpg.mob.typevar.deathsound[hrpg.mob.typ[hrpg.fight[id]]].."\"")
		hrpg.freefights(id)
		tween_scale(hrpg.fighting.hud[id][1],100,1,1)
		tween_move(hrpg.fighting.hud[id][1],100,265,400)
		tween_scale(hrpg.enemyimg[id],3000,0,0)
		tween_rotateconstantly(hrpg.enemyimg[id],10)
		tween_scale(hrpg.mob.id[hrpg.fight[id]],3000,0,0)
		tween_scale(hrpg.mob.shadow[hrpg.fight[id]],3000,0,0)
		tween_rotateconstantly(hrpg.mob.id[hrpg.fight[id]],10)
		hrpg.fighting.action[id]=0
		hrpg.fighting.turn[id]="end"
		hrpg.fighting.comboticker[id]=0
		hrpg.fighting.damleft[id]=0
		hrpg.fighting.music[id]=0
		hrpg.fighting.musicticker[id]=0
		if #hrpg.mob.typevar.drops[hrpg.mob.typ[hrpg.fight[id]]]~=0 then
			local c=""
			for d=1,#hrpg.mob.typevar.drops[hrpg.mob.typ[hrpg.fight[id]]] do
				if math.random(1,hrpg.mob.typevar.dropchances[hrpg.mob.typ[hrpg.fight[id]]][d])==1 then
					c=hrpg.mob.typevar.drops[hrpg.mob.typ[hrpg.fight[id]]][d]
					break
				end
			end
			if c~="" then
				timer(3500,"hrpg.winmusicloopstart",""..id..","..c..","..hrpg.mob.type[hrpg.fight[id]].."")
			else
				timer(3000,"hrpg.fighting.finish",""..id.."")
			end
		else
			timer(3000,"hrpg.fighting.finish",""..id.."")
		end
	end
end
function hrpg.fighting.finish(i)
	local id=tonumber(i)
	local f=hrpg.fight[id]
	for a=1,5 do
		hudding(id,a)
	end
	msg2(id,"255255255"..translate(id,"You got").." "..hrpg.mob.typevar.exp[hrpg.mob.typ[f]]*hrpg.mob.level[f].." XP "..translate(id,"and").." "..hrpg.mob.typevar.money[hrpg.mob.typ[f]].."$!")
	parse("setmoney "..id.." "..player(id,"money")+hrpg.mob.typevar.money[hrpg.mob.typ[f]])
	hrpg.questupdate(id,4)
	hrpg.addexp(id,hrpg.mob.typevar.exp[hrpg.mob.typ[f]]*hrpg.mob.level[f])
	if carimg[id]~=0 then
		parse('speedmod '..id..' 15')
	else
		parse('speedmod '..id..' 0')
	end
	if hrpg.mob.id[f]~=nil then
		hrpg.mob.kill(f)
	end
	hrpg.fight[id]=0
	hrpg.fighting.turnimg[id]=0
	hrpg.fighting.action[id]=0
	hrpg.fightimg[id]=0	
	hrpg.enemyimg[id]=0
	hrpg.fighting.damleft[id]=0
	hrpg.fighting.combohit[id]=false
end
function hrpg.clientdata(id,mode,x,y)
	if mode==0 and hrpg.fight[id]~=0 and hrpg.fighting.action[id]>0 and hrpg.fighting.turn[id]=="player" and hrpg.fighting.action[id]~=2 then
		if hrpg.fighting.action[id]==4 then
			hrpg.fighting.finish(""..id.."")
			return 1
		end
		if x>=220 and x<=320 and y>=385 and y<=410 then
			tween_scale(hrpg.fighting.hud[id][1],100,0.7,0.7)
			timer(100,"hrpg.mob.anim1",""..(id+128).."")
			local dif=0
			if itemtype(player(id,"weapontype"),"slot")==3 then
				dif=math.floor((hrpg.level[id]*itemtype(player(id,"weapontype"),"dmg")/2)-(hrpg.mob.armor[hrpg.fight[id]]/2))
			elseif itemtype(player(id,"weapontype"),"slot")==2 then
				dif=math.floor((hrpg.level[id]*itemtype(player(id,"weapontype"),"dmg")*2)-(hrpg.mob.armor[hrpg.fight[id]]/2))
			elseif itemtype(player(id,"weapontype"),"slot")==1 then
				dif=math.floor((hrpg.level[id]*itemtype(player(id,"weapontype"),"dmg"))-(hrpg.mob.armor[hrpg.fight[id]]/2))
			else
				dif=math.random(1,10)
			end
			if dif<=0 then
				dif=1
			end
			dif=math.floor(dif+math.random(-dif/5,dif/5))
			hudtxt2(id,hrpg.hudids[8],"255255255",translate(id,"COMBO").." - START!",320,60,1)
			parse("sv_sound2 "..id.." \"Houses RPG/hit"..math.random(1,3)..".ogg\"")
			timer(10,"hrpg.fighting.check",""..id.."",dif)
			hrpg.fighting.combohit[id]=true
			local t=0
			if dif>hrpg.mob.maxhp[hrpg.fight[id]] then
				t=100
			else
				t=math.floor((155-(dif/hrpg.mob.maxhp[hrpg.fight[id]])*155)+100)
			end
			hudtxt2(id,hrpg.hudids[10],""..t..""..t.."000",dif,320,240,1)
			if math.random(1,2)==1 then
				parse("hudtxtmove "..id.." "..hrpg.hudids[10].." 1000 "..(320-math.random(50,100)).." "..(240-math.random(50,100)).."")
			else
				parse("hudtxtmove "..id.." "..hrpg.hudids[10].." 1000 "..(320+math.random(50,100)).." "..(240-math.random(50,100)).."")
			end
			parse("hudtxtalphafade "..id.." "..hrpg.hudids[10].." 1000 0")
			hrpg.fighting.action[id]=2
			hrpg.fighting.combocounter[id]=1
			imagecolor(hrpg.enemyimg[id],255,0,0)
			tween_color(hrpg.enemyimg[id],500,255,255,255)
			imagecolor(hrpg.mob.id[hrpg.fight[id]],255,0,0)
			tween_color(hrpg.mob.id[hrpg.fight[id]],500,255,255,255)
			tween_move(hrpg.enemyimg[id],100,320-math.random(-15,15),240-math.random(-5,5))
			tween_scale(hrpg.fighting.turnimg[id],math.abs(hrpg.music.timing[hrpg.fighting.music[id]][hrpg.fighting.musicticker[id]]-math.abs(hrpg.fighting.comboticker[id])),2,2)
			timer(math.abs(hrpg.music.timing[hrpg.fighting.music[id]][hrpg.fighting.musicticker[id]]-math.abs(hrpg.fighting.comboticker[id])),"hrpg.mob.anim2",""..(id+32).."")
			timer(100,"hrpg.mob.anim1",""..id.."")
			freetimer("hrpg.fighting.endturn",""..id.."")
			timer(math.abs(hrpg.music.timing[hrpg.fighting.music[id]][hrpg.fighting.musicticker[id]]-math.abs(hrpg.fighting.comboticker[id]))+hrpg.room_for_error,"hrpg.fighting.endturn",""..id.."")
		elseif x>=330 and x<=430 and y>=415 and y<=440 then
			tween_scale(hrpg.fighting.hud[id][4],100,0.7,0.7)
			timer(100,"hrpg.mob.anim1",""..(id+96).."")
			hrpg.context[id]=3
			hrpg.inv(id,3)
		elseif x>=220 and x<=320 and y>=415 and y<=440 then
			tween_scale(hrpg.fighting.hud[id][3],100,0.7,0.7)
			if math.random(1,2)==1 then
				hudtxt2(id,hrpg.hudids[8],"255255255",""..player(id,"name").." "..translate(id,"tried running... and succeeded!").."",320,60,1)
				hrpg.fighting.turn[id]=""
				hrpg.fighting.action[id]=0
				hrpg.freefights(id)
				tween_scale(hrpg.enemyimg[id],3000,0,0)
				tween_alpha(hrpg.enemyimg[id],3000,0)
				tween_rotateconstantly(hrpg.enemyimg[id],10)
				if hrpg.fighting.turnimg[id]~=0 then
					freeimage(hrpg.fighting.turnimg[id])
				end
				hrpg.fighting.combohit[id]=false
				hrpg.fighting.turnimg[id]=0
				timer(3000,"hrpg.fighting.leave",""..id.."")
			else
				hudtxt2(id,hrpg.hudids[8],"255255255",""..player(id,"name").." "..translate(id,"tried running... and failed!").."",320,60,1)
				hrpg.fighting.turn[id]="mob"
				freetimer("hrpg.fighting.endturn",""..id.."")
				timer(1000,"hrpg.fighting.endturn",""..id.."")
			end
			timer(100,"hrpg.mob.anim1",""..(id+64).."")
		elseif x>=330 and x<=430 and y>=385 and y<=410 then
			hrpg.fighting.action[id]=3
			hrpg.fighting.turn[id]="mob"
			tween_scale(hrpg.fighting.hud[id][2],100,0.7,0.7)
			timer(100,"hrpg.mob.anim1",""..(id+32).."")
			hudtxt2(id,hrpg.hudids[8],"255255255",""..player(id,"name").." "..translate(id,"is defending.").."",320,60,1)
			freetimer("hrpg.fighting.endturn",""..id.."")
			timer(1000,"hrpg.fighting.endturn",""..id.."")
		end
	end
end
function hrpg.fighting.leave(i)
	local id=tonumber(i)
	hrpg.mob.busy[hrpg.fight[id]]=0
	if hrpg.fightimg[id]~=0 then
		freeimage(hrpg.fightimg[id])	
	end
	if hrpg.enemyimg[id]~=0 then
		freeimage(hrpg.enemyimg[id])
	end
	if hrpg.mob.fightimage[hrpg.fight[id]]~=0 then
		freeimage(hrpg.mob.fightimage[hrpg.fight[id]])
	end	
	freetimer("hrpg.mob.anim1",""..(id+64).."")
	hrpg.mob.fightimage[hrpg.fight[id]]=0
	if hrpg.fighting.turnimg[id]~=0 then
		freeimage(hrpg.fighting.turnimg[id])
	end
	hrpg.fighting.turnimg[id]=0
	hrpg.mob.hp[hrpg.fight[id]]=hrpg.mob.maxhp[hrpg.fight[id]]
	hrpg.mob.armor[hrpg.fight[id]]=hrpg.mob.level[hrpg.fight[id]]*hrpg.mob.typevar.armor[hrpg.mob.typ[hrpg.fight[id]]]
	if #hrpg.fighting.hud[id]~=0 then
		for i=1,5 do
			freeimage(hrpg.fighting.hud[id][1])
			table.remove(hrpg.fighting.hud[id],1)
		end
	end
	hrpg.fight[id]=0
	hrpg.fightimg[id]=0
	hrpg.enemyimg[id]=0
	hrpg.fighting.combohit[id]=false
	hrpg.fighting.damleft[id]=0
	hrpg.fighting.musicticker[id]=0
	hrpg.fighting.music[id]=0
	hrpg.fighting.comboticker[id]=0
	parse('effect "smoke" '..player(id,"x")..' '..player(id,'y')..' 6 6 0 0 0')
	for d=1,5 do
		hudding(d,id)
	end
	if carimg[id]~=0 then
		parse('speedmod '..id..' 15')
	else
		parse('speedmod '..id..' 0')
	end
	if myh[id]>0 then
		setpos(id,hrpg.housecoor[myh[id]][1]*32+16,hrpg.housecoor[myh[id]][2]*32+16)
	else
		if math.random(1,2)==1 then
			setpos(id,22*32+16,104*32+16)
		else
			setpos(id,168*32+16,104*32+16)
		end
	end
end
function hrpg.mob.anim1(i)
	local id=tonumber(i)
	if id>32 then
		if id>64 then
			if id>96 then
				if id>128 then
					if hrpg.fighting.combocounter[id-128]<=1 then
						tween_move(hrpg.fighting.hud[id-128][1],300,320,413)
						tween_scale(hrpg.fighting.hud[id-128][1],hrpg.room_for_error,0.4,1.3)
					else
						tween_scale(hrpg.fighting.hud[id-128][1],hrpg.room_for_error,0.4,1.3)
					end
				else
					tween_scale(hrpg.fighting.hud[id-96][4],100,1,1)
				end
			else
				tween_scale(hrpg.fighting.hud[id-64][3],100,1,1)
			end
		else
			tween_scale(hrpg.fighting.hud[id-32][2],100,1,1)
		end
	else
		tween_move(hrpg.enemyimg[id],50,320+math.random(-15,15),240+math.random(-5,5))
		timer(100,"hrpg.mob.anim2",""..id.."")
	end
end
function hrpg.mob.anim2(i)
	local id=tonumber(i)
	if id>=33 then
		tween_scale(hrpg.fighting.turnimg[id-32],hrpg.room_for_error,1,1)
	else
		tween_move(hrpg.enemyimg[id],100,320,240)
	end
end
function hrpg.winmusicloopstart(i)
	local t=hrpg.commakiller(i)
	local id=tonumber(t[1])
	hrpg.winmusicloop(t[1])
	if string.sub(t[2],1,1)~="A" and string.sub(t[2],1,1)~="a" and string.sub(t[2],1,1)~="e" and string.sub(t[2],1,1)~="E" and string.sub(t[2],1,1)~="o" and string.sub(t[2],1,1)~="O" and string.sub(t[2],1,1)~="I" and string.sub(t[2],1,1)~="i" and string.sub(t[2],1,1)~="U" and string.sub(t[2],1,1)~="U" then
		hudtxt2(id,hrpg.hudids[8],"255255255",""..t[3].." "..translate(id,"left something behind! It's a").." "..t[2].."!",320,60,1)
	else
		hudtxt2(id,hrpg.hudids[8],"255255255",""..t[3].." "..translate(id,"left something behind! It's an").." "..t[2].."!",320,60,1)
	end
	msg2(id,"255255255"..translate(id,"Click to continue!").."")
	hrpg.item_add(id,t[2],0)
	hrpg.fighting.turn[id]="player"
	hrpg.fighting.action[id]=4
	timer(6690,"hrpg.winmusicloop",t[1],0)
end
function hrpg.winmusicloop(i)
	parse("sv_sound2 "..tonumber(i).." \"Houses RPG/victory_loop.ogg\"")
end
function hrpg.freefights(id)
	freetimer("hrpg.fightstart",""..id.."")
	freetimer("hrpg.fightimagefix",""..id.."")
	freetimer("hrpg.fighting.check",""..id.."")
	freetimer("hrpg.fighting.finish",""..id.."")
	freetimer("hrpg.fighting.endturn",""..id.."")
	freetimer("hrpg.fighting.leave",""..id.."")
	freetimer("hrpg.healthdec",""..id.."")
	freetimer("hrpg.mob.turn",""..id.."")
	freetimer("hrpg.mob.anim1",""..id.."")
	freetimer("hrpg.mob.anim1",""..(id+32).."")
	freetimer("hrpg.mob.anim1",""..(id+64).."")
	freetimer("hrpg.mob.anim1",""..(id+96).."")
	freetimer("hrpg.mob.anim1",""..(id+128).."")
	freetimer("hrpg.mob.anim2",""..id.."")
	freetimer("hrpg.winmusicloop",""..id.."")
	freetimer("hrpg.winmusicloopstart",""..id.."")
	freetimer("hrpg.mob.retract",""..id.."")
	freetimer("hrpg.mob.retract",""..(id+32).."")
	freetimer("hrpg.mob.retract",""..(id+64).."")
	freetimer("hrpg.playerturn",""..id.."")
	freetimer("hrpg.playerturn",""..(id+32).."")
	freetimer("hrpg.music.update",""..id.."")
	freetimer("hrpg.music.update",""..(id+32).."")
	freetimer("hrpg.fightingmusicstart",""..id.."")
	if hrpg.fight[id]~=0 then
		freetimer("parse","customkill "..id.." LEVEL_"..hrpg.mob.level[hrpg.fight[id]].."_"..hrpg.mob.type[hrpg.fight[id]].." "..id.."")
	end
end

function hrpg.weps(i)
	local t=hrpg.commakiller(i)
	parse('equip '..tonumber(t[1])..' '..wid)
	parse('equip '..tonumber(t[2])..' '..wid)
	parse('setweapon '..tonumber(t[1])..' '..wid)
	parse('setweapon '..tonumber(t[2])..' '..wid)
	parse('equip '..tonumber(t[1])..' 50')
	parse('equip '..tonumber(t[2])..' 50')
end
function hrpg.wepfix(i)
	local id=tonumber(i)
	parse("strip "..id)
	parse("equip "..id.." 50")
	parse("equip "..id.." 74")
	parse("setweapon "..id.." 74")
end
function hrpg.kill(killer,victim,weapon,x,y)
	if player(killer,"money")~=16000 and killer~=victim then
		parse('setmoney '..killer..' '..player(killer,"money")-300)
	end
	if racer[victim]==1 then
		racer[victim]=0
		hrpg.race_leave(victim)
	end
	if killer~=victim and killer~=0 then
		local e=hrpg.level[victim]*math.random(1,10)
		hrpg.addexp(killer,e)
		msg2(killer,"255255255You got "..e.." XP!")
		hrpg.questupdate(killer,2)
	end
	if killer==challenger and victim==challenging then
		if rules~="1 kill" then
			score1=score1+1
			if rules=="3 kills" then
				cfight="Best of 3 - "..player(challenger,"name").." "..score1..":"..score2.." "..player(challenging,"name")..""
			elseif rules=="5 kills" then
				cfight="First to 5 - "..player(challenger,"name").." "..score1..":"..score2.." "..player(challenging,"name")..""
			end
			for i=1,#player(0,"table") do
				hudding(1,player(0,"table")[i])
			end
		end
		if rules=="1 kill" then
			msg("255255255"..player(killer,"name").." has won the First blood round!")
			won(killer,victim)
			hrpg.endarena()
		elseif rules=="3 kills" or rules=="5 kills" then
			frk1=frk1+1
			if frk1==3 and rules=="3 kills" then
				if score1>score2 then
					msg("255255255"..player(challenger,"name").." has won the Best of 3 round!")
					won(challenger,challenging)
					hrpg.endarena()
				elseif score1<score2 then
					msg("255255255"..player(challenging,"name").." has won the Best of 3 round!")
					won(challenging,challenger)
					hrpg.endarena()
				else
					msg("255255255It's a tie between "..player(challenging,"name").." and "..player(challenger,"name").."! Choosing random winner...")
					if math.random(1,2)==1 then
						won(challenging,challenger)
					else
						won(challenger,challenging)
					end
					hrpg.endarena()
				end
			end
			if score1==5 and rules=="5 kills" then
				msg("255255255"..player(challenger,"name").." has won the First to 5 round!")
				won(challenger,challenging)
				hrpg.endarena()
			end
		end
	elseif killer==challenging and victim==challenger then
		if rules~="1 kill" then
			score2=score2+1
			if rules=="3 kills" then
				cfight="Best of 3 - "..player(challenger,"name").." "..score1..":"..score2.." "..player(challenging,"name")..""
			elseif rules=="5 kills" then
				cfight="First to 5 - "..player(challenger,"name").." "..score1..":"..score2.." "..player(challenging,"name")..""
			end
			for i=1,#player(0,"table") do
				hudding(1,player(0,"table")[i])
			end
		end
		if rules=="1 kill" then
			msg("255255255"..player(challenging,"name").." has won the First blood round!")
			won(killer,victim)
			hrpg.endarena()
		elseif rules=="3 kills" or rules=="5 kills" then
			frk2=frk2+1
			if frk2==3 and rules=="3 kills" then
				if score1>score2 then
					msg("255255255"..player(challenger,"name").." has won the Best of 3 round!")
					won(challenger,challenging)
					hrpg.endarena()
				elseif score1<score2 then
					msg("255255255"..player(challenging,"name").." has won the Best of 3 round!")
					won(challenging,challenger)
					hrpg.endarena()
				else
					msg("255255255It's a tie between "..player(challenging,"name").." and "..player(challenger,"name").."! Choosing random winner...")
					if math.random(1,2)==1 then
						won(challenging,challenger)
					else
						won(challenger,challenging)
					end
					hrpg.endarena()
				end
			end
			if score2==5 and rules=="5 kills" then
				msg("255255255"..player(challenging,"name").." has won the First to 5 round!")
				won(challenging,challenger)
				hrpg.endarena()
			end
		end
	end
end
function hrpg.endarena()
	local c1=challenging
	local c2=challenger
	wid=74
	if player(c1,"exists") then
		spawnplayer(c1,77*32+16,162*32+16)
		parse("strip "..c1)
		timer(100,"hrpg.wepfix",""..c1.."")
	end
	if player(c2,"exists") then
		spawnplayer(c2,77*32+16,162*32+16)
		parse("strip "..c2)
		timer(100,"hrpg.wepfix",""..c2.."")
	end
	challenging=0
	challenger=0
	score1=0	
	score2=0
	time2=0
	tim=0
	rules=""
	cfight="None"
	for z=1,#player(0,"table") do
		hudding(1,player(0,"table")[z])
	end
	frk1=0
	frk2=0
end

function hrpg.addexp(id,a)
	local b=hrpg.experience[id]
	local c=a
	if a>0 and hrpg.level[id]<hrpg.maxlevel then
		if b+a>(hrpg.level[id]*100)+((hrpg.level[id]-1)*10) then
			while c>=((hrpg.level[id]*100)+((hrpg.level[id]-1)*10))-hrpg.experience[id] do
				c=c-(((hrpg.level[id]*100)+((hrpg.level[id]-1)*10))-hrpg.experience[id])
				hrpg.level[id]=hrpg.level[id]+1
				hrpg.experience[id]=0
				hrpg.questupdate(id,5)
			end
			if hrpg.level[id]~=hrpg.maxlevel then
				msg2(id,"255255255"..translate(id,"Level up!").." ("..hrpg.level[id]..")")
				hrpg.experience[id]=c
				parse("sv_sound2 "..id.." \"Houses RPG/levelup.ogg\"")
			else
				hrpg.maxlevelreached(id)
				hrpg.experience[id]=0
				parse("sv_sound2 "..id.." \"Houses RPG/levelup.ogg\"")
			end
		elseif b+a==(hrpg.level[id]*100)+((hrpg.level[id]-1)*10) then
			hrpg.level[id]=hrpg.level[id]+1
			if hrpg.level[id]~=hrpg.maxlevel then
				msg2(id,"255255255"..translate(id,"Level up!").." ("..hrpg.level[id]..")")
			else
				hrpg.maxlevelreached(id)
			end
			hrpg.questupdate(id,5)
			hrpg.experience[id]=0
			parse("sv_sound2 "..id.." \"Houses RPG/levelup.ogg\"")
		else
			hrpg.experience[id]=hrpg.experience[id]+a
		end
	end
	hudding(4,id)
	hudding(3,id)
end
function hrpg.maxlevelreached(id)
	for i=1,#hrpg.maxlevelitems do
		hrpg.item_add(id,hrpg.maxlevelitems[i],0)
	end
	msg2(id,"255255255You got new items! Check your Inventory (F3)!")
	msg("000255000"..player(id,"name").." has reached the maximum level! Congratulations!@C")
end

function hrpg.die(victim,killer,weapon,x,y)
	local id=victim
	if hrpg.fight[id]~=0 then
		if hrpg.mob.id[hrpg.fight[id]]~=nil then
			if hrpg.fighting.turn[id]=="end" then
				hrpg.mob.kill(hrpg.fight[id])
			else
				hrpg.mob.busy[hrpg.fight[id]]=0
				if hrpg.mob.fightimage[hrpg.fight[id]]~=0 then
					freeimage(hrpg.mob.fightimage[hrpg.fight[id]])
				end
				hrpg.mob.fightimage[hrpg.fight[id]]=0
				hrpg.mob.experience[hrpg.fight[id]]=hrpg.mob.experience[hrpg.fight[id]]+hrpg.level[id]*math.random(1,10)
				if hrpg.mob.experience[hrpg.fight[id]]>=(hrpg.mob.level[hrpg.fight[id]]*100)+((hrpg.mob.level[hrpg.fight[id]]-1)*10) then
					hrpg.mob.level[hrpg.fight[id]]=hrpg.mob.level[hrpg.fight[id]]+1
					hrpg.mob.experience[hrpg.fight[id]]=0
				end
				hrpg.mob.hp[hrpg.fight[id]]=hrpg.mob.maxhp[hrpg.fight[id]]
				hrpg.mob.armor[hrpg.fight[id]]=hrpg.mob.level[hrpg.fight[id]]*hrpg.mob.typevar.armor[hrpg.mob.typ[hrpg.fight[id]]]
			end
		end
		if hrpg.fightimg[id]~=0 then
			freeimage(hrpg.fightimg[id])
		end
		if hrpg.enemyimg[id]~=0 then
			freeimage(hrpg.enemyimg[id])
		end
		if hrpg.fighting.turnimg[id]~=0 then
			freeimage(hrpg.fighting.turnimg[id])
		end
		hrpg.fighting.turnimg[id]=0
		if hrpg.fighting.hud[id]~=0 and #hrpg.fighting.hud[id]~=0 then
			local c=5
			for i=1,5 do
				if hrpg.fighting.hud[id][c]~=0 then
					freeimage(hrpg.fighting.hud[id][c])
					table.remove(hrpg.fighting.hud[id],c)
				end
				c=c-1
			end
		end
		hrpg.enemyimg[id]=0
		hrpg.fightimg[id]=0
		local e=math.floor(hrpg.experience[id]*0.9)
		if e~=0 then
			msg2(id,"255255255"..translate(id,"You lost").." "..hrpg.experience[id]-e.." XP!")
			hrpg.experience[id]=e
		end
		if hrpg.experience[id]<0 then
			hrpg.experience[id]=0
		end
		hrpg.freefights(id)
		hrpg.fight[id]=0
		hrpg.fighting.damleft[id]=0
		hrpg.fighting.musicticker[id]=0
		hrpg.fighting.music[id]=0
		hrpg.fighting.turn[id]=""
		hrpg.fighting.comboticker[id]=0
		hrpg.fighting.combohit[id]=false
		for d=1,5 do
			hudding(d,id)
		end
		clearhudtxt2(id,hrpg.hudids[10])
		hrpg.fighting.action[id]=0
		parse('effect "colorsmoke" '..player(id,"x")..' '..player(id,'y')..' 1 1 255 0 0')
	end
	if victim==challenging or victim==challenger then
		if killer==victim and (challenging==0 or challenger==0) then
			if player(challenger,"exists") then
				spawnplayer(challenger,77*32+16,162*32+16)
				parse("strip "..challenger)
				parse("equip "..challenger.." 74")
				parse("equip "..challenger.." 50")
				parse("setweapon "..challenger.." 74")
			end
			if player(challenging,"exists") then
				spawnplayer(challenging,77*32+16,162*32+16)
				parse("strip "..challenging)
				parse("equip "..challenging.." 74")
				parse("equip "..challenging.." 50")
				parse("setweapon "..challenging.." 74")
			end
		end
		if rules~="1 kill" then
			local sp1=math.random(156*32+16,168*32+16)
			local sp2=math.random(156*32+16,168*32+16)
			spawnplayer(challenging,59*32+16,sp1)
			spawnplayer(challenger,74*32+16,sp2)
			setpos(challenging,59*32+16,sp1)
			setpos(challenger,74*32+16,sp2)
			timer(100,"hrpg.weps",""..challenger..","..challenging.."")
		elseif rules=="" then
			if player(challenger,"exists") then
				spawnplayer(challenger,77*32+16,162*32+16)
				parse("strip "..challenger)
				parse("equip "..challenger.." 74")
				parse("equip "..challenger.." 50")
				parse("setweapon "..challenger.." 74")
			end
			if player(challenging,"exists") then
				spawnplayer(challenging,77*32+16,162*32+16)
				parse("strip "..challenging)
				parse("equip "..challenging.." 74")
				parse("equip "..challenging.." 50")
				parse("setweapon "..challenging.." 74")
			end
			msg("255255255No contest!")
			rules=""
			tim=0
			time2=0
			cfight="None"
			for z=1,32 do
				hudding(1,z)
			end
			wid=74
			score1=0
			score2=0
			challenger=0
			challenging=0
		end
	end
	local id=victim
	racer[id]=0
	if carimg[id]~=0 then
		freeimage(carimg[id])
	end
	carimg[id]=0
	if parkimg[id]~=0 then
		freeimage(parkimg[id])
	end
	parkimg[id]=0
	if hrpg.darkness[id]~=0 then
		freeimage(hrpg.darkness[id])
	end
	hrpg.darkness[id]=0
	return 1
end

function won(idw,idl,p)
	local id=idw
	if racer[id]~=1 then
		hrpg.debt[idw]=hrpg.debt[idw]-1000
		if hrpg.debt[idw]<=0 then
			parse("setmoney "..idw.." "..player(idw,"money")-hrpg.debt[idw])
			hrpg.debt[idw]=0
		end
		msg2(idw,"255255255You won, so you owe now "..hrpg.debt[idw].."$ to the bank.")
	else
		for i=1,#hrpg.races do
			for d=1,#hrpg.races[i] do
				if hrpg.races[i][d]==id then
					parse("setmoney "..id.." "..player(id,"money")+((hrpg.races[i][1]-1)*500))
					if (hrpg.races[i][1]-1)~=1 then
						msg2(id,"255255255You got "..((hrpg.races[i][1]-1)*500).."$ for beating "..(hrpg.races[i][1]-1).." people!")
					else
						msg2(id,"255255255You got "..((hrpg.races[i][1]-1)*500).."$ for beating 1 person!")
					end
					break
				end
			end
		end
		hrpg.questupdate(id,1)
		return 1
	end
	msg2(idl,"255255255You didnt win, so you still owe "..hrpg.debt[idl].."$ to the bank.")
end

function hrpg.startround(mode)
	freetimer()
	for id=1,32 do
		if myh[id]~=0 then
			timer(1000,"hrpg.house",""..myh[id]..",load")
		end
		if racer[id]==1 and hrpg.powerup.image1[id]~=0 then
			hrpg.powerup.image1[id]=0
			hrpg.powerup.image2[id]=0
		end
		racer[id]=0
		hrpg.debt[id]=0
		carimg[id]=0
		parkimg[id]=0
		hrpg.quests[id]=0
		hrpg.questtypes[id]=0
		hrpg.questdets[id]=0
		hrpg.quest[id]="None"
		hrpg.questtype[id]=0
		hrpg.questdet[id]=0
		hrpg.questch[id]=0
		hrpg.questprog[id]=0
		hrpg.questreward[id]=0
		hrpg.questrews[id]=0
		hrpg.maxhealth[id]=100
		hrpg.maxarmor[id]=0
		hrpg.names[id]="House "..id..""
		hrpg.inventory[id]={}
		hrpg.item_queue[id]={}
		hrpg.page[id]=0
		hrpg.context[id]=0
		hrpg.powerup.item[id]=0
	end
	hrpg.furn.id={}
	hrpg.furn.size={}
	hrpg.furn.type={}
	hrpg.furn.player={}
	hrpg.furn.var={}
	hrpg.furn.img={}
	hrpg.furn.color={}
	hrpg.shop.stockings={}
	hrpg.mob.id={}
	hrpg.mob.type={}
	hrpg.mob.level={}
	hrpg.mob.experience={}
	hrpg.mob.busy={}
	hrpg.mob.fightimage={}
	hrpg.mob.hp={}
	hrpg.mob.maxhp={}
	hrpg.mob.typ={}
	hrpg.mob.experience={}
	hrpg.mob.shadow={}
	hrpg.fight=array(32)
	hrpg.fightimg=array3(32,0)
	hrpg.enemyimg=array3(32,0)
	hrpg.fighting={turn=array3(32,0),comboticker=array3(32,0),action=array(32,0),hud=array(32,{}),damleft=array(32,0),combocounter=array(32,0),turnimg=array(32,0)}
	for h=1,#hrpg.furn.types do
		if hrpg.furn.types[h]~=1 then
			table.insert(hrpg.shop.stockings,math.random(10,20))
		else
			table.insert(hrpg.shop.stockings,-1)
		end
	end
	hrpg.cycle=0
	hrpg.lengths={}
	for p=1,10 do
		table.insert(hrpg.lengths,math.random(hrpg.mindaylength,hrpg.maxdaylength)*10000)
	end
	hrpg.cyclereset("tomoon")
	hrpg.shop.restock()
	hrpg.races={}
	score1=0
	score2=0
	tim=0
	time2=0
	frk1=0
	frk2=0
	challenger=0
	challenging=0
	rules=""
	wid=74
	cfight="None"
	parse('sv_gamemode 1')
	hrpg.sellers={image("gfx/Houses RPG/shopkeeper.png",42*32+16,49*32+16,1),image("gfx/Houses RPG/shopkeeper.png",148*32+16,49*32+16,1),image("gfx/Houses RPG/shopkeeper.png",42*32+16,87*32+16,1),image("gfx/Houses RPG/shopkeeper.png",148*32+16,87*32+16,1)}
	hrpg.sellershadows={image("gfx/Houses RPG/shadow.png",42*32+16,49*32+16,0),image("gfx/Houses RPG/shadow.png",148*32+16,49*32+16,0),image("gfx/Houses RPG/shadow.png",42*32+16,87*32+16,0),image("gfx/Houses RPG/shadow.png",148*32+16,87*32+16,0)}
	imagepos(hrpg.sellers[1],42*32+16,49*32+16,-180)
	imagepos(hrpg.sellers[2],148*32+16,49*32+16,-180)
	imagepos(hrpg.sellers[3],42*32+16,87*32+16,-180)
	imagepos(hrpg.sellers[4],148*32+16,87*32+16,-180)
	tween_move(hrpg.sellers[1],5000,42*32+16,55*32+16)
	tween_move(hrpg.sellershadows[1],5000,42*32+16,55*32+16)
	tween_move(hrpg.sellers[2],5000,148*32+16,55*32+16)
	tween_move(hrpg.sellershadows[2],5000,148*32+16,55*32+16)
	tween_move(hrpg.sellers[3],5000,42*32+16,93*32+16)
	tween_move(hrpg.sellershadows[3],5000,42*32+16,93*32+16)
	tween_move(hrpg.sellers[4],5000,148*32+16,93*32+16)
	tween_move(hrpg.sellershadows[4],5000,148*32+16,93*32+16)
	for v=1,4 do
		imagescale(hrpg.sellershadows[v],1.2,1.2)
		imagealpha(hrpg.sellershadows[v],0.5)
		timer(5000,"hrpg.sellercycle",""..v..",up")
	end
	for c=1,5 do
		for id=1,32 do
			hudding(c,id)
		end
	end
	hrpg.sellstates={"idle","idle","idle","idle"}
	hrpg.houseroof=array(32)
	hrpg.rooftype=array3(32,"")
end

function hrpg.leave(id,p)
	if id==challenger or id==challenging then
		if id==challenger then
			if player(challenging,"exists") then
				spawnplayer(challenging,77*32+16,162*32+16)
				parse("strip "..challenging.." "..wid)
				parse("equip "..challenging.." 74")
				parse("setweapon "..challenging.." 74")
			end
		else
			if player(challenger,"exists") then
				spawnplayer(challenger,77*32+16,162*32+16)
				parse("strip "..challenger.." "..wid)
				parse("equip "..challenger.." 74")
				parse("setweapon "..challenger.." 74")
			end
		end
		msg("255255255"..player(id,"name").." is a coward!")
		rules=""
		time2=0
		tim=0
		cfight="None"
		wid=74
		score1=0
		score2=0
		challenger=0
		challenging=0
		for z=1,32 do
			hudding(1,z)
		end
	end
	if racer[id]==1 then
		hrpg.race_leave(id)
		racer[id]=0
		if hrpg.powerup.image1[id]~=0 then
			freeimage(hrpg.powerup.image1[id])
		end
		if hrpg.powerup.image2[id]~=0 then
			freeimage(hrpg.powerup.image2[id])
		end
		hrpg.powerup.image1[id]=0
		hrpg.powerup.image2[id]=0
		hrpg.powerup.item[id]=0
	end
	if myh[id]>0 then
		if p~=nil then
			hrpg.house(myh[id],"save")
		end
		hrpg.house(myh[id],"destroy")
		local h=myh[id]
		myh[id]=0
		hrpg.names[h]="House "..h..""
		parse('trigger hs'..h..'w')
	end
	if player(id,"team")>0 then
		local c=#hrpg.furn.id
		for d=1,#hrpg.furn.id do
			if hrpg.furn.player[c]==id then
				hrpg.furn.kill(c)
			end
			c=c-1
		end
	end
	myh[id]=0
	hrpg.debt[id]=0
	racer[id]=0
	namch[id]=0
	if carimg[id]~=0 then
		freeimage(carimg[id])
	end
	carimg[id]=0
	if parkimg[id]~=0 then
		freeimage(parkimg[id])
	end
	parkimg[id]=0
	if hrpg.darkness[id]~=0 then
		freeimage(hrpg.darkness[id])
	end
	hrpg.darkness[id]=0
	hrpg.maxhealth[id]=100
	hrpg.maxarmor[id]=0
	hrpg.hud1[id]=1
	hrpg.hud2[id]=1
	hrpg.page[id]=0
	hrpg.context[id]=0
	hrpg.inventory[id]={}
	hrpg.item_queue[id]={}
	hrpg.colors[id]={255,255,255}
	hrpg.quest[id]="None"
	hrpg.questprog[id]=0
	hrpg.questdet[id]=0
	hrpg.questreward[id]=0
	hrpg.namechange[id]=0
	hrpg.check[id]=0
	hrpg.lap[id]=0
	hrpg.bankdeposit[id]=0
	hrpg.fighting.combohit[id]=false
	hrpg.delay[id]=false
	hrpg.fighting.comboticker[id]=0
	hrpg.fighting.turn[id]=""
	hrpg.fighting.damleft[id]=0
	hrpg.fighting.musicticker[id]=0
	hrpg.language[id]="English"
	hrpg.freefights(id)
	hrpg.placeh[id]=0
	hrpg.fighting.music[id]=0
	freetimer("hrpg.carappear",""..id.."")
	freetimer("hrpg.cardisappear",""..id.."")
	if hrpg.fight[id]~=0 then
		if hrpg.fighting.turn[id]=="end" and hrpg.mob.id[hrpg.fight[id]]~=nil then
			hrpg.mob.kill(hrpg.fight[id])
		else
			hrpg.mob.busy[hrpg.fight[id]]=0
			hrpg.mob.hp[hrpg.fight[id]]=hrpg.mob.maxhp[hrpg.fight[id]]
			if hrpg.mob.fightimage[hrpg.fight[id]]~=0 then
				freeimage(hrpg.mob.fightimage[hrpg.fight[id]])
			end
			hrpg.mob.fightimage[hrpg.fight[id]]=0
		end
		if hrpg.fightimg[id]~=0 then
			freeimage(hrpg.fightimg[id])
		end
		if hrpg.enemyimg[id]~=0 then
			freeimage(hrpg.enemyimg[id])
		end
		if hrpg.fighting.turnimg[id]~=0 then
			freeimage(hrpg.fighting.turnimg[id])
		end
		if hrpg.fighting.hud[id]~=0 and #hrpg.fighting.hud[id]~=0 then
			local c=5
			for i=1,5 do
				if hrpg.fighting.hud[id][c]~=0 then
					freeimage(hrpg.fighting.hud[id][c])
					table.remove(hrpg.fighting.hud[id],c)
				end
				c=c-1
			end
		end
	end
	hrpg.fight[id]=0
	hrpg.fighting.turnimg[id]=0
	hrpg.level[id]=1
	hrpg.experience[id]=0
	hrpg.enemyimg[id]=0
	hrpg.fightimg[id]=0
	hrpg.myhrot[id]=0
end

function hrpg.spawn(id)
	parse("setmoney "..id.." "..player(id,"money"))
	parse("setmaxhealth "..id.." "..hrpg.maxhealth[id])
	if hrpg.maxarmor[id]<=206 then
		parse("setarmor "..id.." "..hrpg.maxarmor[id])
	else
		parse("setarmor "..id.." "..math.random(201,206).."")
	end
	parse('speedmod '..id..' 0')
	for d=1,5 do
		hudding(d,id)
	end
	parse('equip '..id..' 74')
	if id==challenger or id==challenging then
		parse('equip '..id..' '..wid)
		parse('setweapon '..id..' '..wid..'')
	else
		parse("setweapon "..id.." 74")
		if myh[id]==0 then
			msg2(id,"255255255"..translate(id,"New to the map? Say !help to know more. Also remember that F2 opens the House Menu!").."")
		end
	end
	hrpg.page[id]=0
	hrpg.context[id]=0
	hrpg.shop.being[id]=0
	hrpg.placeh[id]=0
	hrpg.namechange[id]=0
	namch[id]=0
end

function hrpg.drop(id,iid,t)
	if player(id,"health")>0 and racer[id]==0 then
		for i=1,#hrpg.inventory[id] do
			if hrpg.inventory[id][i]==itemtype(t,"name") then
				hrpg.item_remove(id,i)
			end
		end
	end
	if id==challenger or id==challenging or player(id,"weapontype")==74 then
		return 1
	end
end

function hrpg.gen(id)
	b=array2(8,1,#qnames)	
	d=array2(8,1,#rnames)
	f=array2(8,1,#rnames)
	local a1=b[1]
	local a2=b[2]
	local a3=b[3]
	local a4=b[4]
	local a5=b[5]
	local a6=b[6]
	local a7=b[7]
	local a8=b[8]
	local c1=f[1]
	local c2=f[2]
	local c3=f[3]
	local c4=f[4]
	local c5=f[5]
	local c6=f[6]
	local c7=f[7]
	local c8=f[8]
	local d1=d[1]
	local d2=d[2]
	local d3=d[3]
	local d4=d[4]
	local d5=d[5]
	local d6=d[6]
	local d7=d[7]
	local d8=d[8]
	local b1,b2,b3,b4,b5,b6,b7,b8=""
	if d[1]>1 then
		b1=translate(id,qnames[a1]).." ("..d[1].." "..translate(id,"times")..")"
	else
		b1=translate(id,qnames[a1]).." ("..d[1].." "..translate(id,"time")..")"
	end
	if d[2]>1 then
		b2=translate(id,qnames[a2]).." ("..d[2].." "..translate(id,"times")..")"
	else
		b2=translate(id,qnames[a2]).." ("..d[2].." "..translate(id,"time")..")"
	end
	if d[3]>1 then
		b3=translate(id,qnames[a3]).." ("..d[3].." "..translate(id,"times")..")"
	else
		b3=translate(id,qnames[a3]).." ("..d[3].." "..translate(id,"time")..")"
	end
	if d[4]>1 then
		b4=translate(id,qnames[a4]).." ("..d[4].." "..translate(id,"times")..")"
	else
		b4=translate(id,qnames[a4]).." ("..d[4].." "..translate(id,"time")..")"
	end
	if d[5]>1 then
		b5=translate(id,qnames[a5]).." ("..d[5].." "..translate(id,"times")..")"
	else
		b5=translate(id,qnames[a5]).." ("..d[5].." "..translate(id,"time")..")"
	end
	if d[6]>1 then
		b6=translate(id,qnames[a6]).." ("..d[6].." "..translate(id,"times")..")"
	else
		b6=translate(id,qnames[a6]).." ("..d[6].." "..translate(id,"time")..")"
	end
	if d[7]>1 then
		b7=translate(id,qnames[a7]).." ("..d[7].." "..translate(id,"times")..")"
	else
		b7=translate(id,qnames[a7]).." ("..d[7].." "..translate(id,"time")..")"
	end
	if d[8]>1 then
		b8=translate(id,qnames[a8]).." ("..d[8].." "..translate(id,"times")..")"
	else
		b8=translate(id,qnames[a8]).." ("..d[8].." "..translate(id,"time")..")"
	end
	local e1,e2,e3,e4,e5,e6,e7,e8=""
	if math.random(1,3)==1 then
		e1=hrpg.shop.offers[1][math.random(1,#hrpg.shop.offers[1])]
	else
		e1=rnames[d1]
	end
	if math.random(1,3)==1 then
		e2=hrpg.shop.offers[1][math.random(1,#hrpg.shop.offers[1])]
	else
		e2=rnames[d2]
	end
	if math.random(1,3)==1 then
		e3=hrpg.shop.offers[1][math.random(1,#hrpg.shop.offers[1])]
	else
		e3=rnames[d3]
	end
	if math.random(1,3)==1 then
		e4=hrpg.shop.offers[1][math.random(1,#hrpg.shop.offers[1])]
	else
		e4=rnames[d4]
	end
	if math.random(1,3)==1 then
		e5=hrpg.shop.offers[1][math.random(1,#hrpg.shop.offers[1])]
	else
		e5=rnames[d5]
	end
	if math.random(1,3)==1 then
		e6=hrpg.shop.offers[1][math.random(1,#hrpg.shop.offers[1])]
	else
		e6=rnames[d6]
	end
	if math.random(1,3)==1 then
		e7=hrpg.shop.offers[1][math.random(1,#hrpg.shop.offers[1])]
	else
		e7=rnames[d7]
	end
	if math.random(1,3)==1 then
		e8=hrpg.shop.offers[1][math.random(1,#hrpg.shop.offers[1])]
	else
		e8=rnames[d8]
	end
	hrpg.quests[id]={b1,b2,b3,b4,b5,b6,b7,b8}
	hrpg.questtypes[id]={a1,a2,a3,a4,a5,a6,a7,a8}
	hrpg.questdets[id]={d[1],d[2],d[3],d[4],d[5],d[6],d[7],d[8]}
	hrpg.questrews[id]={e1,e2,e3,e4,e5,e6,e7,e8}
	menu(id,translate(id,"Choose your quest").."@b,"..b1.."|"..e1..","..b2.."|"..e2..","..b3.."|"..e3..","..b4.."|"..e4..","..b5.."|"..e5..","..b6.."|"..e6..","..b7.."|"..e7..","..b8.."|"..e8..","..translate(id,"Back"))
end
function hrpg.showq(id)
	hrpg.questch[id]=0
	hrpg.questtype[id]=0
	hrpg.quest[id]="None"
	hrpg.questdet[id]=0
	hrpg.questprog[id]=0
	hudding(3,id)
end
function hrpg.questupdate(id,t)
	if hrpg.questch[id]==1 and hrpg.questtype[id]==t then
		hrpg.questprog[id]=hrpg.questprog[id]+1
		if hrpg.questprog[id]>=hrpg.questdet[id] then
			msg2(id,"255255255Quest completed!")	
			hrpg.questrew(id)
			hrpg.questch[id]=0
			hrpg.questreward[id]=0
			hrpg.questtype[id]=0
			hrpg.quest[id]="None"
			hrpg.questdet[id]=0
			hrpg.questprog[id]=0
		end
	end
end
function hrpg.questrew(id)
	local ch=0
	if hrpg.questreward[id]=="" or hrpg.questreward[id]==0 then
		return 0
	end
	if hrpg.questreward[id]:find("00") then
		local m=0
		local s=0
		for i=1,string.len(hrpg.questreward[id]) do
			if string.sub(hrpg.questreward[id],i,i+1)=="00" then
				m=i
			end
		end
		s=tonumber(string.sub(hrpg.questreward[id],1,m+1))
		if hrpg.debt[id]>=s then
			hrpg.debt[id]=hrpg.debt[id]-s
			msg2(id,"255255255"..translate(id,"You owe now").." "..hrpg.debt[id].."$ "..translate(id,"to the bank")..".")
		else
			parse("setmoney "..id.." "..player(id,"money")+s)
		end
		ch=1
	elseif hrpg.questreward[id]:find(translate(id,"point Max Health boost")) then
		local t=tonumber(string.sub(hrpg.questreward[id],1,1))
		parse("setmaxhealth "..id.." "..player(id,"maxhealth")+t)
		hrpg.maxhealth[id]=hrpg.maxhealth[id]+t
		ch=1
	elseif hrpg.questreward[id]:find(translate(id,"point Max Health boost")) then
		local t=tonumber(string.sub(hrpg.questreward[id],1,1))
		parse("setarmor "..id.." "..player(id,"armor")+1)
		hrpg.maxarmor[id]=hrpg.maxarmor[id]+1
		ch=1
	end
	for i=1,#hrpg.furniture do
		if hrpg.questreward[id]==hrpg.furniture[i] then
			hrpg.item_add(id,hrpg.furniture[i],1)
			break
		end
	end
end

function hrpg.objectdamage(id,d,p)
	if player(p,"rcon") or player(p,"ip")=="0.0.0.0" then
		return 0
	elseif hrpg.fight[p]~=0 or myh[p]==0 then
		return 1
	elseif d>0 then
		if myh[p]~=0 and object(id,"player")~=p and object(id,"tilex")>hrpg.housecoor[myh[p]][1]-hrpg.housesize[myh[p]][1] and object(id,"tilex")<hrpg.housecoor[myh[p]][1]+hrpg.housesize[myh[p]][1] and object(id,"tilex")>hrpg.housecoor[myh[p]][1]-hrpg.housesize[myh[p]][1] and object(id,"tiley")<hrpg.housecoor[myh[p]][2]+hrpg.housesize[myh[p]][2] then
			return 1
		elseif object(id,"player")==p then
			return 0
		end
		return 1
	else
		return 0
	end
end

function hrpg.log(t)
	if string.sub(t,1,9)=="angledif:" then -- DC, Y U NO FIX ANGLEDIF SPAM?! 
		return 1
	end
end

function hrpg.team(id,t,k)
	if k==-1 then
		menu(id,"Choose language,English,Polski,Deutsch")
		return 1
	end
	if t>0 and player(id,"deaths")<1 then
		hrpg.inventory[id]={}
		hrpg.item_queue[id]={}
		local file=0
		local iden={"",""}
		if player(id,"usgn")~=0 then
			iden={"USGN","usgn"}
		else
			iden={"IP","ip"}
		end
		file=io.open('sys/lua/HRPG_saves/'..iden[1]..'_'..player(id,iden[2])..'.sav','r') 
		if file~=nil then
			msg2(id,"125125125"..iden[1].." save successfully found!")
			file:close()
			for i=1,32 do
				if hrpg.house(i,"owned")==0 then
					myh[id]=i
					timer(100,"hrpg.shortfix",""..id.."")
					break
				end
			end
		else
			msg2(id,"125125125"..iden[1].." save not found...")
			menu(id,"Choose language,English,Polski,Deutsch")
		end
	elseif t>0 then
		if myh[id]>0 then
			timer(100,"hrpg.house",""..myh[id]..",generate")
		else
			msg2(id,"255255255Your house had to be removed due to you spectating.")
			msg2(id,"255255255Your items and furniture are still safe in your inventory though.") 
		end
	elseif t==0 then
		local c=1
		for i=1,#hrpg.furn.id do
			if hrpg.furn.player[c]==id then
				if tonumber(hrpg.furn.var[c])~=nil and tonumber(hrpg.furn.var[c])~=0 then
					hrpg.item_add(id,itemtype(hrpg.furn.var[c],"name"),0)
				else
					hrpg.item_add(id,hrpg.furn.var[c],0)
				end
				hrpg.furn.kill(c)
			else
				c=c+1
			end
		end
		if myh[id]>0 then
			hrpg.house(myh[id],"destroy")
			local h=myh[id]
			myh[id]=0
			hrpg.names[h]="House "..h..""
			parse('trigger hs'..h..'w')
		end
		timer(100,"hrpg.hudfix",""..id.."")
	end
end
function hrpg.hudfix(i)
	local id=tonumber(i)
	if player(id,"exists") then
		hudding(1,id)
	end
end
function hrpg.shortfix(i)
	local id=tonumber(i)
	if player(id,"exists") then
		hrpg.house(myh[id],"load")
	end
end

function hrpg.cyclereset(p)
	if p=="tosun" then
		hrpg.length=hrpg.lengths[math.random(1,#hrpg.lengths)]
		if hrpg.cycle~=0 then
			freeimage(hrpg.cycle)
		end
		hrpg.cycle=image("gfx/Houses RPG/night.png",0,0,3)
		imagescale(hrpg.cycle,map("xsize")*2,map("ysize")*2)
		imagealpha(hrpg.cycle,hrpg.night_transparency)
		tween_alpha(hrpg.cycle,hrpg.length,0)
		msg("255255255It's midnight...")
		timer(hrpg.length,"hrpg.cyclereset","tomoon")
		timer(hrpg.length-hrpg.length/5,"hrpg.shop.restock")
		if hrpg.spawnmobs then
			timer(hrpg.length/2,"hrpg.mob.wipe")
		end
		hrpg.time=-hrpg.length
	elseif p=="tomoon" then
		hrpg.length=hrpg.lengths[math.random(1,#hrpg.lengths)]
		if hrpg.cycle~=0 then
			freeimage(hrpg.cycle)
		end
		hrpg.cycle=image("gfx/Houses RPG/night.png",0,0,3)
		imagescale(hrpg.cycle,map("xsize")*2,map("ysize")*2)
		imagealpha(hrpg.cycle,0)
		tween_alpha(hrpg.cycle,hrpg.length,hrpg.night_transparency)
		msg("255255255It's midday...")
		timer(hrpg.length,"hrpg.cyclereset","tosun")
		if hrpg.spawnmobs then
			timer(hrpg.length-hrpg.length/4,"hrpg.mob.spawn","0")
		end
		hrpg.time=hrpg.length
	end
end

function hrpg.mob.spawn(f,y)
	if f==nil then f=0 end
	local x=tonumber(f)
	if x==0 then
		if #hrpg.mob.id==0 then
			msg("255255255Beware! Monsters have appeared on the streets!")
		else
			return 1
		end
	end
	local px,py=0
	local d=hrpg.level
	local t={}
	for i=1,32 do
		if player(i,"exists") and player(i,"team")>0 then
			table.insert(t,hrpg.level[i])
		end
	end
	if #t==0 then
		t[1]=1
	end
	table.sort(t)
	local minlevel=t[1]-2
	if minlevel<1 then
		minlevel=1
	end
	local maxlevel=t[#t]
	if maxlevel+1>hrpg.maxlevel then
		maxlevel=hrpg.maxlevel-1
	end
	local r=0
	if x==0 then
		for i=1,#hrpg.mob.spawns do
			r=math.random(1,#hrpg.mob.types)
			table.insert(hrpg.mob.type,hrpg.mob.types[r])
			px=hrpg.mob.spawns[i][1]*32+(math.random(-1,1)*32)+16
			py=hrpg.mob.spawns[i][2]*32+(math.random(-1,1)*32)+16
			table.insert(hrpg.mob.id,image(hrpg.mob.typevar.image[r],px,py,1))
			table.insert(hrpg.mob.shadow,image("gfx/Houses RPG/shadow.png",px,py,0))
			imagealpha(hrpg.mob.shadow[#hrpg.mob.shadow],0.5)
			imagescale(hrpg.mob.shadow[#hrpg.mob.shadow],1.2,1.2)
			imagepos(hrpg.mob.id[#hrpg.mob.id],px,py,math.random(0,360))
			table.insert(hrpg.mob.level,math.random(minlevel,maxlevel+1))
			table.insert(hrpg.mob.experience,0)
			table.insert(hrpg.mob.spawnarea,{hrpg.mob.spawns[i][1],hrpg.mob.spawns[i][2]})
			table.insert(hrpg.mob.busy,0)
			table.insert(hrpg.mob.fightimage,0)
			table.insert(hrpg.mob.typ,r)
			table.insert(hrpg.mob.maxhp,hrpg.mob.level[#hrpg.mob.typ]*(hrpg.mob.typevar.hp[hrpg.mob.typ[#hrpg.mob.typ]]))
			table.insert(hrpg.mob.hp,hrpg.mob.maxhp[#hrpg.mob.maxhp])
			table.insert(hrpg.mob.armor,hrpg.mob.level[#hrpg.mob.typ]*hrpg.mob.typevar.armor[hrpg.mob.typ[#hrpg.mob.typ]])
		end
	else
		r=math.random(1,#hrpg.mob.types)
		table.insert(hrpg.mob.type,hrpg.mob.types[r])
		px=x*32+(math.random(-1,1)*32)+16
		py=y*32+(math.random(-1,1)*32)+16
		table.insert(hrpg.mob.id,image(hrpg.mob.typevar.image[r],px,py,1))
		table.insert(hrpg.mob.shadow,image("gfx/Houses RPG/shadow.png",px,py,0))
		imagealpha(hrpg.mob.shadow[#hrpg.mob.shadow],0.5)
		imagescale(hrpg.mob.shadow[#hrpg.mob.shadow],1.2,1.2)
		imagepos(hrpg.mob.id[#hrpg.mob.id],px,py,math.random(0,360))
		table.insert(hrpg.mob.level,math.random(minlevel,maxlevel+1))
		table.insert(hrpg.mob.experience,0)
		table.insert(hrpg.mob.spawnarea,{x,y})
		table.insert(hrpg.mob.busy,0)
		table.insert(hrpg.mob.fightimage,0)
		table.insert(hrpg.mob.typ,r)
		table.insert(hrpg.mob.maxhp,hrpg.mob.level[#hrpg.mob.typ]*(hrpg.mob.typevar.hp[hrpg.mob.typ[#hrpg.mob.typ]]))
		table.insert(hrpg.mob.hp,hrpg.mob.maxhp[#hrpg.mob.maxhp])
		table.insert(hrpg.mob.armor,hrpg.mob.level[#hrpg.mob.typ]*hrpg.mob.typevar.armor[hrpg.mob.typ[#hrpg.mob.typ]])
	end
end
function hrpg.mob.kill(i)
	i=tonumber(i)
	freeimage(hrpg.mob.id[i])
	table.remove(hrpg.mob.id,i)
	table.remove(hrpg.mob.experience,i)
	table.remove(hrpg.mob.spawnarea,i)
	if hrpg.mob.busy[i]==1 then
		for id=1,32 do
			if player(id,"exists") and player(id,"health")>0 and hrpg.fight[id]==i then
				if hrpg.fightimg[id]~=0 then
					freeimage(hrpg.fightimg[id])
				end
				if hrpg.enemyimg[id]~=0 then
					freeimage(hrpg.enemyimg[id])
				end
				if carimg[id]~=0 then
					parse('speedmod '..id..' 15')
				else
					parse('speedmod '..id..' 0')
				end
				if #hrpg.fighting.hud[id]>0 then
					for d=1,5 do
						freeimage(hrpg.fighting.hud[id][1])
						table.remove(hrpg.fighting.hud[id],1)
					end
				end
				if hrpg.fighting.turnimg[id]~=0 then
					freeimage(hrpg.fighting.turnimg[id])
				end
				hrpg.freefights(id)
				hrpg.fight[id]=0
				hrpg.fighting.turnimg[id]=0
				hrpg.enemyimg[id]=0
				hrpg.fightimg[id]=0
				hrpg.fighting.damleft[id]=0
				hrpg.fighting.musicticker[id]=0
				hrpg.fighting.music[id]=0
				hrpg.fighting.comboticker[id]=0
				for c=1,5 do
					hudding(c,id)
				end
				break
			end
		end
	end
	table.remove(hrpg.mob.level,i)
	table.remove(hrpg.mob.type,i)
	table.remove(hrpg.mob.busy,i)
	if hrpg.mob.fightimage[i]~=0 then
		freeimage(hrpg.mob.fightimage[i])
	end
	table.remove(hrpg.mob.fightimage,i)
	if hrpg.mob.shadow[i]~=0 then
		freeimage(hrpg.mob.shadow[i])
	end
	table.remove(hrpg.mob.shadow,i)
	table.remove(hrpg.mob.hp,i)
	table.remove(hrpg.mob.maxhp,i)
	table.remove(hrpg.mob.typ,i)
	table.remove(hrpg.mob.armor,i)
	for p=1,#player(0,"tableliving") do
		if hrpg.fight[player(0,"tableliving")[p]]>i then
			hrpg.fight[player(0,"tableliving")[p]]=hrpg.fight[player(0,"tableliving")[p]]-1
		end
	end
end
function hrpg.mob.wipe()
	if #hrpg.mob.id>0 then
		msg("255255255The monsters have left to another realm...")
		for i=1,#hrpg.mob.id do
			hrpg.mob.kill(1)
		end
	end
	hrpg.fight=array(32,0)
	hrpg.mob.freetimers()
	timer(100,"hrpg.mob.freetimers")
end
function hrpg.mob.freetimers()
	freetimer("hrpg.fightstart")
	freetimer("hrpg.fightimagefix")
	freetimer("hrpg.fighting.check")
	freetimer("hrpg.fighting.endturn")
	freetimer("hrpg.healthdec")
	freetimer("hrpg.mob.turn")
	freetimer("hrpg.mob.anim1")
	freetimer("hrpg.mob.anim2")
	freetimer("hrpg.fighting.finish")
	freetimer("hrpg.winmusicloop")
	freetimer("hrpg.winmusicloopstart")
	freetimer("hrpg.mob.retract")
	freetimer("hrpg.playerturn")
	freetimer("hrpg.fighting.leave")
	freetimer("hrpg.music.update")
	freetimer("hrpg.fightingmusicstart")
end

function hrpg.respcycle()
	freeimage(hrpg.cycle)
	hrpg.cycle=image("gfx/Houses RPG/night.png",0,0,3)
	imagescale(hrpg.cycle,map("xsize")*2,map("ysize")*2)
	if hrpg.time<0 then
		imagealpha(hrpg.cycle,(math.abs(hrpg.time)/hrpg.length*hrpg.night_transparency))
		tween_alpha(hrpg.cycle,math.abs(hrpg.time),0)
	elseif hrpg.time>0 then
		imagealpha(hrpg.cycle,hrpg.night_transparency-(math.abs(hrpg.time)/hrpg.length*hrpg.night_transparency))
		tween_alpha(hrpg.cycle,math.abs(hrpg.time),hrpg.night_transparency)
	end
end
function hrpg.shop.restock(v)
	hrpg.shop.prices={}
	for i=1,#hrpg.furn.prices do
		table.insert(hrpg.shop.prices,hrpg.furn.prices[i])
	end
	msg("255255255SHOP ANNOUNCEMENT!")
	for d=1,#hrpg.shop.stockings do
		if hrpg.shop.stockings[d]>=0 then
			hrpg.shop.stockings[d]=hrpg.shop.stockings[d]+(math.random(1,3)*#player(0,"tableliving"))
		end
	end
	msg("255255255All items have been restocked!")
	if v==nil or v=="" then
		local num=math.random(9,16)
		local tab={}
		local len=0
		local rand=0
		local shops={{},{},{},{}}
		for j=1,#shops do
			for x=1,#hrpg.shop.offers[j] do
				table.insert(shops[j],hrpg.shop.offers[j][x])
			end
			rand=math.random(1,#shops[j])
			table.insert(tab,shops[j][rand])
			table.remove(shops[j],rand)
			rand=math.random(1,#shops[j])
			table.insert(tab,shops[j][rand])
		end
		local tt={1,2,3,4}
		local ran=0
		local z=#tt
		for g=1,#tt do
			if #shops[tt[z]]==2 then
				table.remove(tt,z)
			else
				z=z-1
			end
		end
		for s=9,num do
			ran=tt[math.random(1,#tt)]
			table.insert(tab,shops[ran][math.random(1,#shops[ran])])
		end
		local b=0
		local p=0
		local k=0
		local tabb={}
		if tonumber(string.sub(os.date(),4,5))~=nil and tonumber(string.sub(os.date(),4,5))==12 and tonumber(string.sub(os.date(),1,2))~=nil and tonumber(string.sub(os.date(),1,2))>=23 and tonumber(string.sub(os.date(),1,2))<=31 then
			msg("255255255HOLIDAY SALE!")
			msg("255255255Everything is 25% - 75% off!")
			for v=1,#hrpg.shop.prices do
				hrpg.shop.prices[p]=math.floor(hrpg.shop.prices[p]*hrpg.holidaybargains[math.random(1,#hrpg.holdiaybargains)])
			end
			return 1
		end
		for i=1,num do
			b=math.random(1,#hrpg.bargains)
			for m=1,#hrpg.furniture do	
				if hrpg.furniture[m]==tab[1] then
					p=m
					break
				end
			end
			if i<9 then
				if hrpg.shop.dealimgs[i]~=0 then
					freeimage(hrpg.shop.dealimgs[i])
				end
				if i==1 then
					if hrpg.furn.types[p]~=1 then
						hrpg.shop.dealimgs[i]=image(hrpg.furn.image[p],36*32+16,49*32+16,1)
					else
						hrpg.shop.dealimgs[i]=image("gfx/weapons/"..string.gsub(hrpg.furniture[p]," ","").."_k.bmp",36*32+16,49*32+16,1)
					end
					imagepos(hrpg.shop.dealimgs[i],36*32+16,49*32+16,180)
				elseif i==2 then
					if hrpg.furn.types[p]~=1 then
						hrpg.shop.dealimgs[i]=image(hrpg.furn.image[p],36*32+16,55*32+16,1)
					else
						hrpg.shop.dealimgs[i]=image("gfx/weapons/"..string.gsub(hrpg.furniture[p]," ","").."_k.bmp",36*32+16,55*32+16,1)
					end
				elseif i==3 then
					if hrpg.furn.types[p]~=1 then
						hrpg.shop.dealimgs[i]=image(hrpg.furn.image[p],154*32+16,49*32+16,1)
					else
						hrpg.shop.dealimgs[i]=image("gfx/weapons/"..string.gsub(hrpg.furniture[p]," ","").."_k.bmp",154*32+16,49*32+16,1)
					end
					imagepos(hrpg.shop.dealimgs[i],154*32+16,49*32+16,180)
				elseif i==4 then
					if hrpg.furn.types[p]~=1 then
						hrpg.shop.dealimgs[i]=image(hrpg.furn.image[p],154*32+16,55*32+16,1)
					else
						hrpg.shop.dealimgs[i]=image("gfx/weapons/"..string.gsub(hrpg.furniture[p]," ","").."_k.bmp",154*32+16,55*32+16,1)
					end
				elseif i==5 then
					if hrpg.furn.types[p]~=1 then
						hrpg.shop.dealimgs[i]=image(hrpg.furn.image[p],36*32+16,87*32+16,1)
					else
						hrpg.shop.dealimgs[i]=image("gfx/weapons/"..string.gsub(hrpg.furniture[p]," ","").."_k.bmp",36*32+16,87*32+16,1)
					end
					imagepos(hrpg.shop.dealimgs[i],36*32+16,87*32+16,180)
				elseif i==6 then
					if hrpg.furn.types[p]~=1 then
						hrpg.shop.dealimgs[i]=image(hrpg.furn.image[p],36*32+16,93*32+16,1)
					else
						hrpg.shop.dealimgs[i]=image("gfx/weapons/"..string.gsub(hrpg.furniture[p]," ","").."_k.bmp",36*32+16,93*32+16,1)
					end
				elseif i==7 then
					if hrpg.furn.types[p]~=1 then
						hrpg.shop.dealimgs[i]=image(hrpg.furn.image[p],154*32+16,87*32+16,1)
					else
						hrpg.shop.dealimgs[i]=image("gfx/weapons/"..string.gsub(hrpg.furniture[p]," ","").."_k.bmp",154*32+16,87*32+16,1)
					end
					imagepos(hrpg.shop.dealimgs[i],154*32+16,87*32+16,180)
				elseif i==8 then
					if hrpg.furn.types[p]~=1 then
						hrpg.shop.dealimgs[i]=image(hrpg.furn.image[p],154*32+16,93*32+16,1)
					else
						hrpg.shop.dealimgs[i]=image("gfx/weapons/"..string.gsub(hrpg.furniture[p]," ","").."_k.bmp",154*32+16,93*32+16,1)
					end
				end
				if hrpg.furn.sizes[p][1]>1 then
					imagescale(hrpg.shop.dealimgs[i],1/hrpg.furn.sizes[p][1],hrpg.furn.sizes[p][2])
				else
					if hrpg.furn.sizes[p][2]>1 then
						imagescale(hrpg.shop.dealimgs[i],hrpg.furn.sizes[p][1],1/hrpg.furn.sizes[p][2])
					end
				end
				if hrpg.furn.sizes[p][1]==hrpg.furn.sizes[p][2] and hrpg.furn.sizes[p][1]>1 then
					imagescale(hrpg.shop.dealimgs[i],1/hrpg.furn.sizes[p][1],1/hrpg.furn.sizes[p][2])
				end
			end
			hrpg.shop.prices[p]=math.floor(hrpg.shop.prices[p]*hrpg.bargains[b])
			table.remove(tab,1)
			table.insert(tabb,{p,100-(hrpg.bargains[b]*100)})
		end
		local rans={math.random(1,#tabb),math.random(1,#tabb),math.random(1,#tabb)}
		msg("255255255Daily deals: "..hrpg.furniture[tabb[rans[1]][1]].." ("..tabb[rans[1]][2].."% off), "..hrpg.furniture[tabb[rans[2]][1]].." ("..tabb[rans[2]][2].."% off), "..hrpg.furniture[tabb[rans[3]][1]].." ("..tabb[rans[3]][2].."% off), and more!")
		if math.random(1,10)==7 then
			msg("255255255Season offers:")
			num=math.random(1,3)
			for i=1,num do
				local d=math.random(1,#tt)
				b=math.random(1,#hrpg.superbargains)
				p=shops[tt[d]][math.random(1,#shops[tt[d]])]
				for m=1,#hrpg.furniture do	
					if hrpg.furniture[m]==p then
						p=m
						break
					end
				end
				hrpg.shop.prices[p]=math.floor(hrpg.shop.prices[p]*hrpg.superbargains[b])
				msg("255255255"..hrpg.furniture[p].." costs now "..hrpg.shop.prices[p].."$ ("..(100-(hrpg.superbargains[b]*100)).."% off!)")
				table.remove(tab,d)
			end
		end
	end
end

function hrpg.buildattempt(id)
	if id==challenger or id==challenging then
		return 1
	end
	if racer[id]==1 and player(id,"weapontype")~=77 then
		return 1
	end
end

function hrpg.rcon(t)
	if t:find("restart") then
		for i=1,32 do
			if myh[i]~=0 then
				hrpg.house(myh[i],"save")
			end
		end
	elseif t:find("mob_spawn") then
		hrpg.mob.spawn()
		return 2
	elseif t:find("mob_wipe") then
		hrpg.mob.wipe()
		return 2
	elseif t:find("force_day") then
		msg("255255255Daytime has been forced!")
		freetimer("hrpg.cyclereset","tomoon")
		freetimer("hrpg.cyclereset","tosun")
		freetimer("hrpg.shop.restock")
		hrpg.cyclereset("tomoon")
		if #hrpg.mob.id~=0 then
			hrpg.mob.wipe()
		end
		hrpg.shop.restock()
		return 2
	elseif t:find("force_night") then
		msg("255255255Nighttime has been forced!")
		freetimer("hrpg.cyclereset","tomoon")
		freetimer("hrpg.cyclereset","tosun")
		freetimer("hrpg.shop.restock")
		hrpg.cyclereset("tosun")
		hrpg.mob.spawn()
		return 2
	end
end
function hrpg.parse(t)
	if t:find("restart") or t:find("mob_spawn") or t:find("mob_wipe") or t:find("force_day") or t:find("force_night") then
		hrpg.rcon(t)
		if not t:find("restart") then
			return 2
		end
	end
end

function hrpg.trigger(t,s)
	if t=="shop_1" then
		if hrpg.sellstates[1]=="idle" then
			hrpg.sellstates[1]="busy"
			freetimer("hrpg.sellercycle","1,up")
			freetimer("hrpg.sellercycle","1,down")
			tween_move(hrpg.sellers[1],1500,42*32+8,52*32+16,-90)
			tween_move(hrpg.sellershadows[1],1500,42*32+8,52*32+16,-90)
			return 1
		end
	elseif t=="shop_2" then
		if hrpg.sellstates[2]=="idle" then
			hrpg.sellstates[2]="busy"
			freetimer("hrpg.sellercycle","2,up")
			freetimer("hrpg.sellercycle","2,down")
			tween_move(hrpg.sellers[2],1500,148*32+24,52*32+16,90)
			tween_move(hrpg.sellershadows[2],1500,148*32+24,52*32+16,90)
			return 1
		end
	elseif t=="shop_3" then
		if hrpg.sellstates[3]=="idle" then
			hrpg.sellstates[3]="busy"
			freetimer("hrpg.sellercycle","3,up")
			freetimer("hrpg.sellercycle","3,down")
			tween_move(hrpg.sellers[3],1500,42*32+8,90*32+16,-90)
			tween_move(hrpg.sellershadows[3],1500,42*32+8,90*32+16,-90)
			return 1
		end
	elseif t=="shop_4" then
		if hrpg.sellstates[4]=="idle" then
			hrpg.sellstates[4]="busy"
			freetimer("hrpg.sellercycle","4,up")
			freetimer("hrpg.sellercycle","4,down")
			tween_move(hrpg.sellers[4],1500,148*32+24,90*32+16,90)
			tween_move(hrpg.sellershadows[4],1500,148*32+24,90*32+16,90)
			return 1
		end
	end
end

if tonumber(game('sv_gamemode'))==1 then
	hrpg.cyclereset("tomoon")
	hrpg.shop.restock()
else
	parse('sv_gamemode 1')
end

if hrpg.spawnsetting==1 then
	for x,y in pairs(entitylist(19)) do -- Monsters spawn on every Info_BotNode entity, currently broken for some reason
		table.insert(hrpg.mob.spawns,{x,y})
	end
elseif hrpg.spawnsetting==2 then
	for x=1,map("xsize") do
		for y=1,map("ysize") do
			if tile(x,y,"entity") and entity(x,y,"type")==19 then
				table.insert(hrpg.mob.spawns,{x,y})
			end
		end
	end		
elseif hrpg.spawnsetting==3 then
	for x,y in pairs(entitylist()) do -- Monsters spawn on every Info_BotNode entity, currently broken for some reason
		if entity(x,y,"type")==19 then
			table.insert(hrpg.mob.spawns,{x,y})
		end
	end
end

addhook("second","hrpg.second")
addhook("projectile","hrpg.projectile")
addhook("drop","hrpg.drop")
addhook("walkover","hrpg.walkover")
addhook("hit","hrpg.hit")
addhook("movetile","hrpg.movetile")
addhook("serveraction","hrpg.serveraction",-hrpg.priority)
addhook("minute","hrpg.minute")
addhook("menu","hrpg.menu")
addhook("use","hrpg.use")
addhook("leave","hrpg.leave")
addhook("kill","hrpg.kill")
addhook("die","hrpg.die")
addhook("startround","hrpg.startround")
addhook("objectdamage","hrpg.objectdamage")
addhook("say","hrpg.say",hrpg.priority)
addhook("spawn","hrpg.spawn")
addhook("team","hrpg.team")
addhook("log","hrpg.log")
addhook("buildattempt","hrpg.buildattempt")
addhook("attack","hrpg.attack")
addhook("clientdata","hrpg.clientdata")
addhook("rcon","hrpg.rcon")
addhook("parse","hrpg.parse")
addhook("trigger","hrpg.trigger")

-- Want to extend this? Use the files included in the sys/lua/hrpg_settings folder! You can also use the hrpg.house(house,param) function to call different stuff related to houses: (house - HOUSE NUMBER, not player id)
-- hrpg.house(house,"owned") returns the id of the player who owns the house or 0 if nobody does
-- hrpg.house(house,"generate") builds walls around the house, also kills buildings that are already there
-- hrpg.house(house,"save") saves data of the person who owns the house
-- hrpg.house(house,"load") loads data of the person who owns the house (a house is instantly assigned on join when a save file is found)
-- hrpg.house(house,"destroy") destroys all buildings in the house
-- hrpg.house(house,"destroywalls") destroys only boundaries of the house
-- You can use this function in timers, it works properly (ex. timer(100,"hrpg.house","1,generate") )
-- There is also a hrpg.mob.spawn(tilex,tiley) function, which you can use to spawn a random mob in the designated coordinates. ( hrpg.mob.kill(mobid) to make it vanish, hrpg.mob.wipe() to make all mobs vanish )
-- myh - table consisting of house id's of each player
-- Admin scripts? Try to leave at least one serveraction free (specify it in HRPG_Settings/Settings.txt) needed for this